/********************************** (C) COPYRIGHT ******************************
* File Name          : DHCP_CLIENT.C
* Author             : WCH
* Version            : V1.0
* Date               : 2013/11/15
* Description        : CH563NETʾļ
*                      (1)CH563 Examples by KEIL;
*                      (2)0Ϣ,115200bps;
*                      (3)ʾTCP ͨѶƬյݺ󣬻شԶˣARM966,Thumb,С
*******************************************************************************/



/******************************************************************************/
/* ͷļ*/
#include <stdio.h>
#include <string.h>
#include "CH563SFR.H"
#include "SYSFREQ.H"

#include "CH563NET.H"
#include "ISPXT56X.H"

#define CH563NET_DBG                          1

/* ĻȫֱҪ壬е */
__align(16)UINT8    CH563MACRxDesBuf[(RX_QUEUE_ENTRIES )*16];        /* MAC16ֽڶ */
__align(4) UINT8    CH563MACRxBuf[RX_QUEUE_ENTRIES*RX_BUF_SIZE];     /* MACջ4ֽڶ */
__align(4) SOCK_INF SocketInf[CH563NET_MAX_SOCKET_NUM];                 /* SocketϢ4ֽڶ */
const UINT16 MemNum[8] = {CH563NET_NUM_IPRAW,
                         CH563NET_NUM_UDP,
                         CH563NET_NUM_TCP,
                         CH563NET_NUM_TCP_LISTEN,
                         CH563NET_NUM_TCP_SEG,
                         CH563NET_NUM_IP_REASSDATA,
                         CH563NET_NUM_PBUF,
                         CH563NET_NUM_POOL_BUF
                         };
const UINT16 MemSize[8] = {CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_IPRAW_PCB),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_UDP_PCB),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_TCP_PCB),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_TCP_PCB_LISTEN),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_TCP_SEG),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_IP_REASSDATA),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_PBUF) + CH563NET_MEM_ALIGN_SIZE(0),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_PBUF) + CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_POOL_BUF)
                         };
__align(4)UINT8 Memp_Memory[CH563NET_MEMP_SIZE];
__align(4)UINT8 Mem_Heap_Memory[CH563NET_RAM_HEAP_SIZE];
__align(4)UINT8 Mem_ArpTable[CH563NET_RAM_ARP_TABLE_SIZE];

/******************************************************************************/
/* ʾغ */
#define RECE_BUF_LEN                          1072                              /* ջĴС */
/* CH563NETTCPMSSΪ536ֽڣһTCPݲΪ536ֽ */
/* TCPЭջûڽأֵΪsocketĽջȡ趨 */
/* RX_QUEUE_ENTRIESʱҪMSSʹ֮Ĺϵ細ֵΪ4*MSSԶһλᷢ */
/* 4TCPRX_QUEUE_ENTRIESС4ȻᵼݰʧӶͨѶЧʽ */
/* RX_QUEUE_ENTRIESҪ( /MSS ),socketͬʱдݣ */
/* RX_QUEUE_ENTRIESҪ(( /MSS )*socket) ڶsocketͬʱдշʱ */
/* Ϊ˽ԼRAM뽫ջĳΪMSS */

/* CH563ض */
/* CH563ض */
UINT8 MACAddr[6] = {0x02,0x03,0x04,0x05,0x16,0x17};                             /* CH563MACַ */
UINT8 IPAddr[4] = {192,168,1,2};                                                /* CH563IPַ */
UINT8 GWIPAddr[4] = {192,168,1,1};                                              /* CH563 */
UINT8 IPMask[4] = {255,255,255,0};                                              /* CH563 */
UINT8 DESIP[4] = {192,168,1,100};                                               /* ĿIPַ */
UINT16 DESPORT = 1000;                                                          /* ĿĶ˿ */

UINT8 SocketId;                                                                 /* socketԲö */
UINT8 SocketRecvBuf[CH563NET_MAX_SOCKET_NUM][RECE_BUF_LEN];                     /* socketջ */
UINT8 MyBuf[RECE_BUF_LEN];                                                      /* һʱ */

//UINT32 dns_setserver;

/*******************************************************************************
* Function Name  : IRQ_Handler
* Description    : IRQжϷ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
__irq void IRQ_Handler( void )
{
    if(R32_INT_FLAG & 0x8000)                                                   /* ̫ж */
    {                                                                           /* ̫жжϷ */
        CH563NET_ETHIsr();
    }
    if(R32_INT_FLAG & RB_IF_TMR0)                                               /* ʱж */
    {
         CH563NET_TimeIsr(CH563NETTIMEPERIOD);                                  /* ʱжϷ */
         R8_TMR0_INT_FLAG |= 0xff;                                              /* ʱжϱ־ */
   }
}
__irq void FIQ_Handler( void )
{
    while(1);
}

/*******************************************************************************
* Function Name  : SysTimeInit
* Description    : ϵͳʱʼCH563@100MHZ TIME0 10msCH563NETTIMEPERIOD
*                ʼʱ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void SysTimeInit(void)
{
    R8_TMR0_CTRL_MOD = RB_TMR_ALL_CLEAR;
    R32_TMR0_COUNT = 0x00000000; 
    R32_TMR0_CNT_END = 0x186a0 * CH563NETTIMEPERIOD;                            /* Ϊ10MSʱ */
    R8_TMR0_INTER_EN |= RB_TMR_IE_CYC_END;
    R8_TMR0_CTRL_MOD = RB_TMR_COUNT_EN;
}

/*******************************************************************************
* Function Name  : InitSysHal
* Description    : ӲʼTIM0ETHж
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void InitSysHal(void)
{
    R8_INT_EN_IRQ_0 |= RB_IE_IRQ_TMR0;                                          /* TIM0ж */
    R8_INT_EN_IRQ_1 |= RB_IE_IRQ_ETH;                                           /* ETHж */
    R8_INT_EN_IRQ_GLOB |= RB_IE_IRQ_GLOB;                                       /* IRQȫж */
}

/*******************************************************************************
* Function Name  : mStopIfError
* Description    : ʹãʾ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void mStopIfError(UINT8 iError)
{
    if (iError == CH563NET_ERR_SUCCESS) return;                                 /* ɹ */
#if CH563NET_DBG
    printf("Error: %02X\n", (UINT16)iError);                                    /* ʾ */
#endif    
}

/*******************************************************************************
* Function Name  : CH563NET_LibInit
* Description    : ʼ
* Input          : ip      ipַָ
*                gwip    ipַָ
*                 : mask    ָ
*                 : macaddr MACַָ 
* Output         : None
* Return         : ִ״̬
*******************************************************************************/
UINT8 CH563NET_LibInit(const UINT8 *ip,const UINT8 *gwip,const UINT8 *mask,const UINT8 *macaddr)
{
    UINT8 i;
    struct _CH563_CFG cfg;
    if(CH563NET_GetVer() != CH563NET_LIB_VER)return 0xfc;             /* ȡİ汾ţǷͷļһ */
    CH563NETConfig = LIB_CFG_VALUE;                                      /* Ϣݸñ */
    cfg.RxBufSize = RX_BUF_SIZE; 
    cfg.TCPMss   = CH563NET_TCP_MSS;
    cfg.HeapSize = CH563_MEM_HEAP_SIZE;
    cfg.ARPTableNum = CH563NET_NUM_ARP_TABLE;
    cfg.MiscConfig0 = CH563NET_MISC_CONFIG0;
    CH563NET_ConfigLIB(&cfg);
    i = CH563NET_Init(ip,gwip,mask,macaddr);
    return (i);                      /* ʼ */
}

/*******************************************************************************
* Function Name  : CH563NET_HandleSockInt
* Description    : socketжϴ
* Input          : sockeid  socket
*                initstat ж״̬
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET_HandleSockInt(UINT8 sockeid,UINT8 initstat)
{
    UINT32 len;
    UINT32 totallen;
    UINT8 *p = MyBuf,i;

    if(initstat & SINT_STAT_RECV)                                               /* ж */
    {
        len = CH563NET_SocketRecvLen(sockeid,NULL);                             /* ѯ */
#if CH563NET_DBG
        printf("Receive Len = %02x\n",len);                           
#endif
        totallen = len;
        CH563NET_SocketRecv(sockeid,MyBuf,&len);                                /* ջݶMyBuf*/
        while(1)
        {
           len = totallen;
           CH563NET_SocketSend(sockeid,p,&len);                                 /* MyBufеݷ */
           totallen -= len;                                                     /* ܳȼȥԼϵĳ */
           p += len;                                                            /* ָƫ*/
           if(totallen)continue;                                                /* δϣ*/
           break;                                                               /* ϣ˳ */
        }
    }
    if(initstat & SINT_STAT_CONNECT)                                            /* TCPж */
    {
#if CH563NET_DBG                                                                /* жϱʾTCPѾӣԽշ */
        printf("TCP Connect Success\n");                           
#endif
        /* CH563NET_ModifyRecvBuf                                       */
        /* TCP SERVERģʽ£⵽TCPӣCH563NETԶΪ      */
        /* ӷһsocketϢsocketûзջ     */
        /* TCP Serverģʽ£һյжϺӦòӦ   */
        /* CH563NET_ModifyRecvBufΪsocketһ               */
        /* CH563NET_ModifyRecvBufþΪsocket仺ģʽ */
        /* ͬʹãҪ˫ʱʱ޸Ľջĵַͳ */
        /* TCP Serverģʽ£ͻ˵Ӷsocket     */
        /* пеϢбӺϷͻӣReset    */

        CH563NET_ModifyRecvBuf(sockeid,(UINT32)SocketRecvBuf[sockeid],RECE_BUF_LEN);  
         i = CH563NET_SetSocketTTL( sockeid,10 );
#if CH563NET_DBG                                                                /* жϣCH563NETڲὫsocketΪر*/
        printf("CH563NET_SetSocketTTL:%d\n",(UINT16)i);
 #endif

    }
    if(initstat & SINT_STAT_DISCONNECT)                                         /* TCPϿж */
    {
#if CH563NET_DBG                                                                /* жϣCH563NETڲὫsocketΪر*/
        printf("TCP Disconnect\n");                                             /* Ӧ´ */
#endif

    }
    if(initstat & SINT_STAT_TIM_OUT)                                            /* TCPʱж */
    {
#if CH563NET_DBG                                                                /* жϣCH563NETڲὫsocketΪر*/
        printf("TCP Timout\n");                                                 /* Ӧ´ */
#endif
    }
}

/*******************************************************************************
* Function Name  : CH563NET_HandleGloableInt
* Description    : ȫжϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET_HandleGlobalInt(void)
{
    UINT8 initstat;
    UINT8 i;
    UINT8 socketinit;
    
    initstat = CH563NET_GetGlobalInt();                                         /* ȫж״̬ */
    if(initstat & GINT_STAT_UNREACH)                                            /* ɴж */
    {
    }
    if(initstat & GINT_STAT_IP_CONFLI)                                          /* IPͻж */
    {
    }
    if(initstat & GINT_STAT_PHY_CHANGE)                                         /* PHYıж */
    {
        i = CH563NET_GetPHYStatus();                                            /* ȡPHY״̬ */
#if CH563NET_DBG
        printf("GINT_STAT_PHY_CHANGE %02x\n",i);
#endif   
    }
    if(initstat & GINT_STAT_SOCKET)                                             /* Socketж */
    {
       for(i = 0; i < CH563NET_MAX_SOCKET_NUM; i ++)                     
       {
           socketinit = CH563NET_GetSocketInt(i);                               /* socketжϲ */
           if(socketinit)CH563NET_HandleSockInt(i,socketinit);                  /* ж */
       }    
    }
}

/*******************************************************************************
* Function Name  : CH563NET_CreatTcpSocket
* Description    : TCP Server scoket
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
/*******************************************************************************
* Function Name  : CH563NET_CreatTcpSocket
* Description    : TCP Client socket
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET_CreatTcpSocket(void)
{
   UINT8 i;                                                             
   SOCK_INF TmpSocketInf;                                                       /* ʱsocket */

   memset((void *)&TmpSocketInf,0,sizeof(SOCK_INF));                            /* ڲὫ˱ƣýʱȫ */
   memcpy((void *)TmpSocketInf.IPAddr,DESIP,4);                                 /* ĿIPַ */
   TmpSocketInf.DesPort = DESPORT;                                              /* ĿĶ˿ */
   TmpSocketInf.SourPort = 2000;                                                /* Դ˿ */
   TmpSocketInf.ProtoType = PROTO_TYPE_TCP;                                     /* socekt */
   TmpSocketInf.RecvStartPoint = (UINT32)SocketRecvBuf;                         /* ýջĽջ */
   TmpSocketInf.RecvBufLen = RECE_BUF_LEN ;                                     /* ýջĽճ */
   i = CH563NET_SocketCreat(&SocketId,&TmpSocketInf);                           /* socketصsocketSocketId */
   mStopIfError(i);                                                             /*  */
   i = CH563NET_SocketConnect(SocketId);                                        /* TCP */
   mStopIfError(i);                                                             /*  */
   i = CH563NET_SetSocketTTL( SocketId,10 );
   mStopIfError(i);                                                             /*  */
}

/*******************************************************************************
* Function Name  : mInitSTDIO
* Description    : Ϊprintfgetkeyʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void mInitSTDIO( void )
{
    UINT32    x, x2;

    x = 10 * FREQ_SYS * 2 / 16 / 115200;                                        /* 115200bps */
    x2 = x % 10;
    x /= 10;
    if ( x2 >= 5 ) x ++;                                                        /*  */
    R8_UART0_LCR = 0x80;                                                        /* DLABλ1 */
    R8_UART0_DIV = 1;                                                           /* ԤƵ */
    R8_UART0_DLM = x>>8;
    R8_UART0_DLL = x&0xff;

    R8_UART0_LCR = RB_LCR_WORD_SZ ;                                             /* ֽڳΪ8 */
    R8_UART0_FCR = RB_FCR_FIFO_TRIG|RB_FCR_TX_FIFO_CLR|RB_FCR_RX_FIFO_CLR |    
                   RB_FCR_FIFO_EN ;                                             /* FIFOΪ14巢ͺͽFIFOFIFOʹ */
    R8_UART0_IER = RB_IER_TXD_EN;                                               /* TXD enable */
    R32_PB_SMT |= RXD0|TXD0;                                                    /* RXD0 schmitt input, TXD0 slow rate */
    R32_PB_PD &= ~ RXD0;                                                        /* disable pulldown for RXD0, keep pullup */
    R32_PB_DIR |= TXD0;                                                         /* TXD1 output enable */
}

/*******************************************************************************
* Function Name  : fputc
* Description    : ͨϢ
* Input          : c-- writes the character specified by c 
*                  *f--the output stream pointed to by *f
* Output         : None
* Return         : None
*******************************************************************************/
int fputc( int c, FILE *f )
{
    R8_UART0_THR = c;                                                           /*  */
    while( ( R8_UART0_LSR & RB_LSR_TX_FIFO_EMP ) == 0 );                        /* ȴݷ */
    return( c );
}

/*******************************************************************************
* Function Name  : CH563NET_DHCPCallBack
* Description    : DHCP
* Input          : None
* Output         : None
* Return         : ִ״̬
*******************************************************************************/
UINT8 CH563NET_DHCPCallBack(UINT8 status,void *arg)
{
   UINT8 *p;
   
   if(!status){                                                                 /* ɹ*/
       p = arg;
#if CH563NET_DBG                                                                /* жϣCH563NETڲὫsocketΪر*/
       printf("DHCP Success\n");
#endif
       memcpy(IPAddr,p,4);
       memcpy(GWIPAddr,&p[4],4);
       memcpy(IPMask,&p[8],4);
#if CH563NET_DBG                                                                /* жϣCH563NETڲὫsocketΪر*/
       printf("IPAddr = %d.%d.%d.%d \n",(UINT16)IPAddr[0],(UINT16)IPAddr[1],
              (UINT16)IPAddr[2],(UINT16)IPAddr[3]);
       printf("GWIPAddr = %d.%d.%d.%d \n",(UINT16)GWIPAddr[0],(UINT16)GWIPAddr[1],
              (UINT16)GWIPAddr[2],(UINT16)GWIPAddr[3]);
       printf("IPAddr = %d.%d.%d.%d \n",(UINT16)IPMask[0],(UINT16)IPMask[1],
              (UINT16)IPMask[2],(UINT16)IPMask[3]);
       printf("DNS1: %d.%d.%d.%d\n",p[12],p[13],p[14],p[15]);
       printf("DNS2: %d.%d.%d.%d\n",p[16],p[17],p[18],p[19]);
#endif 
       CH563NET_CreatTcpSocket();                                               /* TCP Socket */
   }
   else{
#if CH563NET_DBG                                                                /* жϣCH563NETڲὫsocketΪر*/
      printf("DHCP Fail %02x\n",status);
#endif 
   }                                                          
   return 0;
}

/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
int main( void ) 
{

    UINT8 i;

    mInitSTDIO( );                                                              /* Ϊüͨڼʾ */
    i = CH563NET_GetVer();
#if CH563NET_DBG                                                                /* жϣCH563NETڲὫsocketΪر*/
    printf("NET_VER == %2x\n",(UINT16)i);
#endif 
    i = CH56X_GetMac(MACAddr);
    i = CH563NET_LibInit(IPAddr,GWIPAddr,IPMask,MACAddr);                       /* ʼ */
#if CH563NET_DBG                                                                /* жϣCH563NETڲὫsocketΪر*/
    printf("Lib init success!\n");
#endif 
    if(!i){
        CH563NET_DHCPStart(CH563NET_DHCPCallBack);                              /* DHCP */
    }
    SysTimeInit();                                                              /* ϵͳʱʼ */
    InitSysHal();                                                               /* ʼж */
    while(1){
        CH563NET_MainTask();                                                    /* CH563NETҪѭвϵ */
        if(CH563NET_QueryGlobalInt())CH563NET_HandleGlobalInt();                /* ѯжϣжϣȫжϴ */
    }
}

/*********************************** endfile **********************************/
