/********************************** (C) COPYRIGHT *********************************
* File Name          : FTPINC.H
* Author             : WCH
* Version            : V1.0
* Date               : 2013/11/15
* Description        : Define for CH563FTP.c
**********************************************************************************/



/*********************************************************************************/
#ifndef _FTPINC_H_
#define _FTPINC_H_



#ifndef Access_Authflag
#define Access_Authflag                0            /* ָûʣû޷ʷ*/
#endif
typedef struct _FTP
{
    UINT8 TimeCount;                   // ʱ
    UINT8 FileFlag;                    // жļȴ64ֽڱ־λ֧ϴļ64
    UINT8 BufStatus;                   // ־λ0-3λֱӦĸ״̬0Ϊ1Ϊʹã
    UINT8 AuthFlag;                    // ûȨޱ־λ
    UINT8 ListFlag;                    // 
    UINT8 CmdDataS;                    // ݴ״̬
    UINT8 DataOver;                    // ݶȡ
    UINT8 ListState;                   // 0ΪǰĿ¼ 1ΪһĿ¼
    UINT8 TcpCtlSta;                   // TCP״̬
    UINT8 TcpDatSta;                   // TCP״̬
    UINT8 CmdReceDatS;                 // ״̬
    UINT8 SocketCtlMonitor;            // ftpӣsocket
    UINT8 SocketCtlConnect;            // ftpӣsocket
    UINT8 SocketCtlSecond;             // ftpӣsocket
    UINT8 SocketDatMonitor;            // ftpӣsocket
    UINT8 SocketDatConnect;            // ftpӣsocket
}FTP;
extern FTP ftp;
extern     char  UserName[16];         // ڱû
extern     char  SourIP[17];           // ڱתַIPַ
#if Access_Authflag
extern     char  *pUserName;           // Էʷûû޷ʷ
#endif
extern     char  *pPassWord;           // Ȩ޵루ֶֻ֧
/* CH563ض */                                                                   
extern UINT8 MACAddr[6];                         // CH563MACַ 
extern const UINT8 IPAddr[4];                    // CH563IPַ 
extern const UINT8 GWIPAddr[4];                  // CH563 
extern const UINT8 IPMask[4];                    // CH563 
/* TCP״̬ */
#define FTP_MACH_DISCONT             0x01        // TCPδ
#define FTP_MACH_CONNECT             0x02        // TCP
#define FTP_MACH_KEPCONT             0x04        // TCP
/*  ݴ״̬ */
#define FTP_MACH_SENDDATA            0x01        // Ҫ
#define FTP_MACH_RECEDATA            0x02        // Ҫ
#define FTP_MACH_DATAOVER            0x04        // ݴ
#define FTP_MACH_CLOSECTL            0x08        // 
/*    */
#define FTP_MACH_LIST                0x00        // ȡб
#define FTP_MACH_FILE                0x01        // ļ
//==============================================================================
void  CH563NET_FTPSendData( char *PSend, UINT32 Len,UINT8 index  );             // 
     
void  CH563NET_FTPConnect( void );                                              // 563ʼ

void  CH563NET_FTPInitVari( void );                                             // ʼ

void  mInitFtpList( void );                                                     // ʼģļĿ¼ϢԼļ 

void CH563NET_FTPListRenew( UINT8 index );                                      // Ŀ¼
                                  
void CH563NET_FTPHandleDatRece( char *recv_buff,UINT8 index );                  // յ

void CH563NET_FTPCmdRespond( char *recv_buff );                                 // յӦĻظ 

void CH563NET_FTPDataReady( char *pSendDat );                                   // ׼Ҫ͵

void CH563NET_FTPGetPortNum( char *recv_buff );                                 // ȡӵĶ˿

void CH563NET_FTPGetFileName( char *recv_buff,char *pBuf );                     // ȡ 

UINT8 CH563NET_FTPFileOpen(  char *pName,UINT8 index  );                        // ļ

UINT32 CH563NET_FTPFileSize ( char *pName );                                    // ȡļ

void CH563NET_FTPFileRead( char *pName );                                       // ļ

void CH563NET_FTPFileWrite( char *recv_buff, UINT16 LEN );                      // дļ

void CH563NET_FTPCtlServer(void);                                               // FTP

void CH563NET_FTPClientDat(  UINT16 port,UINT8 *pAddr );                        // FTP
                                                      
void CH563NET_FTPServerDat( UINT16 *port );                                     // FTP

void CH563NET_FTPGetSockeID( UINT8 socketid  );                                 // ȡsocket

void CH563NET_FTPServerCmd( void );                                             // ѯ״ִ̬Ӧӳ

void mStopIfError(UINT8 iError);

void CH563NET_HandleGloableInt( void );

#endif    // __ftpinc_H__
 //================================================================================ 
