/********************************** (C) COPYRIGHT *********************************
* File Name          : MAILINC.H
* Author             : WCH
* Version            : V1.0
* Date               : 2013/11/15
* Description        : Define for MAIL.C
**********************************************************************************/
#ifndef __MAILINC_H__
#define __MAILINC_H__
//================================================================================
extern  UINT8 OrderType;                         //    
extern  UINT8 CheckType;        
extern  UINT8 ReceDatFlag;                       //    յݱ־λ
extern  UINT16 ReceLen;    
//=================================================================================
#define attach_max_len           512             // ͸󳤶ȣĬΪ512   
#define POP3_SERVER_PORT         110             // ʼĿĶ˵
#define SMTP_SERVER_PORT         25              // ʼĿĶ˵
#define DEBUG                    1               //     -- 115200
typedef struct
{
    UINT8 Socket;                
    UINT8 g_MIME;                                 // ޸־λ
    char  m_strFile[48];                          // 
    char  m_strSendFrom[48];                      // ˵ַ
    char  m_strSendTo[48];                        // ռ˵ַ
    char  m_strSMTPServer[32];                    // 
    char  m_strUSERID[32];                        // û
    char  m_strPASSWD[32];                        // 
    char  m_strSubject[32];                       // 
    char  m_strSenderName[32];                    // 
}SMTP;
typedef struct
{
    UINT8 Socket;                
    UINT8 EncodeType;                             // ʼʹõı뷽ʽ
    UINT8 AnalyMailDat;                           // ʼ־λ
    UINT8 identitycheck;                          // ֤ݱ־λ
    UINT8 RefreshTime;                            // ûѲ鵽ʼ־λ
    UINT8 DiscnntFlag;
    UINT8 ReceFlag;
    char  sBufTime[40];                           // ʼʱ
    char  Ccname[48];                             // ͵
    char  DecodeRName[32];                        // յʼķ
    char  pPop3Server[32];                        // POP
    char  pPop3UserName[32];                      // POP½û
    char  pPop3PassWd[32];                        // POP½
}POP;
/* smtpʼز */
extern const char *m_Server;                      // 
extern const char *m_UserName;                    // û
extern const char *m_PassWord;                    // 
extern const char *m_SendFrom;                    // ˵ַ
extern const char *m_SendName;                    // 
extern const char *m_SendTo;                      // ռ˵ַ
extern const char *m_Subject;                     // 
extern const char *m_FileName;                    // (͸,Ϊ"\0")
/* popʼ */
extern const char *p_Server;                      // POP
extern const char *p_UserName;                    // POP½û
extern const char *p_PassWord;                    // POP½
/* CH563ض */                                                                   
extern UINT8 MACAddr[6];                          // CH563MACַ 
extern const UINT8 IPAddr[4];                     // CH563IPַ 
extern const UINT8 GWIPAddr[4];                   // CH563 
extern const UINT8 IPMask[4];                     // CH563 
/* socketsmtp ض,SMTPʼ    */                                          
extern const UINT8  SocketsmtpIP[4];              // Socket smtpĿIPַ 
extern const UINT16  SmtpSourPrt;                 // Socket smtpԴ˿ں

/* socketpop3 ض, POPʼ*/                                              
extern const UINT8  Socketpop3IP[4];              // Socket pop3ĿIPַ
extern const UINT16  Pop3SourPrt;                 // Socket pop3Դ˿ں
/* ********************************************************************************************************************
*  
*
*  1  ֻʼɺ˳½رsocketӣ
*  2  ֻʼɡȡʼб˳½رsocketӣ
*  3  ֻʼɡȡʼɾ˳½رsocketӣ
*  4  ʼҽʼɺʼʼɺ˳½; 
*  5  ʼҽʼɺظʼɺ˳½ɾʼ˳ʼ½  
*  ˵˴뷢õsocketӣ
*         ĲegգͲ
*                                     ֻmail.cеCheck_Response
*                                     ӳнɺ󣬽Ϊ SMTP_SEND_START
***********************************************************************************************************************/
#ifndef    mail_work_mode
    #define  mail_work_mode             5         
#endif
#if   (mail_work_mode == 1)                                 
    #define send_mail                   1         // ʼ    
    #define    send_over_quit           1         // ˳
#elif (mail_work_mode == 2)                                 
    #define receive_mail                1         // ʼ
    #define    receive_over_quit        1         // ȡʼ˳
#elif (mail_work_mode == 3)                                 
    #define receive_mail                1         // ʼ
    #define    receive_dele_quit        1         // ʼɾ˳
#elif (mail_work_mode == 4)                                 
    #define send_mail                   1         // ʼ
    #define send_over_receive           1         // 
    #define receive_mail                0         // ʼ
    #define receive_over_quit           1         // ȡʼ˳
#elif (mail_work_mode == 5)                                
    #define receive_mail                1         // ʼ
    #define receive_over_reply          1         // ȡʼظʼ
    //#define send_mail                   0         // ʼ
	#define send_mail                   1         // ʼ
    #define    send_over_quit           1         // ˳
#endif
/************************************************************************************************************************
* POPѡ
************************************************************************************************************************/
#ifdef receive_mail 
    #define POP_RTER        1                     // 1 serverʼȫı
    #define POP_DELE        1                     // 2 ɾ
//    #define POP_RSET      1                     // 3 еDELE
//    #define POP_TOP       1                     // 4 nʼǰm
//    #define POP_UIDL      1                     // 5 serverڸָʼΨһʶûָеġ
    #define POP_REFRESH     1                     // ʼûյʼѯ־ 
#endif

#define g_strBoundary    "18ac0781-9ae4-4a2a-b5f7-5479635efb6b"                      /* ߽ */
#define g_strEncode      "base64"                                                    /* 뷽ʽ */
#define g_strcharset     "gb2312"                                                    /* windowsʽ (linuxʽ"utf-8") */
#define g_xMailer        "X-Mailer: X-WCH-Mail Client Sender\r\n"                    /* X-Mailer     */
#define g_Encoding       "Content-Transfer-Encoding: quoted-printable\r\nReply-To: " /* Encoding  */
#define g_Custom         "X-Program: CSMTPMessageTester"                             /* X-Programͬ޸ */
#define g_FormatMail     "This is a multi-part message in MIME format."              /* ʼжݣһи */
#define g_AttachHead     "\r\nContent-Transfer-Encoding: quoted-printable\r\n" 
#define g_AttachHedType  "text/plain"
#define g_MailHedType    "multipart/mixed"

/************************************************************************************************************************
*  
* 0x01-0x0f Ϊʼ
****************** 0x01-0x07 Ϊ
****************** 0x09-0x0e ΪPѡ
****************** 0x01-0x02-0x03-0x06 Ϊȷ״̬
****************** 0x04-0x05 0x09-0x0e Ϊ״̬
* 0x10-0x1f Ϊʼ
****************** 0x10-0x17 谴˳ִ
****************** Ϊѡ
* 0x00         κβ
************************************************************************************************************************/
#define COMMAND_UNUSEFULL       0x00
//POP RECEIVE CODE
#define POP_RECEIVE_USER        0x01    // ֤û
#define POP_RECEIVE_PASS        0x02    // ֤
#define POP_RECEIVE_STAT        0x03    // ͳ
#define POP_RECEIVE_LIST        0x04    // ָʼĴС
#define POP_RECEIVE_RTER        0x05    // ȡʼȫı
#define POP_RECEIVE_QUIT        0x06    // ˳½
#define POP_CLOSE_SOCKET        0x07    // رpopsocket
#define POP_RECEIVE_START       0x08    // ʼ
#define POP_RECEIVE_DELE        0x09    // ɾ
#define POP_RECEIVE_RSET        0x0a    // еDELE
#define POP_RECEIVE_TOP         0x0b    // nʼǰmݣmȻ
#define POP_RECEIVE_UIDL        0x0e    // ڸָʼΨһʶ
#define POP_ERR_CHECK           0x0F    // POPֳ˳½رsocket
//SMTP SEND CODE
#define SMTP_SEND_HELO          0x10    // hello
#define SMTP_SEND_AUTH          0x11    // ͵½
#define SMTP_SEND_USER          0x12    // û
#define SMTP_SEND_PASS          0x13    // 
#define SMTP_SEND_MAIL          0x14    // ͷߵַ
#define SMTP_SEND_RCPT          0x15    // ͽߵַ
#define SMTP_SEND_DATA          0x16    // ͷ
#define SMTP_DATA_OVER          0x17    // ʼ
#define SMTP_SEND_QUIT          0x18    // ˳½
#define SMTP_CLOSE_SOCKET       0x19    // رsmtpsocket
#define SMTP_SEND_START         0x1E    // ʼ
#define SMTP_ERR_CHECK          0x1F    // smtpֳ˳½رsocket
/* *********************************************************************************************************************
* źź˶Դ
************************************************************************************************************************/
//POP ERR CHECK CODE
#define POP_ERR_CNNT            0x20     // popӴ--------------Ƕ˿ںţIPô
#define POP_ERR_USER            0x21     // ֤û-------ûʽԣUSER鿴͵˶Ƿȷͬ
#define POP_ERR_PASS            0x22     // ½ʧ-----------------û󣬻PASS
#define POP_ERR_STAT            0x23     // ȡʼϢ---------STATʧµ½绹ʧܼ
#define POP_ERR_LIST            0x24     // ȡʼϢб---------LIST
#define POP_ERR_RETR            0x25     // ȡָʼϢ---ȡʼڣRETR󣬻Ĳȷ
#define POP_ERR_DELE            0x26     // ɾĳʼʧ---------ɾʼڣRETR󣬻Ĳȷ
#define POP_ERR_QUIT            0x59     // ˳½ʧ-------------QUIT
#define POP_ERR_RSET            0x28     // ָɾʼ-----------RSET˳֮ǰִвЧ
#define POP_ERR_TOP             0x2B     // ȡĳʼǰmʧ----ȡʼڣRETR󣬻Ĳȷ
#define POP_ERR_UIDL            0x2C     // ȡĳʼIDʧ-------ʼڣUIDL󣬻Ĳȷ
#define POP_ERR_UNKW            0x2F     // popδ֪--------------δ֪
//SMTP ERR CHECK CODE
#define SMTP_ERR_CNNT           0x31     // smtpӴ-------------Ƕ˿ںţIPô
#define SMTP_ERR_HELO           0x32     // heloʧ---------HELO󣬻ʽ
#define SMTP_ERR_AUTH           0x33     // ½ʧ---------AUTH
#define SMTP_ERR_USER           0x34     // ûδʶ---------ûʽԣUSER
#define SMTP_ERR_PASS           0x35     // ½ʧ-----------------û󣬻PASS
#define SMTP_ERR_MAIL           0x36     // ˵ַʧ-------˵ַȷMAIL
#define SMTP_ERR_RCPT           0x37     // ͽյַ---------ռ˵ַȷRCPT
#define SMTP_ERR_DATA           0x38     // -------------DATA
#define SMTP_ERR_DATA_END       0x39     // ݹ̳
#define SMTP_ERR_QUIT           0x3A     //    ˳½ʧ
#define    SMTP_ERR_UNKNOW      0x3F     // smtpδ֪
//
#define send_data_timeout       0x10     // ݳʱ
#define send_data_success       0x14     // ݳʱ
/*******************************************************************************
*  
*******************************************************************************/
//POP3  CODE
#define OPEN_SOCKET_RECEIVE       0xA0    // 򿪽socket
#define LOGIN_MAILBOX_RECEIVE     0xA1    // ½
#define READ_MAIL_STAT            0xA2    // ȡʼб
#define READ_MAIL_LIST            0xA3    // ȡʼб
#define READ_MAIL_MAILBODYDATA    0xA4    // ȡʼ
#define READ_MAIL_ATTACHMENT      0xA5    // ȡʼ
#define READ_MAIL_ADDRESS         0xA6    // ȡ˵ַ
#define READ_MAIL_TIME            0xA7    // ȡʱ
#define READ_MAIL_SUBJECT         0xA8    // ȡʼ
#define QUIT_RECEIVE_MAIL         0xA9    // ˳½رsocket
//SMTP  CODE
#define OPEN_SOCKET_SEND          0xB0    // 򿪷socket
#define LOGIN_MAILBOX_SEND        0xB1    // ½
#define SEND_MAIL_UNATTACH        0xB2    // ʼ
#define SEND_MAIL_CONTATTACH      0xB3    // ʼ
#define QUIT_SEND_MAIL            0xB4    // ˳½رsocket
/*******************************************************************************
* ˶ϢĴ 
* ɹCHECK_SUCCESSΪһ
* 󷵻ضӦĴ 
* źţҪ˶
*******************************************************************************/
#define CHECK_SUCCESS             0x00
#define uncheck                   0x00
//POP CHECK CODE
// ӦϢȷء+0k 󷵻ء-ERR
#define POP_CHECK_CNNT            0x50    
#define POP_CHECK_USER            0x51    
#define POP_CHECK_PASS            0x52    
#define POP_CHECK_STAT            0x53
#define POP_CHECK_LIST            0x54    
#define POP_CHECK_RETR            0x55
#define POP_CHECK_DELE            0x56
#define POP_CHECK_SEAR            0x57
#define POP_CHECK_QUIT            0x58
#define POP_CHECK_RSET            0x59
#define POP_CHECK_APOP            0x5A
#define POP_CHECK_TOP             0x5B
#define POP_CHECK_UIDL            0x5C
//SMTP CHECK CODE
#define SMTP_CHECK_CNNT           0x60
#define SMTP_CHECK_HELO           0x61
#define SMTP_CHECK_AUTH           0x62
#define SMTP_CHECK_USER           0x63
#define SMTP_CHECK_PASS           0x64
#define SMTP_CHECK_MAIL           0x65
#define SMTP_CHECK_RCPT           0x66
#define SMTP_CHECK_DATA           0x67
#define SMTP_CHECK_DATA_END       0x68
#define SMTP_CHECK_QUIT           0x69
/******************************************************************************/
void CH563NET_SendData( char *PSend, UINT32 Len,UINT8 type,UINT8 index  );      /*  */

void CH563NET_MAILInit(void);                                                   /* 563ʼ */

void CH563NET_POP3Init( void );                                                 /* ʼʼ */

void CH563NET_SMTPInit( void );                                                 /* ʼʼ */

void CH563NET_MailCmd( UINT8 choiceorder);                                      /* ִжӦԶշ */

void CH563NET_POP3Retr( UINT8 num );                                            /* ȡĳʼ */

void CH563NET_POP3Dele( UINT8 num );                                            /* ɾĳʼ */

void CH563NET_POP3Rset( void );                                                 /* еɾ */

void CH563NET_POP3Top( UINT8 num ,UINT8 m  );                                   /* ȡĳʼǰm */

void CH563NET_POP3Uidl( UINT8 num );                                            /* ȡĳʼID */

UINT8 CH563NET_CheckResponse( char *recv_buff,UINT8 check_type );               /* ӦϢ */

void CH563NET_Quit(UINT8 index );                                               /* ˳½ */

void CH563NET_CreatTcpPop3( void );                                             /* pop3 */

void CH563NET_CreatTcpSmtp( void );                                             /* smtp */

void CH563NET_ReplyMailBody( void );                                            /* ظʼ */

void CH563NET_MailQuery( void );

void mStopIfError(UINT8 iError);

void CH563NET_HandleGloableInt( void );

//================================================================================
#endif
