/********************************** (C) COPYRIGHT ******************************
* File Name          : CH563.C
* Author             : WCH
* Version            : V1.0
* Date               : 2013/11/15
* Description        : CH563粿ֳʼMACշӿں
*******************************************************************************/



/******************************************************************************/
/* ļ */
#include <stdio.h>
#include <string.h>
#include "CH563SFR.H"
#include "SYSFREQ.H"
#include "NETSFR.H"
#include "NETMAC.H"

/******************************************************************************/
/* ȫֱ */
ETHERHEAD    ETH;                                                               /* macͷ */
ARPPACKAGE   ARP;                                                               /* arpݰ */
MACCtrl      mac_cotrl;                                                         /* CH563MACƽṹ */
struct  _RXBUFST    RxCtrl;                                                     /* RXտϢ */
struct  _TXBUFST    TxCtrl;                                                     /* TXտϢ */
UINT8V  SendSuc;                                                                /* ݰ ɹ־ */
UINT8V  PHYStatus;                                                              /* PHY״̬ */

/*******************************************************************************
* Function Name  : PHY_ReadData
* Description    : PHYȡݣݿΪ16λ
* Input          : regad PHYĴַ 
* Output         : None
* Return         : None
*******************************************************************************/
UINT16 PHY_ReadData(UINT16 regad)
{
    R32_ETHE_PHYCR = RB_PHYAD(FTPHY_RB_PHYAD) | RB_REGAD(regad) | RB_MIIRD;     /* PHYƼĴдPHYַPHYĴַԼͶź*/
    Delay_us(100);
    while( R32_ETHE_PHYCR & RB_MIIRD );                                         /* ȴ */
    return( (UINT16)(R32_ETHE_PHYCR & RB_MIIRDATA) );
}

/*******************************************************************************
* Function Name  : CH563PHY_Process
* Description    : PHYЭ̽MACCRĴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH563PHY_Process(void)
{
    UINT16 value;

    value = PHY_ReadData(FTPHY_REG_STATUS);
    if( (value&RB_LINK_STATUS)==0 ){
    }
    if( (value&RB_AUTO_NEG_CMP)==0 ){
    }
    value = PHY_ReadData(FTPHY_REG_CONTROL);
    if((value & RB_DUPLEX_MODE) > 0){
        R32_ETHE_MACCR |= RB_FULLDUP;
    }
    else{
        R32_ETHE_MACCR &= ~(RB_FULLDUP);
    }
    if((value & RB_SPEED_SEL) > 0){
        R32_ETHE_MACCR |= RB_SPEED_100;
    }
    else{
        R32_ETHE_MACCR &= ~(RB_SPEED_100);
    }
}

/*******************************************************************************
* Function Name  : CH563MAC_ParamInit
* Description    : ʼʼȫֱ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH563MAC_ParamInit(void)
{
    memset((void *)&TxCtrl,0,sizeof(TxCtrl));
    memset((void *)&RxCtrl,0,sizeof(RxCtrl));
    RxCtrl.RxDMAEnable = TRUE;
}

/*******************************************************************************
* Function Name  : MAC_InitTXDes
* Description    : ʼ16ֽڶ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void MAC_InitTXDes(void)
{

    UINT32 i;
    mac_txdes *tmp;

    mac_cotrl.txdes_top = (mac_txdes *)TxDesBuf;                                /* ָͷ */
    mac_cotrl.txdes_cur = mac_cotrl.txdes_top;                                  /* ǰָͷ*/
    mac_cotrl.txdes_end = mac_cotrl.txdes_top + (TX_QUEUE_NUM - 1);             /* һָ򻺳β*/
    memset(mac_cotrl.txdes_top, 0,sizeof(TxDesBuf));                            /* շ */
    mac_cotrl.txdes_end->txdes1 |= TXDES1_EDOTR;                                /* һΪ־ */
    mac_cotrl.txdes_cur->txdes2 |= (UINT32)MACTxBuf[TxCtrl.SendIndex];          /* ͻĻַ */
    MACSendbuf = (UINT8 *)&MACTxBuf[TxCtrl.SendIndex][14];
    tmp = mac_cotrl.txdes_top;
    for(i = 0; i < TX_QUEUE_NUM; i++){                                          /*  */
        tmp->txdes3 = (UINT32)(tmp + 1);
        tmp = (mac_txdes *)tmp->txdes3;
    }
    mac_cotrl.txdes_end->txdes3 = (UINT32)mac_cotrl.txdes_top;
}

/*******************************************************************************
* Function Name  : MAC_InitRXDes
* Description    : ʼ16ֽڶ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void MAC_InitRXDes(void)
{
    int i;
    mac_rxdes *tmp;

    mac_cotrl.rxdes_top = (void *)RxDesBuf;                                     /* rxdes_topָһ */
    mac_cotrl.rxdes_cur = mac_cotrl.rxdes_top;                                  /* rxdes_curָһ */
    mac_cotrl.rxdes_end = mac_cotrl.rxdes_top + (RX_QUEUE_NUM - 1);             /* rxdes_endָһ */
    memset(mac_cotrl.rxdes_top, 0, sizeof(RxDesBuf));                           /* */
    mac_cotrl.rxdes_end->rxdes1 |= RXDES1_EDORR;                                /* һΪ־ */    
    mac_cotrl.rxdes_cur->rxdes2 |= (UINT32)MACRxBuf[RxCtrl.RecvIndex];          /* ջĻַ */
    tmp = mac_cotrl.rxdes_top;                                                  /* ָһ */
    tmp->rxdes0 |= RXDES0_RXDMA_OWN;                                            /* MACӵбʹȨ */
    for(i = 0; i < RX_QUEUE_NUM; i++){                                          /*  */
        tmp->rxdes1 |= RXDES1_RXBUF_SIZE( RX_BUF_SIZE );                        /* ջСλΪֽ */
        tmp->rxdes3 = (UINT32)(tmp + 1);                                        /* rxdes3һַ */
        tmp = (mac_rxdes *)tmp->rxdes3;                                         /* ָһַ */ 
    }
    mac_cotrl.rxdes_end->rxdes3 = (UINT32)mac_cotrl.rxdes_top;                  /* rxdes3һַ׸*/
}

/*******************************************************************************
* Function Name  : CH563MAC_Open
* Description    : CH563MAC򿪺ʹĬ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH563MAC_Open(void)
{

    UINT32 i;

    i = R32_ETHE_ISR;                                                           /* ж */
    R32_ETHE_MACCR = RB_SW_RST;                                                 /* λMAC */ 
    MAC_InitRXDes( );                                                           /* ʼ */
    MAC_InitTXDes( );                                                           /* ʼ */

#ifdef  TX_QUEUE_NUM
    R32_ETHE_TXR_BADR = (UINT32)mac_cotrl.txdes_top;                            /* ַдR32_ETHE_TXR_BADR */
#else
    R32_ETHE_TXR_BADR = (UINT32)mac_cotrl.txdes_point;                          /* ַдR32_ETHE_TXR_BADR */
#endif

    R32_ETHE_RXR_BADR = (UINT32)mac_cotrl.rxdes_top;                            /* ַдR32_ETHE_RXR_BADR */
    R32_ETHE_IMR = RB_RPKT_FINISH_EN | RB_NORXBUF_EN | RB_XPKT_OK_EN |          /* MACжʹܼĴ */
                   RB_XPKT_LOST_EN | RB_RPKT_LOST_EN | RB_PHYSTS_CHG_EN;
    i = (UINT32)(CH563MACAddr[2]<<24) + (UINT32)(CH563MACAddr[3]<<16) + (UINT32)(CH563MACAddr[4]<<8) + CH563MACAddr[5]; 
    R32_ETHE_MAC_LADR = i;                                                      /* дMACַĴĵ4*/
    i = (UINT32)(CH563MACAddr[0]<<8) + CH563MACAddr[1]; 
    R32_ETHE_MAC_MADR = i & 0xffff;                                             /* дMACַĴĸ2*/

    R32_ETHE_ITC   = RB_TXINT_THR(1);                                           /* ж϶ʱ */
     R32_ETHE_APTC  = RB_RXINT_CNT(1);                                          /* òѯĴ */
    R32_ETHE_DBLAC = RB_RXFIFO_LTHR(2) | RB_RXFIFO_HTHR(6) | RB_RX_THR_EN |     /* DMAͻ */
                     RB_INCR_SEL(2);
#if 1
    R32_ETHE_MACCR |= ( RB_RCV_ALL | RB_TDMA_EN | RB_RDMA_EN | RB_CRC_APD | 
                      RB_XMT_EN | RB_RCV_EN );                                  /* MACCRĴ */
#else
    R32_ETHE_MACCR |= ( RB_TDMA_EN | RB_RDMA_EN | RB_CRC_APD | 
                      RB_XMT_EN | RB_RCV_EN );                                  /* MACCRĴ */
#endif  
}

/*******************************************************************************
* Function Name  : CH563NET_Init
* Description    : ʼCH56̫
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET_Init(void)
{
    R8_INT_EN_IRQ_GLOB &= ~RB_IE_IRQ_GLOB;                                      /* ȫж */

    R32_PA_DIR |= (1<<18);                                                      /*PA18ΪLINKACK */
    R8_MISC_CTRL_ETH |= RB_MISC_ETH_RST | RB_MISC_ETH_LED;

    R8_SAFE_ACCESS_SIG = 0x57;                                                  /* unlock step 1 */
    R8_SAFE_ACCESS_SIG = 0xA8;                                                  /* unlock step 2 */                   
    R8_SLP_WAKE_CTRL  &= 0x7f;                                                  /* Դ */
    R8_SAFE_ACCESS_SIG = 0x00;                                                  /* д */

    Delay_ms( 50 );
    R8_MISC_CTRL_ETH &= ~RB_MISC_ETH_RST;                                       /* λ*/
    Delay_ms( 200 );

    R8_SAFE_ACCESS_SIG = 0x57 ;                                                 /* unlock step 1 */
    R8_SAFE_ACCESS_SIG = 0xA8 ;                                                 /* unlock step 2 */
    R8_SLP_CLK_OFF1 &= ~RB_SLP_CLK_ETH;                                         /* ʱ */
    R8_SAFE_ACCESS_SIG = 0;                                                     /* д */
}

/*******************************************************************************
* Function Name  : NET_INIT
* Description    : ̫ʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void NET_INIT( void )
{
    CH563MAC_ParamInit( );                                                      /* ʼ */
    CH563NET_Init( );                                                           /* ֵ̫Դʱӣelink */
    CH563MAC_Open( );                                                           /* ʼMAC */
    CH563PHY_Process( );                                                        /* ʼPHY */
}

/*******************************************************************************
* Function Name  : MAC_RxSuccessHandle
* Description    : ̫ճɹصҪǴʶѯǰ
                   ûпУֹͣDMAֱòſ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void MAC_RxSuccessHandle(void)
{
    RxCtrl.RxBufStau[RxCtrl.RecvIndex] = BUF_IP_LOCK;                           /* ˻Ȩ޽ϲ */
    RxCtrl.RxBufAddr[RxCtrl.RecvIndex]=((UINT32)MACRxBuf[RxCtrl.RecvIndex])+2;  /* ַƫ2ֽڣÿǰ2ֽЧ */
    RxCtrl.RecvIndex++;                                                         /* MACָһջ */
    if(RxCtrl.RecvIndex >= RX_QUEUE_NUM){                                       /* Ƿβ */
        RxCtrl.RecvIndex = 0;
    }
    /* ջķǶʧݰ */
    if(RxCtrl.RxBufStau[RxCtrl.RecvIndex] == BUF_IDLE){                         /* һջУ򽫽ָ˻ */
        RxCtrl.RemainCout++;
        if(RxCtrl.RemainCout > RX_QUEUE_NUM){
            RxCtrl.RemainCout = RX_QUEUE_NUM;
        }
    }
    else{
    }
    RxCtrl.RxBufStau[RxCtrl.RecvIndex] = BUF_MAC_LOCK;                          /* ˻MACʹãMAC */
    mac_cotrl.rxdes_cur = (mac_rxdes *)mac_cotrl.rxdes_cur->rxdes3;             /* ǰָһ */
    /* ʼһ */
    mac_cotrl.rxdes_cur->rxdes2 = (UINT32)MACRxBuf[RxCtrl.RecvIndex];    
    mac_cotrl.rxdes_cur->rxdes0 = RXDES0_RXDMA_OWN;
    RxCtrl.RxDMAEnable = TRUE;
}

/*******************************************************************************
* Function Name  : MAC_QueryInput
* Description    : ѯǷпɶݰ
* Input          : None
* Output         : None
* Return         : ʣݰ0ʾû
*******************************************************************************/
UINT8 MAC_QueryInput(void)
{
    return RxCtrl.RemainCout;                                                   /* ʣĿ */
}

/*******************************************************************************
* Function Name  : MAC_Xmit
* Description    : MACͺֻܷһ
* Input          : tx_addr  ͻַ
*                size     ݳ
* Output         : None
* Return         : None
*******************************************************************************/
void MAC_Xmit( UINT32 size)
{
    TxCtrl.TxBufStat[TxCtrl.SendIndex] = BUF_MAC_LOCK;                         /* ޸ķϢб */
    if( mac_cotrl.txdes_cur->txdes0 & TXDES0_TXDMA_OWN ){
//        R32_ETHE_MACCR &= (~RB_TDMA_EN);
//        R32_ETHE_MACCR |= RB_TDMA_EN; 
    }
    mac_cotrl.txdes_cur->txdes1 &= TXDES1_EDOTR;
    mac_cotrl.txdes_cur->txdes1 |= ( TXDES1_TXBUF_SIZE(size) | TXDES1_LTS | 
                                   TXDES1_FTS | TXDES1_TXIC );
    mac_cotrl.txdes_cur->txdes0 = TXDES0_TXDMA_OWN;
    SendSuc = 1;
    TxCtrl.SendIndex++;
    if(TxCtrl.SendIndex >= TX_QUEUE_NUM){
        TxCtrl.SendIndex = 0;
    }
    if( (R32_ETHE_APTC & RB_TXINT_CNT(0xf)) == 0 ){
        R32_ETHE_TXPD = 0xffffffff;                                             /* дMAC */
    }
}

/*******************************************************************************
* Function Name  : MAC_SendOkHanld
* Description    : CH563MAC_IsrãCH563MACж
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void MAC_SendOkHanld(void)
{                                                                                    
    R8_INT_EN_IRQ_GLOB &= ~RB_IE_IRQ_GLOB;                                      /* رIRQȫж */
    mac_cotrl.txdes_cur = (mac_txdes *)mac_cotrl.txdes_cur->txdes3;             /* ָһ */
    mac_cotrl.txdes_cur->txdes2 |= (UINT32)MACTxBuf[TxCtrl.SendIndex];          /* ͻĻַ */
    MACSendbuf = (UINT8 *)&MACTxBuf[TxCtrl.SendIndex][14];
    SendSuc = 0;                                                                /* ͳɹ־0 */
    R8_INT_EN_IRQ_GLOB |= RB_IE_IRQ_GLOB;                                       /* IRQȫж */
}

/*******************************************************************************
* Function Name  : PHY_GetLinkStatus
* Description    : ȡPHY״̬PHYıжеãȡǰ״̬
* Input          : None
* Output         : None
* Return         : ״̬
*******************************************************************************/
UINT8 PHY_GetLinkStatus(void)
{
    UINT8  status;
    UINT16 value;

    value = PHY_ReadData(FTPHY_REG_STATUS);                                     /* ȡ״̬Ĵ */
    if( (value & RB_LINK_STATUS) == 0 ){                                        /* ΪϿ״̬ */
        status =  PHY_DISCONN;  
    }
    else{
        value = PHY_ReadData(FTPHY_REG_CONTROL);                                /* ȡPHYƼĴ */
        if((value & RB_DUPLEX_MODE) ){                                          /* Ϊȫ˫ģʽ */
            R32_ETHE_MACCR |= RB_FULLDUP;
            if((value & RB_SPEED_SEL) > 0){                                     /* ȡٶ */
                R32_ETHE_MACCR |= RB_SPEED_100;
                status = PHY_100M_FLL;                                          /* ȫ˫100M */
            }
            else{ 
                R32_ETHE_MACCR &= ~RB_SPEED_100;
                status = PHY_10M_FLL;                                           /* ȫ˫10M */
            }
        }
        else{                                                                   /* Ϊ˫ģʽ */
            R32_ETHE_MACCR &= ~(RB_FULLDUP);                                    /* ȡٶ */
            if((value & RB_SPEED_SEL) > 0){                                    
                R32_ETHE_MACCR |= RB_SPEED_100;
                status = PHY_100M_HALF;                                         /* ˫100M */
            }
            else{ 
                R32_ETHE_MACCR &= ~(RB_SPEED_100);
                status = PHY_10M_HALF;                                          /* ˫10M */
            }
        }
    }                   
    return status;
}

/*******************************************************************************
* Function Name  : MAC_RecvFinishHanld
* Description    : CH563MAC_Isrãжϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void MAC_RecvFinishHanld(void)
{

    if(mac_cotrl.rxdes_cur->rxdes0 & RXDES0_FRS){                               /* ǷǷΪһ */
        if(mac_cotrl.rxdes_cur->rxdes0 & RXDES0_RX_ODD_NB){                     /* ֽڴ */
#if  CH563_DEBUG
            printf("ERROR *** RX_ODD_NB\n");
#endif 
            return;
        }
        if(mac_cotrl.rxdes_cur->rxdes0 & RXDES0_CRC_ERR){                       /* CRCУ */
#if  CH563_DEBUG
            printf("ERROR *** CRC\n");
#endif
            return;
        }
        if(mac_cotrl.rxdes_cur->rxdes0 & RXDES0_RX_ERR){                        /* DES0 */
#if  CH563_DEBUG
            printf("ERROR *** RX_ERR\n");
#endif
            return;
        }
        RxCtrl.RxBufLen[RxCtrl.RecvIndex] = mac_cotrl.rxdes_cur->rxdes0 & RXDES0_RFL;/* ȡȣǷ񳬹TX_BUF_SIZE */
        if( RxCtrl.RxBufLen[RxCtrl.RecvIndex] > TX_BUF_SIZE){
#if  CH563_DEBUG
            printf("ERROR *** len large\n");
#endif
            return;
        }
    }
    else{                                                                       /* ǵһ */
#if  CH563_DEBUG
        printf("ERROR *** not the first package\n");
#endif
        return;
    }
    while(1){
        while(mac_cotrl.rxdes_cur->rxdes0 & RXDES0_RXDMA_OWN);                  /* ȴȨ */
        if(mac_cotrl.rxdes_cur->rxdes0 & RXDES0_LRS){
            MAC_RxSuccessHandle();                                              /* ճɹҪ¿б */
            break;
        }
        mac_cotrl.rxdes_cur->rxdes0 = RXDES0_RXDMA_OWN;                         /* ͷDMAڶCH563MAC_RxSuccessHandleѾת */
        mac_cotrl.rxdes_cur = (mac_rxdes *)mac_cotrl.rxdes_cur->rxdes3;         /* ǰָһ */
    }
}

/*******************************************************************************
* Function Name  : MAC_Input
* Description    : ȡݣȡһ֡
* Input          : buf  ,ĴС벻СRX_BUF_SIZE
*                : len  ݰЧ
* Output         : None
* Return         : ʣݰ0ʾû
*******************************************************************************/
UINT16 MAC_Input(UINT8 *buf,UINT16 *len)
{
    UINT8  *macdata;
    UINT16 mac_len;

    mac_len = RxCtrl.RxBufLen[RxCtrl.ReadIndex];                                /* ȡǰݰ */
    if( mac_len < ETHER_HEAD_LEN ){
        *len = 0;
        return FALSE;
    }
    if(  mac_len > RECE_BUF_LEN ){
        mac_len = RECE_BUF_LEN;
    }
    macdata = (UINT8 *)RxCtrl.RxBufAddr[RxCtrl.ReadIndex];                      /* ȡǰݰָ */
    memcpy(ETH.buffer,macdata,ETHER_HEAD_LEN);                                  /* ̫ͷƳ */
    /// ˴Զmacַݳ /////////
    mac_len -= ETHER_HEAD_LEN;
    memcpy(buf,&macdata[ETHER_HEAD_LEN],mac_len);                               /* ݰƵûָĻ */
    R8_INT_EN_IRQ_GLOB &= ~RB_IE_IRQ_GLOB;                                      /* رжϣ޸ĽϢб */
    RxCtrl.RxBufStau[RxCtrl.ReadIndex] = BUF_IDLE;                              /* ǰбΪ״̬ */
    RxCtrl.ReadIndex++;                                                         /* +1 */
    if(RxCtrl.ReadIndex >= RX_QUEUE_NUM){                                       /* Χ */
        RxCtrl.ReadIndex = 0;
    }
    if(RxCtrl.RemainCout){                                                      /* ʣ-1 */
        RxCtrl.RemainCout--; 
    }
    R8_INT_EN_IRQ_GLOB |= RB_IE_IRQ_GLOB;                                       /* ж  */
    *len = mac_len;
    return TRUE;
}

/*******************************************************************************
* Function Name  : MAC_Output
* Description    : CH563MAC 
* Input          : buf  ,ĴС벻ôTX_BUF_SIZEҲС60
*                : len  ݰЧ
*                code macЭ
* Output         : None
* Return         : ط״̬
*******************************************************************************/
UINT8 MAC_Output(UINT8 *buf,UINT16 *len,UINT16 code)
{
    UINT8   timecount = 0;
    UINT16  mac_len;
    
    if(buf) MACSendbuf = buf;
    mac_len = *len;
    if( mac_len > MAC_MAX_LEN ){                                                /* 鳤ȣȴTX_BUF_SIZEܻᵼϵͳ */
        mac_len = MAC_MAX_LEN; 
        *len = MAC_MAX_LEN;
    }
    memcpy( ETH.Head.SourMAC,CH563MACAddr,MACADDR_LEN );                        /* дmacַ */
    ETH.Head.PROTOCOL = code;                                                   /* дЭ */
    memcpy( MACTxBuf[TxCtrl.SendIndex],ETH.buffer,ETHER_HEAD_LEN );             /* ̫ͷƵͻ */
    mac_len += ETHER_HEAD_LEN; 
    if( mac_len < 60){
        memset(&MACTxBuf[mac_len],0,60 - mac_len);                              /* 60ֽڵĲֲ0 */
        mac_len = 60;                                                           /* СΪ60ֽ */
    }
    MAC_Xmit( mac_len);                                                         /* Ϊ˽ʡRAMֱbufݷͣʡȥʱ䣬Ч*/
    while(SendSuc){                                                             /* Ϻ󣬻ͳɹжCH563MAC_INT_XPKT_OK */
       timecount++;
       Delay_us(10);
       if((timecount > 200))return FALSE;                                       /* ʱʱԼΪ2MSʱFALSE(0) */
    }
    return TRUE;                                                                /* ɹTRUE(1) */
}

/*******************************************************************************
* Function Name  : GLOB_nTohs
* Description    : 16λСл
* Input          : in 
* Output         : None
* Return         : None
*******************************************************************************/
UINT16 GLOB_nTohs( UINT16 in ) 
{
    UINT16 out;
    out = (in<<8) | (in>>8);
    return out;
}

/*******************************************************************************
* Function Name  : MAC_Isr
* Description    : MACжϷ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void MAC_Isr(void)
{
    UINT32  int_status;
     
    int_status = R32_ETHE_ISR;
    if(int_status & RB_RPKT_FINISH) {                                           /* ж */  
        MAC_RecvFinishHanld( );                                     
    }
    if(int_status & RB_XPKT_FINISH){                                            /* (TXDMA дFIFOʾͳɹ)*/

    }
    if(int_status & RB_XPKT_OK){                                                /* ݷͳɹ */
        MAC_SendOkHanld( );
    }      
    if(int_status & RB_PHYSTS_CHG){                                             /* PHYıж */
        PHYStatus = PHY_GetLinkStatus( );                                       /* ȡPHY״̬ */
#if  CH563_DEBUG
        printf("PHY change,status=%x\r\n",(UINT16)PHYStatus);
#endif
    }                                                                 
}

/*******************************************************************************
* Function Name  : ARP_Output
* Description    : arp
* Input          : DestIP͵Ŀipַ
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 ARP_Output( UINT8 *desip,UINT8 code )
{
    UINT16 arp_len;    

    arp_len = ARP_PACKAGE_LEN;                                               
    ARP.Package.HRDTYPE = GLOB_nTohs( ARP_HARDWARE_TYPE_ETHER );
    ARP.Package.PROTYPE = GLOB_nTohs( ARP_PROTOCOL_TYPE_IP );    
    ARP.Package.MACLEN  = MACADDR_LEN;    
    ARP.Package.IPLEN   = IPADDR_LEN;    
    ARP.Package.OPCODE  = GLOB_nTohs( code );                                   /* ݰͣ1 -arp2-arpӦ*/
    memcpy(ARP.Package.TARGIP,desip,IPADDR_LEN);                                /* arpĿipַ */
    memset(ARP.Package.TARGMAC,0,MACADDR_LEN);                                  /* arpĿmacַΪȫ0 */
    memcpy(ARP.Package.SENDIP,CH563IPAddr,IPADDR_LEN);                          /* ipַ */
    memcpy(ARP.Package.SENDMAC,CH563MACAddr,MACADDR_LEN);                       /* macַ */
    memcpy( MACSendbuf,ARP.buffer,arp_len );                                    /* arpݰƵͻ */
    if( code == ARP_CODE_REPLY ){
        memcpy(ETH.Head.DestMAC,ETH.Head.SourMAC,MACADDR_LEN);                  /* дĿmacַ */
    }
    else memset(ETH.Head.DestMAC,0xff,MACADDR_LEN);                             /* дĿmacַ */
    return ( MAC_Output( MACSendbuf,&arp_len,GLOB_nTohs( ETHER_TYPE_ARP ) ));
}

/*******************************************************************************
* Function Name  : ARP_Input
* Description    : յarp
* Input          : DestIP͵Ŀipַ
* Output         : None
* Return         : None
*******************************************************************************/
void ARP_Input( UINT8 *arpdata,UINT16 len )
{
    
    if( len < ARP_PACKAGE_LEN ) return;
    memcpy(ARP.buffer,arpdata,ARP_PACKAGE_LEN);
    if(    ARP.Package.HRDTYPE == GLOB_nTohs( ARP_HARDWARE_TYPE_ETHER ) &&
        ARP.Package.PROTYPE == GLOB_nTohs( ARP_PROTOCOL_TYPE_IP ) &&
        ARP.Package.MACLEN  == MACADDR_LEN &&    
        ARP.Package.IPLEN   == IPADDR_LEN ){
        if( ARP.Package.OPCODE  == GLOB_nTohs( ARP_CODE_QUEST )){
            if(  memcmp(ARP.Package.TARGIP,CH563IPAddr,IPADDR_LEN) == 0 ){
                ARP_Output( ARP.Package.TARGIP,ARP_CODE_REPLY );
            }
        }
        else{
            return ;
        }
    }    
}

/*********************************** endfile **********************************/
