/********************************** (C) COPYRIGHT ******************************
* File Name		: MQTT.C
* Author		: WCH
* Version		: V1.0
* Date			: 2018/4/15
* Description	:TCP/IPMQTTЭͨѶ̣ʵMQTTʽͨٶȡʵ豸ͨʹǰʺź
*					(1)CH563 Examples by KEIL;
*					(2)0Ϣ,115200bps;
*					(3)ʾTCP/IPMQTTЭͨѶ
					     Ƭ̫MQTT󽫻ᷢһ⣬
					     ٶ⣬ⷢϢ
						 յԼ͵Ϣ
*******************************************************************************/



/******************************************************************************/
/* ͷļ*/
#include <stdio.h>							 
#include <string.h>
#include "CH563SFR.H"
#include "SYSFREQ.H"

#include "CH563NET.H"
#include "ISPXT56X.H"
#include "MQTTPacket.H"

#define CH563NET_DBG		1			 
#define KEEPLIVE_ENABLE		1														/* KEEPLIVE */


/* ĻȫֱҪ壬е */
__align(16)UINT8		CH563MACRxDesBuf[(RX_QUEUE_ENTRIES )*16];					/* MAC16ֽڶ */
__align(4) UINT8		CH563MACRxBuf[RX_QUEUE_ENTRIES*RX_BUF_SIZE];				/* MACջ4ֽڶ */
__align(4) SOCK_INF SocketInf[CH563NET_MAX_SOCKET_NUM];								/* SocketϢ4ֽڶ */
const UINT16 MemNum[8] = {CH563NET_NUM_IPRAW,
												 CH563NET_NUM_UDP,
												 CH563NET_NUM_TCP,
												 CH563NET_NUM_TCP_LISTEN,
												 CH563NET_NUM_TCP_SEG,
												 CH563NET_NUM_IP_REASSDATA,
												 CH563NET_NUM_PBUF,
												 CH563NET_NUM_POOL_BUF
												 };
const UINT16 MemSize[8] = {CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_IPRAW_PCB),
													CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_UDP_PCB),
													CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_TCP_PCB),
													CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_TCP_PCB_LISTEN),
													CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_TCP_SEG),
													CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_IP_REASSDATA),
													CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_PBUF) + CH563NET_MEM_ALIGN_SIZE(0),
													CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_PBUF) + CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_POOL_BUF)
												 };
__align(4)UINT8 Memp_Memory[CH563NET_MEMP_SIZE];
__align(4)UINT8 Mem_Heap_Memory[CH563NET_RAM_HEAP_SIZE];
__align(4)UINT8 Mem_ArpTable[CH563NET_RAM_ARP_TABLE_SIZE];
/******************************************************************************/
/* ʾغ */
#define RECE_BUF_LEN	536					/* ջĴС */
/* CH563NETTCPMSSΪ536ֽڣһTCPݲΪ536ֽ */
/* TCPЭջûڽأֵΪsocketĽջȡ趨 */
/* RX_QUEUE_ENTRIESʱҪMSSʹ֮Ĺϵ細ֵΪ4*MSSԶһλᷢ */
/* 4TCPRX_QUEUE_ENTRIESС4ȻᵼݰʧӶͨѶЧʽ */
/* RX_QUEUE_ENTRIESҪ( /MSS ),socketͬʱдݣ */
/* RX_QUEUE_ENTRIESҪ(( /MSS )*socket) ڶsocketͬʱдշʱ */
/* Ϊ˽ԼRAM뽫ջĳΪMSS */




/*ʹǰҪöӦƽ̨ʺź*/
UINT8 MACAddr[6] = {0x84,0xc2,0xe4,0x05,0x06,0x17};			/* CH563MACַ */
UINT8 IPAddr[4] = {192,168,10,75};							/* CH563IPַ */
UINT8 GWIPAddr[4] = {192,168,10,1};							/* CH563 */
UINT8 IPMask[4] = {255,255,255,0};							/* CH563 */
UINT16 aport=1000;											/* CH563Դ˿ */

UINT16 DESPORT= 1883;										/* MQTT˿ */
UINT8 DESIP[4] = {163,177,150,12};							/* MQTTIPַ */
char *username = "test1/device1";							/* 豸ÿ豸Ψһá/ּ */
char *password = "password";								/* ½ */
char *sub_topic = "topic1";									/* ĵĻỰΪԷգӦ뷢ĻỰͬ */
char *pub_topic = "topic1";									/* ĻỰ */


/* CH563ض */
UINT8 SocketId;												/* socketԲö */
UINT8 SocketRecvBuf[RECE_BUF_LEN];							/* socketջ */
UINT8 MyBuf[RECE_BUF_LEN];									/* һʱ */
UINT32 a=0;

UINT8 con_flag=0;											/* MQTT־λ */
UINT8 pub_flag=1;											/* ѷỰϢ־λ */
UINT8 sub_flag=0;											/* ѶĻỰ־λ */
UINT8 tout_flag=0;											/* ʱ־λ */
UINT16 packetid=0;											/* ID */


/*******************************************************************************
* Function Name	: SysTimeInit
* Description	: ϵͳʱʼCH563@100MHZ TIME0 10msCH563NETTIMEPERIOD
*				  ʼʱ
* Input			: None
* Output		: None
* Return		: None
*******************************************************************************/
void SysTimeInit(void)
{
		R8_TMR0_CTRL_MOD = RB_TMR_ALL_CLEAR;
		R32_TMR0_COUNT = 0x00000000; 
		R32_TMR0_CNT_END = 0x186a0 * CH563NETTIMEPERIOD;		/* Ϊ10MSʱ */
		R8_TMR0_INTER_EN |= RB_TMR_IE_CYC_END;
		R8_TMR0_CTRL_MOD = RB_TMR_COUNT_EN;
}


/*******************************************************************************
* Function Name	: InitSysHal
* Description	: ӲʼTIM0ETHж
* Input			: None
* Output		: None
* Return		: None
*******************************************************************************/
void InitSysHal(void)
{
		R8_INT_EN_IRQ_0 |= RB_IE_IRQ_TMR0;			/* TIM0ж */
		R8_INT_EN_IRQ_1 |= RB_IE_IRQ_ETH;			/* ETHж */
		R8_INT_EN_IRQ_GLOB |= RB_IE_IRQ_GLOB;		/* IRQȫж */
}


/*******************************************************************************
* Function Name	: mStopIfError
* Description	: ʹãʾ
* Input			: None
* Output		: None
* Return		: None
*******************************************************************************/
void mStopIfError(UINT8 iError)
{
		if (iError == CH563NET_ERR_SUCCESS) return;			/* ɹ */
#if CH563NET_DBG
		printf("Error: %02X\n", (UINT16)iError);			/* ʾ */
#endif		
}


/*******************************************************************************
* Function Name	: Transport_Open
* Description	: TCP
* Input			: None
* Output		: None
* Return		: None
*******************************************************************************/
UINT8 Transport_Open()
{
	UINT8 i;																														 
	SOCK_INF TmpSocketInf;									/* ʱsocket */

	memset((void *)&TmpSocketInf,0,sizeof(SOCK_INF));		/* ڲὫ˱ƣýʱȫ */
	memcpy((void *)TmpSocketInf.IPAddr,DESIP,4);			/* ĿIPַ */
	TmpSocketInf.DesPort = 1883;							/* ĿĶ˿ */
	TmpSocketInf.SourPort = aport++;						/* Դ˿ */
	TmpSocketInf.ProtoType = PROTO_TYPE_TCP;				/* socekt */
	TmpSocketInf.RecvStartPoint = (UINT32)SocketRecvBuf;	/* ýջĽջ */
	TmpSocketInf.RecvBufLen = RECE_BUF_LEN ;				/* ýջĽճ */
	i = CH563NET_SocketCreat(&SocketId,&TmpSocketInf);		/* socketصsocketSocketId */
	mStopIfError(i);										/*  */
	
	i = CH563NET_SocketConnect(SocketId);					/* TCP */
	mStopIfError(i);										/*  */
	return SocketId;
}


/*******************************************************************************
* Function Name	: Transport_Close
* Description	: رTCP
* Input			: None
* Output		: None
* Return		: None
*******************************************************************************/
UINT8 Transport_Close()
{
	UINT8 i;
	i=CH563NET_SocketClose(SocketId,TCP_CLOSE_NORMAL);
	mStopIfError(i);
	return i;
}


/*******************************************************************************
* Function Name	: Transport_SendPacket
* Description	: ̫
* Input			: UINT8 *buf ݵֽڵַ
				  UINT32 len ݵĳ
* Output		: None
* Return		: None
*******************************************************************************/
void Transport_SendPacket(UINT8 *buf,UINT32 len)
{
	UINT32 totallen;
	UINT8 *p=buf;
	
	totallen=len;
	while(1)
	{
		len = totallen;
		CH563NET_SocketSend(SocketId,p,&len);					/* MyBufеݷ */
		totallen -= len;					 					/* ܳȼȥԼϵĳ */
		p += len;												/* ָƫ*/
		if(totallen)continue;									/* δϣ*/
		break;													/* ϣ˳ */
	}
}


/*******************************************************************************
* Function Name	: MQTT_Connect
* Description	: MQTT
* Input			: char *username 豸
				  char *password 
* Output		: None
* Return		: None
*******************************************************************************/
void MQTT_Connect(char *username,char *password)
{
	MQTTPacket_connectData data = MQTTPacket_connectData_initializer;
	UINT32 len;
	UINT8 buf[200];

	data.clientID.cstring = "11";
	data.keepAliveInterval = 20;
	data.cleansession = 1;
	data.username.cstring = username;																		
	data.password.cstring = password;
	 
	len=MQTTSerialize_connect(buf,sizeof(buf),&data);											
	Transport_SendPacket(buf,len);						/*MQTT*/
}


/*******************************************************************************
* Function Name	: MQTT_Subscribe
* Description	: MQTTһ
* Input			: char *topic ĵ
* Output		: None
* Return		: None
*******************************************************************************/
void MQTT_Subscribe( char *topic)
{
	MQTTString topicString = MQTTString_initializer;
	int req_qos=0;
	UINT32 len;
	UINT32 msgid=1;
	UINT8 buf[200];
	
	topicString.cstring=topic;
	len=MQTTSerialize_subscribe(buf,sizeof(buf),0,msgid,1,&topicString,&req_qos);
	Transport_SendPacket(buf,len);
}


/*******************************************************************************
* Function Name	: MQTT_Unsubscribe
* Description	: MQTTȡһ
* Input			: char *topic ȡĵ
* Output		: None
* Return		: None
*******************************************************************************/
void MQTT_Unsubscribe(char *topic)
{
	MQTTString topicString = MQTTString_initializer;
	UINT32 len;
	UINT32 msgid=1;
	UINT8 buf[200];
	
	topicString.cstring=topic;
	len=MQTTSerialize_unsubscribe(buf,sizeof(buf),0,msgid,1,&topicString);
	Transport_SendPacket(buf,len);
}


/*******************************************************************************
* Function Name	: MQTT_Subscribe
* Description	: MQTTһ
* Input			: char *topic ĵ
* Output		: None
* Return		: None
*******************************************************************************/
void MQTT_Publish(char *topic,char *payload)
{
	MQTTString topicString = MQTTString_initializer;
	UINT32 payloadlen;
	UINT32 len;
	UINT8 buf[1024];
	
	topicString.cstring=topic; 
	payloadlen=strlen(payload);
	len= MQTTSerialize_publish(buf,sizeof(buf),0,0,0,packetid++,topicString,payload,payloadlen);	
	Transport_SendPacket(buf,len);
}


/*******************************************************************************
* Function Name	: MQTT_Pingreq
* Description	: MQTT
* Input			: None
* Output		: None
* Return		: None
*******************************************************************************/
void MQTT_Pingreq()
{
	UINT32 len;
	UINT8 buf[200];
	
	len=MQTTSerialize_pingreq(buf,sizeof(buf));
	Transport_SendPacket(buf,len);
}


/*******************************************************************************
* Function Name	: MQTT_Disconnect
* Description	: ϿMQTT
* Input			: None
* Output		: None
* Return		: None
*******************************************************************************/
void MQTT_Disconnect()
{
	UINT32 len;
	UINT8 buf[50];
	len=MQTTSerialize_disconnect(buf,sizeof(buf));
	Transport_SendPacket(buf,len);
}


/*******************************************************************************
* Function Name	: net_initkeeplive
* Description	: keepliveʼ
* Input			: None			
* Output		: None
* Return		: None
*******************************************************************************/
#ifdef	KEEPLIVE_ENABLE
void net_initkeeplive(void)
{
		struct _KEEP_CFG	klcfg;

		klcfg.KLIdle = 20000;				/*  */
		klcfg.KLIntvl = 10000;				/*  */
		klcfg.KLCount = 5;					/*  */
		CH563NET_ConfigKeepLive(&klcfg);
}
#endif

/*******************************************************************************
* Function Name	: CH563NET_LibInit
* Description	: ʼ
* Input			: ip			ipַָ
*				: gwip		ipַָ
*				: mask		ָ
*				: macaddr MACַָ 
* Output		: None
* Return		: ִ״̬
*******************************************************************************/
UINT8 CH563NET_LibInit(const UINT8 *ip,const UINT8 *gwip,const UINT8 *mask,const UINT8 *macaddr)
{
		UINT8 i;
		struct _CH563_CFG cfg;

		if(CH563NET_GetVer() != CH563NET_LIB_VER)return 0xfc;			/* ȡİ汾ţǷͷļһ */
		CH563NETConfig = LIB_CFG_VALUE;									/* Ϣݸñ */
		cfg.RxBufSize = RX_BUF_SIZE; 
		cfg.TCPMss	 = CH563NET_TCP_MSS;
		cfg.HeapSize = CH563_MEM_HEAP_SIZE;
		cfg.ARPTableNum = CH563NET_NUM_ARP_TABLE;
		cfg.MiscConfig0 = CH563NET_MISC_CONFIG0;
		CH563NET_ConfigLIB(&cfg);
		i = CH563NET_Init(ip,gwip,mask,macaddr);
#ifdef	KEEPLIVE_ENABLE
		net_initkeeplive( );
#endif
		return (i);											/* ʼ */
}

/*******************************************************************************
* Function Name	: CH563NET_CreatTcpSocket
* Description	: TCP Client socket
* Input			: None
* Output		: None
* Return		: None
*******************************************************************************/
void CH563NET_CreatTcpSocket(void)
{
	 UINT8 i;																														 
	 SOCK_INF TmpSocketInf;											/* ʱsocket */

	 memset((void *)&TmpSocketInf,0,sizeof(SOCK_INF));				/* ڲὫ˱ƣýʱȫ */
	 memcpy((void *)TmpSocketInf.IPAddr,DESIP,4);					/* ĿIPַ */
	 TmpSocketInf.DesPort = 1000;									/* ĿĶ˿ */
	 TmpSocketInf.SourPort = 2000;									/* Դ˿ */
	 TmpSocketInf.ProtoType = PROTO_TYPE_TCP;						/* socekt */
	 TmpSocketInf.RecvStartPoint = (UINT32)SocketRecvBuf;			/* ýջĽջ */
	 TmpSocketInf.RecvBufLen = RECE_BUF_LEN ;						/* ýջĽճ */
	 i = CH563NET_SocketCreat(&SocketId,&TmpSocketInf);				/* socketصsocketSocketId */
	 mStopIfError(i);												/*  */

#ifdef	KEEPLIVE_ENABLE
	 CH563NET_SocketSetKeepLive( SocketId, 1 );						/* socketKEEPLIVEܣV06汾֧֣ */
#endif

	 i = CH563NET_SocketConnect(SocketId);							/* TCP */
	 mStopIfError(i);												/*  */
}

/*******************************************************************************
* Function Name	: CH563NET_HandleSockInt
* Description	: Socketжϴ
* Input			: sockeid	socket
*				: initstat ж״̬
* Output		: None
* Return		: None
*******************************************************************************/
void CH563NET_HandleSockInt(UINT8 sockeid,UINT8 initstat)
{
	UINT32 len;
	UINT8 i;

	unsigned char* dup;
	unsigned short* packetid;

	int* qos;
	unsigned char* retained;
	MQTTString* topicName;
	unsigned char* payload;
	int payloadlen;
	unsigned char *p=payload;

	if(initstat & SINT_STAT_RECV)							/* ж */
	{
		len = CH563NET_SocketRecvLen(sockeid,NULL);			/* ѯ */
		CH563NET_SocketRecv(sockeid,MyBuf,&len);			/* ջݶMyBuf*/
		switch(MyBuf[0]>>4)
		{
			case FLAG_CONNACK:
				printf("connack\r\n");
				con_flag=1;
				break;

			case FLAG_PUBLISH:
				MQTTDeserialize_publish(dup,qos,retained,packetid,topicName,&payload,&payloadlen,MyBuf,len);
				printf("payloadlen=%d\r\n",(UINT16)payloadlen);
				p=payload;
				for(i=0;i<payloadlen;i++)
				{
					printf("%c ",(UINT16)*p);
					p++;
				}
				printf("\r\n");
				break;
				
			case FLAG_SUBACK:
				sub_flag=1;
				printf("suback\r\n");
				break;

			default:

				break;
		}
	}
	if(initstat & SINT_STAT_CONNECT)					/* TCPж */
	{
#if CH563NET_DBG										/* жϱʾTCPѾӣԽշ */
		printf("TCP Connect Success\n");													 
#endif
		MQTT_Connect(username, password);

	}
	if(initstat & SINT_STAT_DISCONNECT)					/* TCPϿж */
	{
#if CH563NET_DBG										/* жϣCH563ڲὫsocketΪر*/
		printf("TCP Disconnect\n");						/* Ӧ´ */
#endif												 
		CH563NET_CreatTcpSocket();
	}
	if(initstat & SINT_STAT_TIM_OUT)					/* TCPʱж */
	{
#if CH563NET_DBG										/* жϣCH563ڲὫsocketΪر*/
		printf("TCP Timout\n");							/* Ӧ´ */
#endif
		Transport_Open();
	}
}

/*******************************************************************************
* Function Name	: CH563NET_HandleGloableInt
* Description	: ȫжϴ
* Input			: None
* Output		: None
* Return		: None
*******************************************************************************/
void CH563NET_HandleGlobalInt(void)
{
	UINT8 initstat;
	UINT8 i;
	UINT8 socketinit;
	
	initstat = CH563NET_GetGlobalInt();										/* ȫж״̬ */
	if(initstat & GINT_STAT_UNREACH)										/* ɴж */
	{
#if CH563NET_DBG
		printf("UnreachCode %d\n",CH563Inf.UnreachCode);					/* 鿴ɴ */
		printf("UnreachProto %d\n",CH563Inf.UnreachProto);				/* 鿴ɴЭ */
		printf("UnreachPort %d\n",CH563Inf.UnreachPort);					/* ѯɴ˿ */
#endif			 
	}
	if(initstat & GINT_STAT_IP_CONFLI)										/* IPͻж */
	{
	 
	}
	if(initstat & GINT_STAT_PHY_CHANGE)										/* PHYıж */
	{
		i = CH563NET_GetPHYStatus();										/* ȡPHY״̬ */
#if CH563NET_DBG
		printf("GINT_STAT_PHY_CHANGE %02x\n",i);
#endif	 
	}
	if(initstat & GINT_STAT_SOCKET)											/* Socketж */
	{
		for(i = 0; i < CH563NET_MAX_SOCKET_NUM; i ++)										 
		{
			socketinit = CH563NET_GetSocketInt(i);							/* socketжϲ */
			if(socketinit) CH563NET_HandleSockInt(i,socketinit);			/* ж */
		}		
	}
}



/*******************************************************************************
* Function Name	: mInitSTDIO
* Description	: Ϊprintfgetkeyʼ
* Input			: None
* Output		: None
* Return		: None
*******************************************************************************/
void mInitSTDIO( void )
{
	UINT32		x, x2;

	x = 10 * FREQ_SYS * 2 / 16 / 115200;									/* 115200bps */
	x2 = x % 10;
	x /= 10;
	if ( x2 >= 5 ) x ++;													/*  */
	R8_UART0_LCR = 0x80;													/* DLABλ1 */
	R8_UART0_DIV = 1;														/* ԤƵ */
	R8_UART0_DLM = x>>8;
	R8_UART0_DLL = x&0xff;

	R8_UART0_LCR = RB_LCR_WORD_SZ ;													/* ֽڳΪ8 */
	R8_UART0_FCR = RB_FCR_FIFO_TRIG|RB_FCR_TX_FIFO_CLR|RB_FCR_RX_FIFO_CLR |		
								 RB_FCR_FIFO_EN ;									/* FIFOΪ14巢ͺͽFIFOFIFOʹ */
	R8_UART0_IER = RB_IER_TXD_EN;													/* TXD enable */
	R32_PB_SMT |= RXD0|TXD0;														/* RXD0 schmitt input, TXD0 slow rate */
	R32_PB_PD &= ~ RXD0;															/* disable pulldown for RXD0, keep pullup */
	R32_PB_DIR |= TXD0;																/* TXD0 output enable */
}

/*******************************************************************************
* Function Name	: fputc
* Description	: ͨϢ
* Input			: c-- writes the character specified by c 
*				  *f--the output stream pointed to by *f
* Output		: None
* Return		: None
*******************************************************************************/
int fputc( int c, FILE *f )
{
		R8_UART0_THR = c;													/*  */
		while( ( R8_UART0_LSR & RB_LSR_TX_FIFO_EMP ) == 0 );				/* ȴݷ */
		return( c );
}


__irq void IRQ_Handler( void )
{
	if(R32_INT_FLAG & 0x8000)												/* ̫ж */
	{																		/* ̫жжϷ */
			CH563NET_ETHIsr();
	}
	if(R32_INT_FLAG & RB_IF_TMR0)											/* ʱж */
	{
		CH563NET_TimeIsr(CH563NETTIMEPERIOD);								/* ʱжϷ */
		R8_TMR0_INT_FLAG |= 0xff;											/* ʱжϱ־ */
		a++;
	 }
}

__irq void FIQ_Handler( void )
{
	while(1);
}

/*******************************************************************************
* Function Name	: main
* Description	: 
* Input			: None
* Output		: None
* Return		: None
*******************************************************************************/
int main(void) 
{
	UINT32 i = 0;
	UINT16 TimeDelay=0;
	char payload[500];
	
	for(i=0;i<500;i++)
	payload[i]='a';

	mInitSTDIO( );															/* Ϊüͨڼʾ */
	i = CH563NET_LibInit(IPAddr,GWIPAddr,IPMask,MACAddr);					/* ʼ */
	mStopIfError(i);														/*  */
#if CH563NET_DBG
	printf("CH563NETLibInit Success\n");
#endif		
	SysTimeInit();															/* ϵͳʱʼ */
	InitSysHal();															/* ʼж */
	Transport_Open();	

	while(1)
	{
		CH563NET_MainTask();												/* CH563NETҪѭвϵ */
		if (CH563NET_QueryGlobalInt()) CH563NET_HandleGlobalInt();			/* ѯжϣжϣȫжϴ */
		Delay_ms(1);
		TimeDelay++;
		if (TimeDelay>500) {
			TimeDelay=0;
			if(con_flag) MQTT_Publish(pub_topic,payload);
		}
	}
}

/*********************************** endfile **********************************/
