/********************************** (C) COPYRIGHT *******************************
* File Name          : USB_DEVICE.C
* Author             : WCH
* Version            : V1.0
* Date               : 2013/11/15
* Description        : CH563 USB_Device Example
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include  <stdio.h>
#include  <string.h>
#include  "CH563BAS.H"                                                          /* оƬͶͷļ */
#include  "CH563SFR.H"                                                          /* оƬĴͷļ */
#include  "SYSFREQ.H"                                                           /* ϵͳͷļ */
#include  "CH563USBSFR.H"                                                       /* оƬUSBĴͷļ */
#include  "CH563USB.H"                                                          /* USBöͷļ */
#include  "USB_DEVICE.H"                                                        /* USB豸ͷļ */
#include  "PRINTF.H"                                                            /* ڴӡͷļ */

/******************************************************************************/
/* 豸 */
const UINT8 MyDevDescr[ ] = { 0x12, 0x01, 0x10, 0x01, 0x00, 0x00, 0x00, 0x40,
                              0x88, 0x11, 0x88, 0x88,                           /* IDͲƷID */
                              0x00, 0x01, 0x01, 0x02, 0x03, 0x01 };

/* ȫ */
const UINT8 My_FS_CfgDescr[ ] = { 0x09, 0x02, 0x22, 0x00, 0x01, 0x01, 0x00, 0xc0, 0x32,
                                  0x09, 0x04, 0x00, 0x00, 0x01, 0x03, 0x01, 0x01, 0x00,
                                  0x09, 0x21, 0x10, 0x01, 0x21, 0x01, 0x22, 0x41, 0x00,
                                  0x07, 0x05, 0x82, 0x03, 0x40, 0x00, 0x0A};


const UINT8 Key_ReportDescrip[] = {  //ÿпʼĵһֽΪĿǰ׺ǰ׺ĸʽΪ
 //D7~D4bTagD3~D2bTypeD1~D0bSize·ֱÿĿע͡

/************************USBֱ̲**********************/
/*******************************************************************/
 //һȫ֣bTypeΪ1Ŀ;ҳѡΪͨGeneric Desktop Page(0x01)
 //һֽݣbSizeΪ1ֽͲעˣ
 //ԼbSizeжϡ
 0x05, 0x01, // USAGE_PAGE (Generic Desktop)

 //һֲbTypeΪ2Ŀ˵ļ;ڼ
 0x09, 0x06, // USAGE (Keyboard)

 //һĿbTypeΪ0Ŀϣ0x01ʾ
 //üһӦüϡǰ;ҳ;Ϊ
 //ͨõļ̡
 0xa1, 0x01, // COLLECTION (Application)

 //һȫĿѡ;ҳΪ̣Keyboard/Keypad(0x07)
 0x05, 0x07, //     USAGE_PAGE (Keyboard/Keypad)

 //һֲĿ˵;СֵΪ0xe0ʵǼCtrl
 //;ֵHID;в鿴
 0x19, 0xe0, //     USAGE_MINIMUM (Keyboard LeftControl)

 //һֲĿ˵;ֵΪ0xe7ʵǼGUI
 0x29, 0xe7, //     USAGE_MAXIMUM (Keyboard Right GUI)

 //һȫĿ˵صݵ߼ֵǷصֵ
 //СΪ0ΪBitʾһСΪ0Ϊ1
 0x15, 0x00, //     LOGICAL_MINIMUM (0)

 //һȫĿ˵߼ֵΪ1
 0x25, 0x01, //     LOGICAL_MAXIMUM (1)

 //һȫĿ˵Ϊ˸
 0x95, 0x08, //     REPORT_COUNT (8)

 //һȫĿ˵ÿĳΪ1bit
 0x75, 0x01, //     REPORT_SIZE (1)

 //һĿ˵8Ϊ1bitͳ
 //ǰȫĿ壩Ϊ룬
 //ΪData,Var,AbsDataʾЩݿԱ䶯Varʾ
 //ЩǶģÿʾһ˼Absʾֵ
 //ĽǣĳֵΪ1ʱͱʾӦļ¡
 //bit0ͶӦ;Сֵ0xe0bit7Ӧ;ֵ0xe7
 0x81, 0x02, //     INPUT (Data,Var,Abs)

 //һȫĿ˵Ϊ1
 0x95, 0x01, //     REPORT_COUNT (1)

 //һȫĿ˵ÿĳΪ8bit
 0x75, 0x08, //     REPORT_SIZE (8)

 //һĿãǰȫĿ֪Ϊ8bit
 //Ϊ1Ϊصһֱ0
 //ֽǱֽڣOEMʹã
 0x81, 0x03, //     INPUT (Cnst,Var,Abs)

 //һȫĿλΪ6
 0x95, 0x06, //   REPORT_COUNT (6)

 //һȫĿÿλ򳤶Ϊ8bit
 //ʵĿҪҲǿԵģΪǰѾһ
 //Ϊ8bitȫĿˡ
 0x75, 0x08, //   REPORT_SIZE (8)

 //һȫĿ߼СֵΪ0
 //ͬϣȫĿҲǿԲҪģΪǰѾһ
 //߼СֵΪ0ȫĿˡ
 0x15, 0x00, //   LOGICAL_MINIMUM (0)

 //һȫĿ߼ֵΪ255
 0x25, 0xFF, //   LOGICAL_MAXIMUM (255)

 //һȫĿѡ;ҳΪ̡
 //ǰѾѡ;ҳΪˣԸĿҪҲԡ
 0x05, 0x07, //   USAGE_PAGE (Keyboard/Keypad)

 //һֲĿ;СֵΪ00ʾûм£
 0x19, 0x00, //   USAGE_MINIMUM (Reserved (no event indicated))

 //һֲĿ;ֵΪ0x65
 0x29, 0x65, //   USAGE_MAXIMUM (Keyboard Application)

 //һĿ˵8bitõģ
 //ΪData,Ary,AbsData˵ǿԱģAry˵
 //Щһ飬ÿ8bitԱʾĳֵ
 //µļ̫ࣨ糬ﶨĳȻ߼̱޷
 //ɨʱЩݷȫ1ƣʾЧ
 //AbsʾЩֵǾֵ
 0x81, 0x00, //     INPUT (Data,Ary,Abs)

 //Ϊ
 //߼СֵǰѾжΪ0ˣʡԡ
 //һȫĿ˵߼ֵΪ1
 0x25, 0x01, //     LOGICAL_MAXIMUM (1)

 //һȫĿ˵Ϊ5
 0x95, 0x05, //   REPORT_COUNT (5)

 //һȫĿ˵ĳΪ1bit
 0x75, 0x01, //   REPORT_SIZE (1)

 //һȫĿ˵ʹõ;ҳΪָʾƣLED
 0x05, 0x08, //   USAGE_PAGE (LEDs)

 //һֲĿ˵;СֵΪ̵ּơ
 0x19, 0x01, //   USAGE_MINIMUM (Num Lock)

 //һֲĿ˵;ֵΪKanaơ
 0x29, 0x05, //   USAGE_MAXIMUM (Kana)

 //һĿݣǰ涨5LED
 0x91, 0x02, //   OUTPUT (Data,Var,Abs)

 //һȫĿλΪ1
 0x95, 0x01, //   REPORT_COUNT (1)

 //һȫĿλ򳤶Ϊ3bit
 0x75, 0x03, //   REPORT_SIZE (3)

 //һĿǰ5bitҪ
 //3bitճһֽڡ
 0x91, 0x03, //   OUTPUT (Cnst,Var,Abs)

 //ĿرǰļϡbSizeΪ0Ժûݡ
 0xc0,        // END_COLLECTION
                                    };
const UINT8 MyProductIDInfo[] = {0x0E,0x03,'k',0,'e',0,'y',0,'5',0,'6',0,'3',0};

/*  */
const UINT8 MyLangDescr[ ] = { 0x04, 0x03, 0x09, 0x04 };

/* Ϣ */
const UINT8 MyManuInfo[ ] = { 0x0E, 0x03, 'w', 0, 'c', 0, 'h', 0, '.', 0, 'c', 0, 'n', 0 };

/* ƷϢ */
const UINT8 MyProdInfo[ ] = { 0x0C, 0x03, 'C', 0, 'H', 0, '5', 0, '6', 0, '3', 0 };

/*******************************************************************************/
/*  */
UINT8V  gUsbConfig;                                                             /* USB豸ñ־ */
UINT8V  gSetupReq;                                                              /* USBƴ */
UINT16V gSetupLen;                                                              /* USBƴ䴫䳤 */
UINT8V  gUsbSpeed;                                                              /* ǰUSBٶ(Ĭ0: ;1:ȫ) */
UINT8V  gUsbInterCfg;                                                           /* USB豸ӿ */
UINT8V  gUsbFlag;                                                               /* USB豸ֲ־,λ0=߸λ,λ1=ȡ豸,λ2=õַ,λ3=ȡ,λ4= */
UINT8   *pDescr;                                                                /* ָ */
UINT32  USB_Recv_Buf[ 512/4 ];                                                  /* USB豸ݽջ */
UINT32  USB_Tran_Buf[ 512/4 ];                                                  /* USB豸ݷͻ */
UINT32V gRecvLen;                                                               /* ǰճ */
UINT8   SendOnces = 1;

volatile UINT8 KEY_SendFlag = 0;

/*******************************************************************************
* Function Name  : USBDev_ModeSet
* Description    : óUSB豸ģʽ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_ModeSet( void )
{
    R8_MISC_CTRL_USB &= ~RB_MISC_USB_ID_EN;                                     /* USB OTG ID pin enable */
    R8_MISC_CTRL_USB |= RB_MISC_USB_ID_ST;                                      /* óUSB豸 */
}

/*******************************************************************************
* Function Name  : USBDev_SpeedSet
* Description    : USB豸ٶ
* Input          : speed---USB_DEV_SPEED_HS: ģʽ
*                          USB_DEV_SPEED_FS: ȫģʽ
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_SpeedSet( UINT8 speed )
{
    if( speed == USB_DEV_SPEED_HS )
    {
        USB_DEV_CONTROL &= ~RB_FORCE_FS;                                        /* ģʽ(Ĭ) */
    }
    else
    {
        USB_DEV_CONTROL |= RB_FORCE_FS;                                         /* ȫģʽ */
    }
}

/*******************************************************************************
* Function Name  : USBDev_SpeedCheck
* Description    : USB豸ٶȼ
* Input          : None
* Output         : None
* Return         : USB_DEV_SPEED_HS: ģʽ; USB_DEV_SPEED_FS: ȫģʽ
*******************************************************************************/

UINT8 USBDev_SpeedCheck( void )
{
     if( USB_DEV_CONTROL & RB_HS_EN )
    {
#if  MY_DEBUG_PRINTF
        printf("Current Device is High Speed!\n");
#endif
#if DELAY_IN_PRINTF
    Delay_ms(2);
#endif // DELAY_IN_PRINTF
        gUsbSpeed = USB_DEV_SPEED_HS;                                           /* ǰUSB豸ٶΪ */
        return( USB_DEV_SPEED_HS );
    }
    else
    {
#if  MY_DEBUG_PRINTF
          printf("Current Device is Full Speed!\n");
#endif
#if DELAY_IN_PRINTF
    Delay_ms(2);
#endif // DELAY_IN_PRINTF
        gUsbSpeed = USB_DEV_SPEED_FS;                                           /* ǰUSB豸ٶΪȫ */
        return( USB_DEV_SPEED_FS );
    }
}

/*******************************************************************************
* Function Name  : USBDev_UsbInt_Enable
* Description    : USB豸USBжʹ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_UsbInt_Enable( void )
{
    /* USBж */
    R8_INT_EN_IRQ_1 |= RB_IE_IRQ_USB;                                           /* USBжʹ */
    R8_INT_EN_IRQ_GLOB |= RB_IE_IRQ_GLOB;                                       /* ȫжʹ */
}

/*******************************************************************************
* Function Name  : USBDev_Init
* Description    : USB豸ʼ
*                  ҪĴã˵㡢FIFO
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_Init( void )
{
    /* ģCH372豸 */
    /* ENDP1_IN Ϊж϶˵㣬ռ8ֽڣʹFIFO0(IN) */
    /* ENDP2_IN Ϊ˵㣬ռ64ֽڣʹFIFO1(IN) */
    /* ENDP2_OUTΪ˵㣬ռ64ֽڣʹFIFO2(OUT) */

    /* λUSB豸 */
    USB_DEV_CONTROL = RB_SFRST;
    while( USB_DEV_CONTROL & 0x10 );                                            /* ȴλ */

    /* λUSB豸FIFO */
    USB_DEV_FIFO0_INFO = RB_FFRST;                                              /* FIFO0 Reset */
    USB_DEV_FIFO1_INFO = RB_FFRST;                                              /* FIFO1 Reset */
    USB_DEV_FIFO2_INFO = RB_FFRST;                                              /* FIFO2 Reset */
    USB_DEV_FIFO3_INFO = RB_FFRST;                                              /* FIFO3 Reset */
    Delay_us( 10 );

#if 1
    /* һ˵ԼFIFO(Ĵֱ÷ʽ) */
    USB_DEV_FIFO_CONFIG    = 0x00222223;                                        /* R(0x1AC) */
    USB_DEV_EP1_4_MAP      = 0x33332130;                                        /* R(0x1A0) FIFO0(ENDP1_IN)FIFO1(ENDP2_IN)FIFO2(ENDP2_OUT) */
    USB_DEV_FIFO_MAP       = 0x0F021211;                                        /* R(0x1A8) */
    USB_DEV_EP1_IN_MAXPKS  = 0x00000008;                                        /* R(0x160) EP1_IN_MAXPKS  = 8 bytes */
    USB_DEV_EP2_IN_MAXPKS  = 0x00000040;                                        /* R(0x164) EP2_IN_MAXPKS  = 64 bytes */
    USB_DEV_EP2_OUT_MAXPKS = 0x00000040;                                        /* R(0x184) EP2_OUT_MAXPKS = 64 bytes */
#endif

#if 0
    /* ˵ԼFIFO(÷ʽ) */

    /* ˵1 */
    USBDev_EPx_Init( ENDP1,
                     ENDP_TYPE_IN,                                              /* ENDP1 IN˵ */
                     FIFO_TYPE_INTERRUPT,                                       /* ˵Ϊж϶˵ */
                     FIFO_DIR_IN,                                               /* FIFOΪΪIN */
                     FIFO_BK_NUM_SINGLE,                                        /* FIFOΪ,512ֽ */
                     FIFO_BK_SIZE_0,                                            /* FIFOССڵ512ֽ */
                     FIFO_NUM_0,                                                /* ö˵ӦFIFOΪFIFO 0 */
                     FIFO_ENABLE,                                               /* ʹܸö˵ӦFIFO */
                     USB_EP1_IN_MAX_PKT );                                      /* øö˵С */

    /* ˵2 */
    USBDev_EPx_Init( ENDP2,
                     ENDP_TYPE_IN,                                              /* ENDP2 IN˵ */
                     FIFO_TYPE_BULK,                                            /* ˵Ϊ˵ */
                     FIFO_DIR_IN,                                               /* FIFOΪΪIN */
                     FIFO_BK_NUM_SINGLE,                                        /* FIFOΪ,512ֽ */
                     FIFO_BK_SIZE_0,                                            /* FIFOССڵ512ֽ */
                     FIFO_NUM_1,                                                /* ö˵ӦFIFOΪFIFO 1 */
                     FIFO_ENABLE,                                               /* ʹܸö˵ӦFIFO */
                     USB_EP2_IN_MAX_PKT );                                      /* øö˵С */

    /* ˵2 */
    USBDev_EPx_Init( ENDP2,
                     ENDP_TYPE_OUT,                                             /* ENDP2 OUT˵ */
                     FIFO_TYPE_BULK,                                            /* ˵Ϊ˵ */
                     FIFO_DIR_OUT,                                              /* FIFOΪΪOUT */
                     FIFO_BK_NUM_SINGLE,                                        /* FIFOΪ,512ֽ */
                     FIFO_BK_SIZE_0,                                            /* FIFOССڵ512ֽ */
                     FIFO_NUM_2,                                                /* ö˵ӦFIFOΪFIFO 2 */
                     FIFO_ENABLE,                                               /* ʹܸö˵ӦFIFO */
                     USB_EP2_OUT_MAX_PKT );                                     /* øö˵С */
#endif

    /* USB豸жʹ */
    /* óʹ˳FIFOжж,ԸҪرӦж */
    USB_DEV_MASK_INT_GROP  = 0x00000000;                                        /* Enable USB Device interrupt of source group 012*/
    USB_DEV_MASK_INT_GROP0 = 0x00000000;
    USB_DEV_MASK_INT_GROP1 = RB_F3_IN_INT | RB_F2_IN_INT | RB_F1_IN_INT |
        RB_F0_IN_INT;                                                           /* ֹFIFOϴж */
    USB_DEV_MASK_INT_GROP2 = 0x00000000 | RB_MDMA_CMPLT ;

    /* ʹоƬ(Ҫǿȫģʽ) */
    USB_DEV_CONTROL = RB_CHIP_EN | RB_GLINT_EN;                                 /* ʹоƬʹȫжϡʹܸ */
    USBDev_SpeedSet( USB_DEV_SPEED_FS );                                        /* ǿȫģʽ */
    Delay_ms( 1 );
    USB_PHY_TEST_MODE &= ~RB_UNPLUG;                                            /* Ĵ(0x114)λ00,֪ͨ */
}

/*******************************************************************************
* Function Name  : USB_Dev_SetAddress
* Description    : USB豸ַ
* Input          : addre---豸ַ
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_SetAddress( UINT8 addre )
{
    USB_DEV_ADDRESS = ( USB_DEV_ADDRESS & RB_AFT_CONF ) | addre;                /* ַĴ7λ */
}

/*******************************************************************************
* Function Name  : USBDev_SetConfig
* Description    : USB豸ñ־λ
*                  ע: ڴSET_CONFIGURATIONøñ־λ,򲻻Ӧ
*                        ǿƶ˵Ĵ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_SetConfig( void )
{
    USB_DEV_ADDRESS |= RB_AFT_CONF;                                             /* ñ־λ */

#if  MY_DEBUG_PRINTF
    printf("USB Enumerate Success!\n ");
#endif
#if DELAY_IN_PRINTF
    Delay_ms(2);
#endif // DELAY_IN_PRINTF

}

/*******************************************************************************
* Function Name  : USBDev_EP0_Stall
* Description    : USB豸STALL
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_EP0_Stall( void )
{
    USB_DEV_CX_CONF_FIFO_STATUS |= RB_CX_STL;                                   /* reg=0x120 */
}

/*******************************************************************************
* Function Name  : USBDev_EPx_IN_Stall
* Description    : USB豸EPxIN˵STALL
* Input          : epx_num---˵(ΧΪ:1---8)
*                  mode------ģʽ(1ΪSTALL, 0ΪSTALL)
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_EPx_IN_Stall( UINT8 epx_num, UINT8 mode )
{
    UINT32 addr;
    UINT32 reg;

    addr = USB_BASE_ADDR + 0x160 + 4 * ( epx_num - 1 );
    reg  = (*((PUINT32V)addr));
    if( mode )
    {
        (*((PUINT32V)addr)) = reg | RB_STL_IEPx;
    }
    else
    {
        (*((PUINT32V)addr)) = reg & ( ~RB_STL_IEPx );
    }
}

/*******************************************************************************
* Function Name  : USBDev_EPx_OUT_Stall
* Description    : USB豸EPxOUT˵STALL
* Input          : epx_num---˵(ΧΪ:1---8)
*                  mode------ģʽ(1ΪSTALL, 0ΪSTALL)
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_EPx_OUT_Stall( UINT8 epx_num, UINT8 mode )
{
    UINT32 addr;
    UINT32 reg;

    addr = USB_BASE_ADDR + 0x180 + 4 * ( epx_num - 1 );
    reg  = (*((PUINT32V)addr));

    if( mode )
    {
        (*((PUINT32V)addr)) = reg | RB_STL_OEPx;
    }
    else
    {
        (*((PUINT32V)addr)) = reg & ( ~RB_STL_OEPx );
    }
}

/*******************************************************************************
* Function Name  : USBDev_EPx_IN_ResetToggle
* Description    : USB豸EPxIN˵㸴λͬλ
* Input          : epx_num---˵(ΧΪ:1---8)
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_EPx_IN_ResetToggle( UINT8 epx_num )
{
    UINT32 addr;
    UINT32 reg;

    addr = USB_BASE_ADDR + 0x160 + 4 * ( epx_num - 1 );
    reg  = (*((PUINT32V)addr));
    (*((PUINT32V)addr)) = reg | RB_RSTG_IEPx;
    Delay_us( 5 );
    (*((PUINT32V)addr)) = reg & ( ~RB_RSTG_IEPx );
}

/*******************************************************************************
* Function Name  : USBDev_EPx_OUT_ResetToggle
* Description    : USB豸EPxOUT˵㸴λͬλ
* Input          : epx_num---˵(ΧΪ:1---8)
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_EPx_OUT_ResetToggle( UINT8 epx_num )
{
    UINT32 addr;
    UINT32 reg;

    addr = USB_BASE_ADDR + 0x180 + 4 * ( epx_num - 1 );
    reg  = (*((PUINT32V)addr));
    (*((PUINT32V)addr)) = reg | RB_RSTG_OEPx;
    Delay_us( 5 );
    (*((PUINT32V)addr)) = reg & ( ~RB_RSTG_OEPx );
}

/*******************************************************************************
* Function Name  : USBDev_EPx_IN_SetMaxPKS
* Description    : USB豸EPxIN˵
* Input          : epx_num---˵(ΧΪ:1---8)
*                  maxpks_len---С
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_EPx_IN_SetMaxPKS( UINT8 epx_num, UINT16 maxpks_len )
{
    UINT32 addr;
    UINT32 reg;

    maxpks_len = maxpks_len & 0x7FF;
    addr = USB_BASE_ADDR + 0x160 + 4 * ( epx_num - 1 );
    reg  = (*((PUINT32V)addr));
    (*((PUINT32V)addr)) = ( reg & 0xFFFFFC00 ) | maxpks_len;
}

/*******************************************************************************
* Function Name  : USBDev_EPx_OUT_SetMaxPKS
* Description    : USB豸EPxOUT˵
* Input          : epx_num---˵(ΧΪ:1---8)
*                  maxpks_len---С
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_EPx_OUT_SetMaxPKS( UINT8 epx_num, UINT16 maxpks_len )
{
    UINT32 addr;
    UINT32 reg;

    maxpks_len = maxpks_len & 0x7FF;
    addr = USB_BASE_ADDR + 0x180 + 4 * ( epx_num - 1 );
    reg  = (*((PUINT32V)addr));
    (*((PUINT32V)addr)) = ( reg & 0xFFFFFC00 ) | maxpks_len;
}

/*******************************************************************************
* Function Name  : USBDev_EPx_Init
* Description    : USB豸˵
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_EPx_Init( UINT8 epx_num,
                      UINT8 epx_type,
                      UINT8 fifo_type,
                      UINT8 fifo_dir,
                      UINT8 fifo_bk_num,
                      UINT8 fifo_bk_size,
                      UINT8 fifo_num,
                      UINT8 fifo_en,
                      UINT16 maxpks_len )
{
    UINT32 addr;
    UINT32 reg1, reg2, mask;

    /* øö˵INOUTС */
    if( epx_type == ENDP_TYPE_IN )
    {
        USBDev_EPx_IN_SetMaxPKS( epx_num, maxpks_len );                         /* EPx_IN˵С */
    }
    else if( epx_type == ENDP_TYPE_OUT )
    {
        USBDev_EPx_OUT_SetMaxPKS( epx_num, maxpks_len );                        /* EPx_OUT˵С */
    }

    /* øö˵INOUTӦFIFO */
    /* Endpoint1-4 Map Register(Addr=0X1A0)ԼEndpoint5-8 Map Register(Addr=0X1A4)*/
    if( epx_num <= 4 )
    {
        addr = USB_BASE_ADDR + 0x1A0;
    }
    else
    {
        addr = USB_BASE_ADDR + 0x1A4;
        epx_num = epx_num - 4;
    }
    reg1 = (*((PUINT32V)addr));                                                 /* ȡĴ0X1A00X1A4ԭֵ */

    mask = 0x00000003;
    reg2 = fifo_num;
    if( epx_type == ENDP_TYPE_OUT )
    {
        mask = mask << 4;
        reg2 = reg2 << 4;
    }
    mask = mask << ( ( epx_num - 1 ) * 8 );
    reg2 = reg2 << ( ( epx_num - 1 ) * 8 );
    reg1 = ( reg1 & ( ~mask ) ) | reg2;
    reg1 = reg1 & 0x33333333;
    (*((PUINT32V)addr)) = reg1;

    /* FIFO Map Register(Addr=0X1A8) */
    mask = 0x000000FF;
    reg2 = ( ( fifo_dir & 0x03 ) << 4 ) | epx_num;
    mask = mask << ( fifo_num * 8 );
    reg2 = reg2 << ( fifo_num * 8 );
    reg1 = USB_DEV_FIFO_MAP;
    USB_DEV_FIFO_MAP = ( reg1 & ( ~mask ) ) | reg2;

    /* FIFO Configuration Register(Addr=0X1AC) */
    mask = 0x000000FF;
    reg2 = fifo_type | ( ( fifo_bk_num & 0x03 ) << 2 ) | ( fifo_bk_size << 4 ) | ( fifo_en << 5 );
    mask = mask << ( fifo_num * 8 );
    reg2 = reg2 << ( fifo_num * 8 );
    reg1 = USB_DEV_FIFO_CONFIG;
    USB_DEV_FIFO_CONFIG = ( reg1 & ( ~mask ) ) | reg2;
}

/*******************************************************************************
* Function Name  : USBDev_RD_FIFOx
* Description    : FIFOжȡUSB
* Input          : fifonum---FIFO
*                  len-------ݳ
*                  *pbuf-----ݴ洢
* Output         : None
* Return         : len---ʵʶȡ
*******************************************************************************/

UINT32 USBDev_RD_FIFOx( UINT8 fifonum, UINT32 len, UINT8 *pbuf )
{
    UINT32 i = 0;

    if( ( fifonum != USB_DMA_ACC_F0 ) && ( fifonum != USB_DMA_ACC_F1 ) &&
        ( fifonum != USB_DMA_ACC_F2 ) && ( fifonum != USB_DMA_ACC_F3 ) &&
        ( fifonum != USB_DMA_ACC_CXF ) )
    {
        USB_DEV_DMA_TARGET_FIFO = USB_DMA_ACC_NO;                               /* DMAӦκFIFO */
        return( 0x00 );
    }

#if  MY_DEBUG_PRINTF
    printf("USBDev_RD_FIFOx:\n ");
#endif
#if DELAY_IN_PRINTF
    Delay_ms(2);
#endif // DELAY_IN_PRINTF
    USB_DEV_DMA_TARGET_FIFO = fifonum;                                          /* DMAӦFIFO */
    if( fifonum == USB_DMA_ACC_CXF )                                            /* SETUPֱӶȡ */
    {
        if( len == 8 )
        {
            *(PUINT32)pbuf = USB_DEV_SETUP_CMD_RPORT;
            *(PUINT32)( pbuf + 4 ) = USB_DEV_SETUP_CMD_RPORT;
        }
        else
        {
            len = 0;
        }
    }
    else
    {
        if( USB_DEV_DMA_SET1 & RB_DMA_ABORT )                                   /* жǷDMA_ABORT */
        {
            USB_DEV_DMA_SET1 |= RB_CLRFIFO_DMAABORT;
            len = 0x00;
        }
        else
        {
            /* FIFO x Instruction and Byte Count Register(0X1B0--0X1BC)жȡӦFIFOݵĳ */
            if( fifonum == USB_DMA_ACC_F0 )
            {
                i = USB_DEV_FIFO0_INFO & 0x7FF;
            }
            else if( fifonum == USB_DMA_ACC_F1 )
            {
                i = USB_DEV_FIFO1_INFO & 0x7FF;
            }
            else if( fifonum == USB_DMA_ACC_F2 )
            {
                i = USB_DEV_FIFO2_INFO & 0x7FF;
            }
            else if( fifonum == USB_DMA_ACC_F3 )
            {
                i = USB_DEV_FIFO3_INFO & 0x7FF;
            }
            if( len > i )
            {
                len = i;                                                        /* ȡȴʵʳ,ȡʵʳ */
            }
#if MY_DEBUG_PRINTF
            printf("rd_len:%04x\n",(UINT32)len);
#endif
            /* ͨDMAݴRAMFIFO */
            USB_DEV_DMA_SET1 = len << 8;                                        /* USB DMAͨų */
            USB_DEV_DMA_SET2 = (UINT32)pbuf;                                    /* USB DMAͨŻʼַ */
            USB_DEV_DMA_SET1 = USB_DEV_DMA_SET1 | RB_DMA_START;                 /* USB DMAFIFOݴ */
            while( USB_DEV_DMA_SET1 & RB_DMA_START );                           /* ȴDMA */
            USB_DEV_INT_GROP2 = USB_DEV_INT_GROP2 | RB_DMA_CMPLT;               /* DMAɱ־ */
        }
    }
    USB_DEV_DMA_TARGET_FIFO = USB_DMA_ACC_NO;                                   /* DMAӦκFIFO */
    return( len );
}

/*******************************************************************************
* Function Name  : USBDev_WR_FIFOx
* Description    : FIFOдUSB
* Input          : fifonum---FIFO
*                  len-------ݳ
*                  *pbuf-----ݴ洢
* Output         : None
* Return         : len---д볤
*******************************************************************************/

UINT32 USBDev_WR_FIFOx( UINT8 fifonum, UINT32 len, UINT8 *pbuf )
{
    if( ( fifonum != USB_DMA_ACC_F0 ) && ( fifonum != USB_DMA_ACC_F1 ) &&
        ( fifonum != USB_DMA_ACC_F2 ) && ( fifonum != USB_DMA_ACC_F3 ) &&
        ( fifonum != USB_DMA_ACC_CXF ) )
    {
        USB_DEV_DMA_TARGET_FIFO = USB_DMA_ACC_NO;                               /* DMAӦκFIFO */
        return( 0x00 );
    }

#if  MY_DEBUG_PRINTF
    printf("USBDev_WR_FIFOx:\n ");
#endif
#if DELAY_IN_PRINTF
    Delay_ms(2);
#endif // DELAY_IN_PRINTF
    if( USB_DEV_DMA_SET1 & RB_DMA_ABORT )                                       /* жǷDMA_ABORT */
    {
        USB_DEV_DMA_SET1 = RB_CLRFIFO_DMAABORT;
        return( 0x00 );
    }
    else
    {
#if  MY_DEBUG_PRINTF
        printf("wr_len:%04x\n",(UINT32)len);
#endif
#if DELAY_IN_PRINTF
    Delay_ms(2);
#endif // DELAY_IN_PRINTF

        /* ͨDMAݴFIFORAM */
        USB_DEV_DMA_TARGET_FIFO = fifonum;                                      /* USB DMAӦFIFO */
        USB_DEV_DMA_SET1 = ( len  << 8 ) | RB_DMA_TYPE;                         /* USB DMAͨų */

        /* ȲΪ0DMAݴ */
        if( len )
        {
            USB_DEV_DMA_SET2 = ( UINT32 )pbuf;                                  /* USB DMAͨŻʼַ */
            USB_DEV_DMA_SET1 = USB_DEV_DMA_SET1 | RB_DMA_START;                 /* USB DMAFIFOݴ */
            while( ( USB_DEV_DMA_SET1 & RB_DMA_START ) );                       /* ȴDMA */
        }
        USB_DEV_INT_GROP2 = USB_DEV_INT_GROP2 | RB_DMA_CMPLT;                   /* DMAɱ־ */
        USB_DEV_DMA_TARGET_FIFO = USB_DMA_ACC_NO;                               /* DMAӦκFIFO */
        return( len );
    }
}

/*******************************************************************************
* Function Name  : USBDev_EP0_Setup_Deal
* Description    : USBƶ˵Setup
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_EP0_Setup_Deal( void )
{
    UINT32 len;
    UINT32 status;
    UINT8  buf[ 8 ];
    USB_SETUP_REQ SetupReqBuf;

    /* ȡSETUP */
    len = USBDev_RD_FIFOx( USB_DMA_ACC_CXF, 8, (PUINT8)&SetupReqBuf );          /* FIFO4жȡSETUP */
    if( len == sizeof( USB_SETUP_REQ ) )                                        /* жϳǷSetup */
    {
        gSetupLen = ( SetupReqBuf.wLengthH << 8 ) + SetupReqBuf.wLengthL;       /* 洫䳤 */
        gSetupReq = SetupReqBuf.bRequest;                                       /* 浱ǰ */

        /* ǰSETUP */
        len = 0;                                                                /* ĬϴΪ0 */
        status = 0x00;                                                          /* ĬϲΪɹ״̬ */
        if( ( SetupReqBuf.bReqType & USB_REQ_TYPE_MASK ) != USB_REQ_TYPE_STAND )
        {
            /* 󣬲 */
            if(( SetupReqBuf.bReqType & (USB_REQ_TYPE_MASK | 0x01) )== 0x21)    /**/
            {
                if(SetupReqBuf.bRequest==0x09)
                {
                    printf("class req%x\n",SetupReqBuf.bReqType);
                    KEY_SendFlag = 1;
                }
                else if(SetupReqBuf.bRequest==0x0a)
                {
                    printf("Idle req\n");
                }
                else
                {
                    status = 0xff;
                }
            }
            else
            {
                status = 0xFF;                                                   /* ʧ */
            }
        }
        else
        {
            /* ׼ */
            switch( gSetupReq )
            {
                case USB_REQ_GET_DESCR:                                         /* CMD: GET_DESCR */
                    #if  MY_DEBUG_PRINTF
                                        printf("USB_REQ_GET_DESCR:\n ");
                    #endif
                    #if DELAY_IN_PRINTF
                        Delay_ms(2);
                    #endif // DELAY_IN_PRINTF
                    switch( SetupReqBuf.wValueH )
                    {
                        case 1:
                            gUsbFlag |= DEF_BIT_USB_DEV_DESC;                   /* ûȡ豸־ */
                            pDescr = (PUINT8)( &MyDevDescr[ 0 ] );
                            len = sizeof( MyDevDescr );
                            USBDev_SpeedCheck(  );                              /* жϵǰUSB豸ٶ */
                            break;

                        case 2:
                            gUsbFlag |= DEF_BIT_USB_CFG_DESC;                   /* ûȡ־ */
                            gUsbFlag &= ~DEF_BIT_USB_HS;                        /* ȫٱ־ */
                            pDescr = (PUINT8)( &My_FS_CfgDescr[ 0 ] );
                            len = sizeof( My_FS_CfgDescr );
                            break;

                        case 3:
                            switch( SetupReqBuf.wValueL )
                            {
                                case 1:
                                    pDescr = (PUINT8)( &MyManuInfo[ 0 ] );      /* ȡַ */
                                    len = sizeof( MyManuInfo );
                                    break;

                                case 2:
                                    pDescr = (PUINT8)( &MyProdInfo[ 0 ] );      /* ȡƷַ */
                                    len = sizeof( MyProdInfo );
                                    break;

                                case 0:
                                    pDescr = (PUINT8)( &MyLangDescr[ 0 ] );     /* ȡIDַ */
                                    len = sizeof( MyLangDescr );
                                    break;

                                case 3:
                                    pDescr = (PUINT8)(&MyProductIDInfo[0]);
                                    len = sizeof(MyProductIDInfo);
                                    break;

                                default:
                                    status = 0xFF;                              /* ʧ */
                                    break;
                            }
                            break;

                        case 0X22:                                              /*ȡ*/
                            pDescr = (PUINT8)(&Key_ReportDescrip[0]);
                            len = sizeof(Key_ReportDescrip);
                            printf("report\n");
                            break;

                        default:
                            status = 0xFF;                                      /* ʧ */
                            break;
                    }
                    break;

                case USB_REQ_SET_ADDRESS:                                       /* CMD: SET_ADDRESS */
                    gUsbFlag |= DEF_BIT_USB_ADDRESS;                            /* õַ־ */
                    if( SetupReqBuf.wValueL < 0x80 )
                    {
                        USBDev_SetAddress( SetupReqBuf.wValueL );               /* õַ: עооƬһSETUPʱõַЧ */
                    }
                    else
                    {
                        status = 0xFF;                                          /* ʧ */
                    }
                    break;

                case USB_REQ_GET_CONFIG:                                        /* CMD: GET_CONFIG */
                    buf[ 0 ] = gUsbConfig;
                    len = 0x01;
                    pDescr = buf;
                    break;

                case USB_REQ_SET_CONFIG:                                        /* CMD: SET_CONFIG */
                    gUsbFlag |= DEF_BIT_USB_SET_CFG;                            /* ñ־ */
                    gUsbConfig = SetupReqBuf.wValueL;
                    USBDev_SetConfig( );                                        /* USBλ */
                    break;

                case USB_REQ_CLR_FEATURE:                                       /* Clear Feature */
                    if( ( SetupReqBuf.bReqType & 0x1F ) == 0x00 )               /* 豸 */
                    {
                        if( ( ( ( UINT16 )SetupReqBuf.wValueH << 8 ) | SetupReqBuf.wValueL ) == 0x01 )
                        {
                            if( My_FS_CfgDescr[ 7 ] & 0x20 )
                            {
                                gUsbFlag &= ~DEF_BIT_USB_WAKE;                  /* ûѽֹ־ */
                            }
                            else
                            {
                                status = 0xFF;                                  /* ʧ */
                            }
                        }
                        else
                        {
                            status = 0xFF;                                      /* ʧ */
                        }
                    }
                    else if( ( SetupReqBuf.bReqType & 0x1F ) == 0x02 )          /* ˵ */
                    {
                        switch( ( ( UINT16 )SetupReqBuf.wIndexH << 8 ) | SetupReqBuf.wIndexL )
                        {
                            case 0x82:
                                USBDev_EPx_IN_Stall( 0x02, 0x00 );              /* STALL */
                                USBDev_EPx_IN_ResetToggle( 0x02 );              /* λͬ־ */
                                break;

                            case 0x02:
                                USBDev_EPx_OUT_Stall( 0x02, 0x00 );             /* STALL */
                                USBDev_EPx_OUT_ResetToggle( 0x02 );             /* λͬ־ */
                                break;

                            case 0x81:
                                USBDev_EPx_IN_Stall( 0x01, 0x00 );              /* STALL */
                                USBDev_EPx_IN_ResetToggle( 0x01 );              /* λͬ־ */
                                break;

                            case 0x01:
                                USBDev_EPx_OUT_Stall( 0x01, 0x00 );             /* STALL */
                                USBDev_EPx_OUT_ResetToggle( 0x01 );             /* λͬ־ */
                                break;

                            default:
                                status = 0xFF;                                  /* ʧ */
                                break;
                        }
                    }
                    else
                    {
                        status = 0xFF;                                           /* ʧ */
                    }
                    break;

                case USB_REQ_SET_FEATURE:                                       /* Set Feature */
                    if( ( SetupReqBuf.bReqType & 0x1F ) == 0x00 )               /* 豸 */
                    {
                        if( ( ( ( UINT16 )SetupReqBuf.wValueH << 8 ) | SetupReqBuf.wValueL ) == 0x01 )
                        {
                              if( My_FS_CfgDescr[ 7 ] & 0x20 )
                            {
                                  gUsbFlag |= DEF_BIT_USB_WAKE;                 /* ûʹܱ־ */
                            }
                            else
                            {
                                status = 0xFF;                                  /* ʧ */
                            }
                        }
                        else
                        {
                            status = 0xFF;                                      /* ʧ */
                        }
                    }
                    else if( ( SetupReqBuf.bReqType & 0x1F ) == 0x02 )          /* ö˵ */
                    {
                        if( ( ( ( UINT16 )SetupReqBuf.wValueH << 8 ) | SetupReqBuf.wValueL ) == 0x00 )
                        {
                            switch( ( ( UINT16 )SetupReqBuf.wIndexH << 8 ) | SetupReqBuf.wIndexL )
                            {
                                case 0x82:
                                    USBDev_EPx_IN_Stall( 0x02, 0x01 );          /* ö˵2 IN STALL */
                                    break;

                                case 0x02:
                                    USBDev_EPx_OUT_Stall( 0x02, 0x01 );         /* ö˵2 OUT Stall */
                                    break;

                                case 0x81:
                                    USBDev_EPx_IN_Stall( 0x01, 0x01 );          /* ö˵1 IN STALL */
                                    break;

                                default:
                                    status = 0xFF;                              /* ʧ */
                                    break;
                            }
                        }
                        else
                        {
                            status = 0xFF;                                      /* ʧ */
                        }
                    }
                    else
                    {
                        status = 0xFF;                                          /* ʧ */
                    }
                    break;

                case USB_REQ_SET_INTERF:                                        /* Set Interface */
                    gUsbInterCfg = SetupReqBuf.wIndexL;                         /* ӿ */
                    break;

                case USB_REQ_GET_INTERF:                                        /* CMD: GET_INTERF */
                    buf[ 0 ] = gUsbInterCfg;
                    pDescr = buf;
                    len = 1;
                    break;

                case USB_REQ_GET_STATUS:                                        /* Get Status */
                    if( ( SetupReqBuf.bReqType & 0x1F ) == 0x00 )               /* ȡ豸״̬ */
                    {
                        if( ( ( UINT16 )SetupReqBuf.wValueH << 8 | SetupReqBuf.wValueL ) == 0x00 &&
                            ( ( UINT16 )SetupReqBuf.wIndexH << 8 | SetupReqBuf.wIndexL ) == 0x00 )
                        {
                            buf[ 0 ] = ( gUsbFlag & DEF_BIT_USB_WAKE ) ? 0x02 : 0x00;
                            buf[ 1 ] = 0x00;
                            pDescr = buf;
                            len = 2;
                        }
                        else
                        {
                            status = 0xFF;                                      /* ʧ */
                        }
                    }
                    else if( ( SetupReqBuf.bReqType & 0x1F ) == 0x02 )          /* ȡ˵״̬ */
                    {
                        if( ( ( UINT16 )SetupReqBuf.wValueH << 8 | SetupReqBuf.wValueL ) == 0x00 )
                        {
                            switch( ( UINT16 )SetupReqBuf.wIndexH << 8 | SetupReqBuf.wIndexL )
                            {
                                case 0x82:
                                    buf[ 0 ] = ( USB_DEV_EP2_IN_MAXPKS & RB_STL_IEPx ) ? 0x01 : 0x00;
                                    break;

                                case 0x02:
                                    buf[ 0 ] = ( USB_DEV_EP2_OUT_MAXPKS & RB_STL_OEPx ) ? 0x01 : 0x00;
                                    break;

                                case 0x81:
                                    buf[ 0 ] = ( USB_DEV_EP1_IN_MAXPKS & RB_STL_IEPx ) ? 0x01 : 0x00;
                                    break;

                                default:
                                    status = 0xFF;                              /* ʧ */
                                    break;
                            }
                            buf[ 1 ] = 0x00;
                            len = 2;
                            pDescr = buf;
                        }
                        else
                        {
                            status = 0xFF;                                      /* ʧ */
                        }
                    }
                    else
                    {
                        status = 0xFF;                                          /* ʧ */
                    }
                    break;

                default:
                    status = 0xFF;                                              /* ʧ */
                    break;
            }
        }
    }
    else
    {
        status = 0xFF;                                                          /* ʧ */
    }

    if( status == 0xFF )
    {
        /* ʧ */
        USBDev_EP0_Stall( );                                                    /* ˵0STALL */
    }
    else
    {
        gSetupLen = gSetupLen < len ? gSetupLen : len;                          /* ܳ */
        if( gSetupLen )
        {
            if( SetupReqBuf.bReqType & 0x80 )                                   /* ϴ */
            {
                len = gSetupLen>=USB_EP0_MAX_PKT ? USB_EP0_MAX_PKT : gSetupLen; /* 㱾δ䳤 */
                memcpy( USB_Tran_Buf, pDescr, len );                            /* FlashROMеconstݸƵRAMУԱDMAȡ */
                  USBDev_WR_FIFOx( USB_DMA_ACC_CXF, len, (UINT8 *)USB_Tran_Buf ); /* ϴݵFIFO 4 */
                gSetupLen -= len;                                               /* 㴫䳤 */
                pDescr += len;                                                  /* ָƫ */
                if( gSetupLen == 0 )
                {
                    USB_DEV_CX_CONF_FIFO_STATUS |= RB_DONE;                     /* ȫϴ,ö˵0ݴ */
                }
            }
        }
        else
        {
            USB_DEV_CX_CONF_FIFO_STATUS |= RB_DONE;                             /* ö˵0ݴ */
        }
    }
}

/*******************************************************************************
* Function Name  : USBDev_EP0_IN_Deal
* Description    : USBƶ˵IN
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_EP0_IN_Deal( void )
{
    UINT16 len;

    switch( gSetupReq )
    {
        case USB_REQ_GET_DESCR:
            len = gSetupLen >= USB_EP0_MAX_PKT ? USB_EP0_MAX_PKT : gSetupLen;   /* δ䳤 */
            memcpy( USB_Tran_Buf, pDescr, len );                                /* FlashROMеconstݸƵRAMУԱDMAȡ */
            USBDev_WR_FIFOx( USB_DMA_ACC_CXF, len, (UINT8 *)USB_Tran_Buf );     /* ϴ */
            gSetupLen -= len;
            pDescr += len;
            if( len < USB_EP0_MAX_PKT )                                         /* жǷȫϴ */
            {
                USB_DEV_CX_CONF_FIFO_STATUS |= RB_DONE;                         /* ö˵0ݴ */
            }
            break;

        default:
            break;
    }
}

/*******************************************************************************
* Function Name  : USBDev_EP0_OUT_Deal
* Description    : USBƶ˵OUT
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_EP0_OUT_Deal( void )
{

}

/*******************************************************************************
* Function Name  : USBDev_EP2_IN_Deal
* Description    : USB˵2 IN
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_EP2_IN_Deal( void )
{
#if  MY_DEBUG_PRINTF
    printf("USBDev_EP2_IN_Deal...\n");
#endif
    /* ϴе */
    if( gUsbSpeed == USB_DEV_SPEED_HS )                                         /* ģʽ */
    {
        USBDev_WR_FIFOx( USB_DMA_ACC_F1, gRecvLen, (PUINT8)USB_Tran_Buf );
    }
    else
    {
           USBDev_WR_FIFOx( USB_DMA_ACC_F1, gRecvLen, (PUINT8)USB_Tran_Buf );
    }
}

/*******************************************************************************
* Function Name  : USBDev_EP2_OUT_Deal
* Description    : USB˵2 OUT
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_EP2_OUT_Deal( void )
{
    UINT32    len;

#if  MY_DEBUG_PRINTF
    printf("USBDev_EP2_OUT_Deal...\n");
#endif
#if DELAY_IN_PRINTF
    Delay_ms(2);
#endif // DELAY_IN_PRINTF

    /* ´ȡ */
    if( gUsbSpeed == USB_DEV_SPEED_HS )                                         /* ģʽ */
    {
        len = USBDev_RD_FIFOx( USB_DMA_ACC_F2, 512, (PUINT8)USB_Recv_Buf );     /* ȡEP2_OUT */
    }
    else
    {
        len = USBDev_RD_FIFOx( USB_DMA_ACC_F2, 64, (PUINT8)USB_Recv_Buf );      /* ȡEP2_OUT */
    }

    /* ȡͨϴ˵㷵 */
    gRecvLen = len;
    for( len = 0; len < gRecvLen; len++ )
    {
        USB_Tran_Buf[ len ] = ~USB_Recv_Buf[ len ];
    }
    USBDev_EP2_IN_Deal( );
}

/*******************************************************************************
* Function Name  : USBDev_EPx_Up_0BytePack
* Description    : USB豸EPxIN˵ϴ0Ȱ
* Input          : epx_num---˵(ΧΪ:1---8)
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_EPx_Up_0BytePack( UINT8 epx_num )
{
    UINT32 addr;
    UINT32 reg;

    addr = USB_BASE_ADDR + 0x160 + 4 * ( epx_num - 1 );
    reg  = (*((PUINT32V)addr));
    (*((PUINT32V)addr)) = reg | RB_TX0BYTE_IEPx;
}

/*******************************************************************************
* Function Name  : USBDev_IRQHandler
* Description    : USBжϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_IRQHandler( void )
{
    UINT32 grp_int, intstatus;
    /* жǷUSB豸жϲ, */
    if( USB_GL_INT_STATUS & RB_DEV_INT )                                        /* жǷUSB豸жϲ */
    {
        USB_GL_INT_STATUS = USB_GL_INT_STATUS | RB_DEV_INT;                     /* λд10 */

        grp_int = USB_DEV_INT_GROP;                                             /* ȡUSBжϵжԴ */
        if( grp_int & 0x01 )                                                    /* grop0: control transfer interrupt */
        {
            printf("grp1\n");
            intstatus = USB_DEV_INT_GROP0;
            if( intstatus & RB_CX_COMABORT_INT  )                               /* R(0x140)λ5 ƴʧ */
            {
                USB_DEV_INT_GROP0 = intstatus | RB_CX_COMABORT_INT;             /* USB˵0 OUTж(д10) */
            }
            if( intstatus & RB_CX_COMFAIL_INT )                                 /* R(0x140)λ4ƶ˵INOUTʧ */
            {
                /* жλֻ,Ӳ0 */
                USBDev_EP0_Stall( );                                            /* ˵0STALL */
            }
            if( intstatus & RB_CX_COMEND )                                      /* R(0x140)λ3״̬׶ */
            {
                /* ƴ״̬׶ */
                /* жλֻ,Ӳ0 */
            }
            if( intstatus & RB_CX_OUT_INT )                                     /* R(0x140)λ2ƶ˵OUTж */
            {
                /* ƶ˵OUTжϴ */
                USBDev_EP0_OUT_Deal( );
                USB_DEV_MASK_INT_GROP0 |= RB_CX_OUT_INT;
                /* жλֻ,Ӳ0 */
            }
            if( intstatus & RB_CX_IN_INT )                                      /* R(0x140)λ1ƶ˵INж */
            {
                /* ƶ˵INжϴ */
                USBDev_EP0_IN_Deal( );

                /* жλֻ,Ӳ0 */
            }
            if( intstatus & RB_CX_SETUP_INT )                                   /* R(0x140)λ0ƶ˵SETUPж */
            {
                /* ƶ˵SETUPжϴ */
                USBDev_EP0_Setup_Deal( );

                /* жλֻ,Ӳ0 */
            }
        }
        if( grp_int & 0x02 )   //ж1жϲ                              /* grop1: bulk/ISO/Interrupt interrupt */
        {
            printf("grp2\n");
            intstatus = USB_DEV_INT_GROP1;

            /* üĴжλΪֻ,Ӳ0 */
            if( intstatus & RB_F3_IN_INT )                                      /* FIFO3 IN interrupt */
            {
                USB_DEV_MASK_INT_GROP1 |= RB_MF3_IN_INT;                        /* ֹFIFO3ж */
                /* Ӵ */
            }
            if( intstatus & RB_F2_IN_INT )                                      /* FIFO2 IN interrupt */
            {
                USB_DEV_MASK_INT_GROP1 |= RB_MF2_IN_INT;                        /* ֹFIFO2ж */
                /* Ӵ */
            }
            if( intstatus & RB_F1_IN_INT )                                      /* FIFO1 IN interrupt */
            {
                printf("get\n");
                KEY_SendFlag = 1;
                USB_DEV_MASK_INT_GROP1 |= RB_MF1_IN_INT;                        /* ֹFIFO1ж */
                /* Ӵ */
            }
            if( intstatus & RB_F0_IN_INT )                                      /* FIFO0 IN interrupt */
            {
                USB_DEV_MASK_INT_GROP1 |= RB_MF0_IN_INT;                        /* ֹFIFO0ж */
                /* Ӵ */
            }
            if( intstatus & RB_F3_SPK_INT )                                     /* FIFO3 Short OUT interrupt */
            {
            }
            if( intstatus & RB_F3_OUT_INT )                                     /* FIFO3 OUT interrupt */
            {
                /* Ӵ */
            }
            if( intstatus & RB_F2_SPK_INT )                                     /* FIFO2 Short OUT interrupt */
            {
            }
            if( intstatus & RB_F2_OUT_INT )                                     /* FIFO2 OUT interrupt */
            {
                USB_DEV_MASK_INT_GROP1 |= RB_MF2_OUT_INT;
            }
            if( intstatus & RB_F1_SPK_INT )                                     /* FIFO1 Short OUT interrupt */
            {
            }
            if( intstatus & RB_F1_OUT_INT )                                     /* FIFO1 OUT interrupt */
            {
                /* Ӵ */
            }
            if( intstatus & RB_F0_SPK_INT )                                     /* FIFO0 Short OUT interrupt */
            {
            }
            if( intstatus & RB_F0_OUT_INT )                                     /* FIFO0 OUT interrupt */
            {
                /* Ӵ */
            }
        }
        if( grp_int & 0x04 )                                                    /* grop2: bulk/ISO/Interrupt interrupt */
        {
            intstatus = USB_DEV_INT_GROP2;
            printf("grp3 %x\n",intstatus);
            if( intstatus & RB_DEV_WAKEUP_BYBUS )                               /* Dev_Wakeup_byVBUS interrupt */
            {
                /* 豸VBUSж */
                /* жλֻ,Ӳ0 */
            }
            if( intstatus & RB_DEV_IDLE )                                       /* Dev_Idle interrupt */
            {
                /* 豸ж */
                /* жλֻ,Ӳ0 */
            }
            if( intstatus & RB_DMA_ERROR )                                      /* DMA Error interrupt */
            {
                /* DMAж */
                USB_DEV_INT_GROP2 = RB_DMA_ERROR;                               /* DMAж(д10) */
            }
            if( intstatus & RB_DMA_CMPLT )                                      /* DMA Completion interrupt */
            {
                /* DMAж */
                USB_DEV_INT_GROP2 = RB_DMA_CMPLT;                               /* DMAж(д10) */
            }
            if( intstatus & RB_RX0BYTE_INT )                                    /* Received Zero-length Data Packet interrupt */
            {
                /* 0ݰж */
                USB_DEV_INT_GROP2 |= RB_RX0BYTE_INT;                            /* 0ݰж(д10) */
                USB_DEV_RECV_0_LEN_PACK = 0x00;

                /* Ӵ,ʵҪUSB_DEV_RECV_0_LEN_PACKж´0ȰĶ˵,ٽд */
            }
            if( intstatus & RB_TX0BYTE_INT )                                    /* Transferred Zero-length Data Packet interrupt */
            {
                /* 0ݰж */
                USB_DEV_INT_GROP2 |= RB_TX0BYTE_INT;                            /* 巢0ݰж(д10) */
                USB_DEV_SEND_0_LEN_PACK = 0x00;                                 /* жϱ־ */

                /* Ӵ,ʵҪUSB_DEV_SEND_0_LEN_PACKжϴ0ȰĶ˵,ٽд */
            }
            if( intstatus & RB_ISO_SEQ_ABORT_INT )                              /* ISO Sequential Abort interrupt */
            {
                /* USB ISO쳣ж */
                USB_DEV_INT_GROP2 = RB_ISO_SEQ_ABORT_INT;                       /* USB ISO쳣ж(д10) */
            }
            if( intstatus & RB_ISO_SEQ_ERR_INT )                                /* ISO Sequential Error interrupt */
            {
                /* USB ISOж */
                USB_DEV_INT_GROP2 = RB_ISO_SEQ_ERR_INT;                         /* USB ISOж(д10) */
            }
            if( intstatus & RB_RESMQ_INT )                                      /* Resume interrupt */
            {
                /* USB߻ָж */
                USB_DEV_INT_GROP2 = RB_RESMQ_INT;                               /* USB߻ָж(д10) */
                gUsbFlag &= ~DEF_BIT_USB_SUPD;                                  /* ߹־ */
                USB_DEV_CONTROL &= ~RB_GOSUSP;                                  /* PHY */
            }
            if( intstatus & RB_SUSP_INT )                                       /* Suspend interrupt */
            {
                /* USB߹ж */
                USB_DEV_INT_GROP2 = RB_SUSP_INT;                                /* USB߹ж(д10) */
                gUsbFlag |= DEF_BIT_USB_SUPD;                                   /* ߹־ */
                USB_DEV_CONTROL |= RB_GOSUSP;                                   /* PHY */
            }
            if( intstatus & RB_USBRST_INT )                                     /* USB Reset interrupt */
            {
                USB_DEV_INT_GROP2 = RB_USBRST_INT;
                gUsbFlag = DEF_BIT_USB_RESET;                                   /*  ־,øλ־ */

                /* USB߸λ,Զַ */
                USB_DEV_ADDRESS = 0;                                            /* USB豸ַ(ʵʸλʱԶ0) */
            }
        }
    }
    else
    {
        USB_GL_INT_STATUS = USB_GL_INT_STATUS | RB_HC_INT | RB_OTG_INT;         /* λд10 */
    }
}

/*******************************************************************************
* Function Name  : KEY_SendKey
* Description    : Ͱֵ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void KEY_SendKey(UINT8 num)
{
    UINT8 keyData[8],i;
    for(i=0;i!=8;i++)
    {
        keyData[i] = 0;
    }
    keyData[2] = 0x04+num;      
    USBDev_WR_FIFOx( USB_DMA_ACC_F1, 8, (PUINT8)(&keyData[0]) );
    USB_DEV_MASK_INT_GROP1 &= ~RB_MF1_IN_INT;
}

/*******************************************************************************
* Function Name  : KEY_SendBlank
* Description    : ͷż
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void KEY_SendBlank(UINT8 num)
{
    UINT8 keyData[8],i;
    for(i=0;i!=8;i++)
    {
        keyData[i] = 0;
    }
    USBDev_WR_FIFOx( USB_DMA_ACC_F1, 8, (PUINT8)(&keyData[0]) );
    USB_DEV_MASK_INT_GROP1 &= ~RB_MF1_IN_INT;
}

/*********************************** endfile **********************************/
