/********************************** (C) COPYRIGHT *******************************
* File Name          : HID.H
* Author             : WCH
* Version            : V1.20
* Date               : 2013/11/15
* Description        : USBHID̡ͷļ
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include "CH563BAS.H"

#ifndef __HID_H__
#define __HID_H__

#ifdef __cplusplus
extern "C" {
#endif

/******************************************************************************/
/* HID豸غ궨 */
#define HID_TYPE_UNKNOW					0x00								   /* HIDδ֪豸 */
#define HID_TYPE_KEYBOARD				0x01								   /* HID豸 */
#define HID_TYPE_MOUSE					0x02								   /* HID豸 */

/******************************************************************************/
/* HID豸Ϣṹ嶨 */
typedef struct _HidInfo 
{ 
	ATTACH_DEVICE_INFO  Device;													
	qHD_Structure *qHD_INT_In1; 												/* жϴ˵1 EHCIؽṹָ붨 */
	qHD_Structure *qHD_INT_In2; 												/* жϴ˵2 EHCIؽṹָ붨 */
	qTD_Structure *IntInEp1qTD;
	qTD_Structure *IntInEp2qTD;
	UINT8  HidType;																/* HID豸ͣ0:None,1:Keyboard,2:Mouse */
	UINT8  IntfacNum;															/* HID豸Ľӿں */   
	UINT8  IntInEp1;															/* HID豸IN˵1ַ */
	UINT8  IntInEp2;															/* HID豸IN˵2ַ */
	UINT16 IntInEp1Size;  	    												/* HID豸IN˵1С */	
	UINT16 IntInEp2Size;  														/* HID豸IN˵2С */	
	UINT16 ReportDes_Len1;														/* HID౨ܳ1 */
	UINT16 ReportDes_Len2;														/* HID౨ܳ2 */
}HID_INFO;																		/* HIDϢṹ,洢ǰHIDҪ */

/******************************************************************************/
/*  */	
extern Periodic_Frame_List_Structure  *pHID_FramList;
extern UINT32 gEHCI_Preiodic_Frame_List_BaseAddr;  								/* EHCIбݽṹַ */

/******************************************************************************/
/*  */
extern UINT8 HID_CofDescrAnalyse( HID_INFO *Hidinfo, UINT8 *pbuf );				/* HID */
extern UINT8 HID_SetIdle( HID_INFO *Hidinfo, UINT8 intface, UINT8 *buf );
extern UINT8 HID_SetReport( HID_INFO *Hidinfo, UINT8 intface, UINT8 *buf );
extern UINT8 HID_GetReportDescr( HID_INFO *Hidinfo, UINT8 intface, UINT8 *buf, UINT16 len );
extern UINT8 HID_ClassRequest_Deal( HID_INFO *Hidinfo, UINT8 *pbuf );
extern UINT8 HID_Issue_GetData( HID_INFO *Hidinfo, qHD_Structure *spTempqHD, UINT8 *pbuf, UINT16 len );
extern UINT8 HID_Check_Data( HID_INFO *Hidinfo, qHD_Structure *spTempqHD, UINT16 *len );
extern UINT8 HID_Stop_GetData( HID_INFO *Hidinfo, qHD_Structure *spTempqHD );

#ifdef __cplusplus
}
#endif

#endif
