/********************************** (C) COPYRIGHT *******************************
* File Name          : UDISK_FAT.C
* Author             : WCH
* Version            : V1.20
* Date               : 2013/11/15
* Description        : USB洢豸ļϵͳļ
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "CH563BAS.H"
#include "EHCI_HCD.H"                                                           /* Ͳͷļ */
#include "CH563SFR.H"                                                           /* CH563Ĵͷļ */
#include "CH563USBSFR.H"                                                        /* оƬUSBĴͷļ */    
#include "CH563USB.H"                                                           /* USBöͷļ */    
#include "Udisk.H"                                                              /* Udiskͷļ */
#include "Udisk_FAT.H"                                                          /* Udiskװͷļ */

/******************************************************************************/
/*  */
UINT8  gDiskMaxLun;                                                             /* ߼Ԫ */
UINT8  gDiskCurLun;                                                             /* ̵ǰ߼Ԫ */

/******************************************************************************/ 
/******************************************************************************/
/* ΪEHCIײطװ */
/******************************************************************************/
/******************************************************************************/ 

/*******************************************************************************
* Function Name  : USBHOST_BusReset
* Description    : USB߸λ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 USBHOST_BusReset( void )
{
    return( USBHOST_EHCI_BusReset( &UDisk.Device ) );
}                             

/*******************************************************************************
* Function Name  : USBHOST_EP0_Init
* Description    : USBƶ˵0ʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 USBHOST_EP0_Init( void )
{
       return( USBHOST_EHCI_EP0_Init( &UDisk.Device) );
}

/*******************************************************************************
* Function Name  : USBHOST_CtrlTransfer
* Description    : USBһƴ
* Input          : *pDatBuf----շݻ
*                   *pRetLen----շʵʳ
* Output         : None   
* Return         : None
*******************************************************************************/
UINT8 USBHOST_CtrlTransfer( UINT8 *DatBuf, UINT16 *RetLen )
{
       return( USBHOST_Issue_Control( &UDisk.Device, Ctl_Setup, DatBuf, RetLen ) );
}

/*******************************************************************************
* Function Name  : USBHOST_GetDeviceDescr
* Description    : USBȡ豸
* Input          : *buf------ݻ                 
* Output         : None
* Return         : صǰִ״̬
*******************************************************************************/
UINT8 USBHOST_GetDeviceDescr( UINT8 *buf )
{
    UINT16  len;    

       return( USBHOST_EHCI_GetDeviceDescr( &UDisk.Device, buf, &len ) );    
}

/*******************************************************************************
* Function Name  : USBHOST_GetConfigDescr
* Description    : USBȡ
* Input          : *buf------ݻ
* Output         : None
* Return         : صǰִ״̬
*******************************************************************************/
UINT8 USBHOST_GetConfigDescr( UINT8 *buf )
{
    UINT16  len;

       return( USBHOST_EHCI_GetConfigDescr( &UDisk.Device, buf, &len ) );
}


/*******************************************************************************
* Function Name  : USBHOST_SetAddress
* Description    : USBõַ
* Input          : addr------Ҫõĵַ
* Output         : None
* Return         : صǰִ״̬
*******************************************************************************/
UINT8 USBHOST_SetAddress( UINT8 addr )
{
       return( USBHOST_EHCI_SetAddress( &UDisk.Device, addr ) );
}

/*******************************************************************************
* Function Name  : USBHOST_SetConfig
* Description    : USBֵ
* Input          : cfg-------Ҫõֵ
* Output         : None
* Return         : صǰִ״̬
*******************************************************************************/
UINT8 USBHOST_SetConfig( UINT8 cfg )
{
       return( USBHOST_EHCI_SetConfig( &UDisk.Device, cfg ) );
}

/*******************************************************************************
* Function Name  : USBHOST_ClearEndpStall
* Description    : USB˵
* Input          : endp------ҪĶ˵
* Output         : None
* Return         : صǰִ״̬
*******************************************************************************/
UINT8 USBHOST_ClearEndpStall( UINT8 endp )
{
    return( USBHOST_EHCI_ClearEndpStall( &UDisk.Device, endp ) );
}

/*******************************************************************************
* Function Name  : USBHOST_SetTargetAddr
* Description    : USBĿַ
* Input          : addr------Ҫõĵַ
* Output         : None
* Return         : None
*******************************************************************************/
void USBHOST_SetTargetAddr( UINT8 addr )
{
}

/*******************************************************************************
* Function Name  : USBHOST_Detect_Connect
* Description    : USB豸
*                  ע˿ʹλ߸λʱԶ1
* Input          : None
* Output         : None
* Return         : 0x00-----------------USB豸
*                  0x01-----------------USB豸δʹ
*                  0x02-----------------USB豸Ѿʹ
*                  USB_INT_CONNECT------⵽USB豸¼
*                  USB_INT_DISCONNECT---⵽USB豸Ͽ¼
*******************************************************************************/
UINT8 USBHOST_Detect_Connect( void )
{
    return( USBHOST_EHCI_Detect_Connect( &UDisk.Device ) );
}

/*******************************************************************************
* Function Name  : USBHOST_Parameter_Init
* Description    : ʼ豸ز
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void USBHOST_Parameter_Init( void )
{                                                                
    USBHOST_DevicePara_Init( &UDisk.Device );
}

/*******************************************************************************
* Function Name  : USBHOST_Enumerate
* Description    : USB豸ö
* Input          : *pbuf-----ݻ
* Output         : None
* Return         : USB_OPERATE_SUCCESS---豸öٳɹ;
*                  USB_OPERATE_ERROR-----豸öʧ;
*******************************************************************************/
UINT8 USBHOST_Enumerate( UINT8 *pbuf )
{
    return( USBHOST_EHCI_Enumerate( &UDisk.Device, pbuf ) );
}

/******************************************************************************/
/******************************************************************************/
/* ΪU̵ײصڷװ */
/******************************************************************************/
/******************************************************************************/
/*******************************************************************************
* Function Name  : USBHOST_MS_CofDescrAnalyse
* Description    : Mass Storage Device
* Input          : *pbuf--------ǰҪ
* Output         : None
* Return         : USB_OPERATE_SUCCESS----Mass Storage Device; 
*                  USB_OPERATE_ERROR---豸
*******************************************************************************/
UINT8 USBHOST_MS_CofDescrAnalyse( UINT8 *pbuf )
{
    return( MS_CofDescrAnalyse( &UDisk, pbuf ) );    
}

/*******************************************************************************
* Function Name  : MS_GetMaxLun
* Description    : USBȡ߼Ԫ
* Input          : None
* Output         : None
* Return         : صǰִ״̬
*******************************************************************************/
UINT8 MS_GetMaxLun( void )
{
    return( MS_GetMaxLun_EX( &UDisk ) );    
}

/*******************************************************************************
* Function Name  : MS_ResetErrorBOC
* Description    : USBλU
* Input          : None
* Output         : None
* Return         : صǰִ״̬
*******************************************************************************/
UINT8 MS_ResetErrorBOC( void )
{
    return( MS_ResetErrorBOC_EX( &UDisk ) );    
}

/*******************************************************************************
* Function Name  : MS_ScsiCmd_Process
* Description    : ִлBulkOnlyЭ
*                  һοԴ20K,δѭ
*                  ע: ݻ4K߽,δ,򻺳С
*                        ʵҪдĴСҪ4K 
* Input          : *DataBuf-----롢ݻ
* Output         : None
* Return         : ִ״̬
*******************************************************************************/
UINT8 MS_ScsiCmd_Process( UINT8 *DataBuf )
{
    return( MS_ScsiCmd_Process_EX( &UDisk, DataBuf ) );    
}

/*******************************************************************************
* Function Name  : MS_Init
* Description    : USB洢豸ʼ 
* Input          : *pbuf------ݻ 
* Output         : None
* Return         : USB_OPERATE_SUCCESS---ʼɹ;
*                  USB_OPERATE_ERROR--ʼʧ;
*******************************************************************************/
UINT8 MS_Init( UINT8 *pbuf )
{
    return( MS_Init_EX( &UDisk, pbuf ) );
}

/*******************************************************************************
* Function Name  : MS_RequestSense
* Description    : USB̴״̬
* Input          : *pbuf------ݻ
* Output         : None
* Return         : صǰִ״̬
*******************************************************************************/
UINT8 MS_RequestSense( UINT8 *pbuf )
{
    return( MS_RequestSense_EX( &UDisk, pbuf ) );
}

/*******************************************************************************
* Function Name  : MS_DiskInquiry
* Description    : USBȡ
* Input          : *pbuf------ݻ
* Output         : None
* Return         : صǰִ״̬
*******************************************************************************/
UINT8 MS_DiskInquiry( UINT8 *pbuf )
{
    return( MS_DiskInquiry_EX( &UDisk, pbuf ) );
}

/*******************************************************************************
* Function Name  : MS_DiskCapacity
* Description    : USBȡ
* Input          : *pbuf------ݻ
* Output         : None
* Return         : صǰִ״̬
*******************************************************************************/
UINT8 MS_DiskCapacity( UINT8 *pbuf )
{
    return( MS_DiskCapacity_EX( &UDisk, pbuf ) );
}

/*******************************************************************************
* Function Name  : MS_DiskTestReady
* Description    : USBԴǷ
* Input          : *pbuf------ݻ 
* Output         : None
* Return         : صǰִ״̬
*******************************************************************************/
UINT8 MS_DiskTestReady( UINT8 *pbuf )
{
    return( MS_DiskTestReady_EX( &UDisk, pbuf ) );
}

/*******************************************************************************
* Function Name  : MS_ReadSector
* Description    : ΪλӴ̶ȡ
* Input          : StartLba----ʼ
*                  SectCount---ҪȡĿ
*                  DataBuf-----ݻ 
* Output         : None
* Return         : ִ״̬
*******************************************************************************/
UINT8 MS_ReadSector( UINT32 StartLba, UINT32 SectCount, PUINT8 DataBuf )
{
    return( MS_ReadSector_EX( &UDisk, StartLba, SectCount, DataBuf ) );
}

/*******************************************************************************
* Function Name  : MS_WriteSector
* Description    : Ϊλд
* Input          : StartLba----ʼ
*                  SectCount---ҪдĿ
*                  DataBuf-----ݻ
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 MS_WriteSector( UINT32 StartLba, UINT8 SectCount, PUINT8 DataBuf )
{
    return( MS_WriteSector_EX( &UDisk, StartLba, SectCount, DataBuf ) );
}


