/* 2014.09.09
*****************************************
**   Copyright  (C)  W.ch  1999-2014   **
**   Web:      http://wch.cn           **
*****************************************
**  USB-flash File Interface for CH56x **
**  ADS 1.2, Keil 3.11/4.12 @ARM946E-S,v5TE **
*****************************************
*/
/* CH56x Uļϵͳӿ, ֧: FAT12/FAT16/FAT32 */

//#include "CH56XBAS.H"

#ifndef __CH56xUFI_H__
#define __CH56xUFI_H__

#define CH56x_LIB_VER		0x16

//#define DISK_BASE_BUF_LEN		512	/* ĬϵĴݻСΪ512ֽ,ѡΪ20484096֧ĳЩU,Ϊ0ֹڱļж建ӦópDISK_BASE_BUFָ */
/* ҪôݻԽԼRAM,ôɽDISK_BASE_BUF_LENΪ0Խֹڱļж建,ӦóڵCH56xLibInit֮ǰõĻʼַpDISK_BASE_BUF */

//#define NO_DEFAULT_ACCESS_SECTOR	1		/* ֹĬϵĴдӳ,Ȼбдĳ */
//#define NO_DEFAULT_FILE_ENUMER		1		/* ֹĬϵļöٻص,Ȼбдĳ */

#ifdef __cplusplus
extern "C" {
#endif

/* ********************************************************************************************************************* */

/* FILE: CH56xUF.H */

/*  */
#ifndef ERR_SUCCESS
#define ERR_SUCCESS				0x00	/* ɹ */
#endif
#ifndef ERR_DISK_DISCON
#define ERR_CH56x_ERROR			0x81	/* CH56xӲ,ҪλCH56x */
#define ERR_DISK_DISCON			0x82	/* δ,ܴѾϿ */
#define ERR_STATUS_ERR			0x83	/* ״̬,ӻ߶Ͽ */
#define ERR_HUB_PORT_FREE		0x84	/* USB-HUBѾӵHUB˿δӴ,ܴѾϿ */
#define ERR_MBR_ERROR			0x91	/* ̵¼Ч,ܴδδʽ */
#define ERR_TYPE_ERROR			0x92	/* ̷Ͳ֧,ֻ֧FAT12/FAT16/BigDOS/FAT32,Ҫɴ̹· */
#define ERR_BPB_ERROR			0xA1	/* δʽ,߲,ҪWINDOWSĬϲ¸ʽ */
#define ERR_TOO_LARGE			0xA2	/* ̷ʽ4GB,250GB,ҪWINDOWSĬϲ¸ʽ */
#define ERR_FAT_ERROR			0xA3	/* ̵ļϵͳ֧,ֻ֧FAT12/FAT16/FAT32,ҪWINDOWSĬϲ¸ʽ */
#define ERR_DISK_FULL			0xB1	/* ļ̫,ʣռ̫ٻѾû,Ҫ */
#define ERR_FDT_OVER			0xB2	/* Ŀ¼ļ̫,ûпеĿ¼,FAT12/FAT16Ŀ¼µļӦ500,Ҫ */
#define ERR_MISS_DIR			0xB3	/* ָ·ĳĿ¼ûҵ,Ŀ¼ƴ */
#define ERR_FILE_CLOSE			0xB4	/* ļѾر,Ҫʹ,Ӧ´ļ */
#define ERR_OPEN_DIR			0x41	/* ָ·Ŀ¼ */
#define ERR_MISS_FILE			0x42	/* ָ·ļûҵ,ļƴ */
#define ERR_FOUND_NAME			0x43	/* ͨƥļ,ļ·,Ҫʹ,Ӧô򿪸ļ */
#endif
/* 1XHUSBʽĲ״̬ */
#ifndef ERR_USB_CONNECT
#define	ERR_USB_CONNECT_LS		0x13	/* ⵽USB豸¼ */
#define	ERR_USB_CONNECT			0x15	/* ⵽USB豸¼,Ѿ */
#define	ERR_USB_DISCON			0x16	/* ⵽USB豸Ͽ¼,ѾϿ */
#define	ERR_USB_DISK_ERR		0x1F	/* USB洢ʧ,ڳʼʱUSB洢֧,ڶдпǴ𻵻ѾϿ */
#endif

/* ̼ļ״̬ */
#define DISK_UNKNOWN			0x00	/* δʼ,δ֪״̬ */
#define DISK_DISCONNECT			0x01	/* ûӻѾϿ */
#define DISK_CONNECT			0x02	/* Ѿ,δʼ޷ʶô */
#define DISK_MOUNTED			0x03	/* Ѿʼɹ,δļϵͳļϵͳ֧ */
#define DISK_READY				0x10	/* Ѿ̵ļϵͳܹ֧ */
#define DISK_OPEN_ROOT			0x12	/* Ѿ򿪸Ŀ¼,ģʽ,ֻΪλдĿ¼,ʹúر,עFAT12/FAT16Ŀ¼ǹ̶ */
#define DISK_OPEN_DIR			0x13	/* ѾĿ¼,ģʽ,ֻΪλдĿ¼ */
#define DISK_OPEN_FILE			0x14	/* Ѿļ,ģʽ,Ϊλݶд */
#define DISK_OPEN_FILE_B		0x15	/* Ѿļ,ֽģʽ,ֽΪλݶд */

/* FATͱ־ */
#ifndef DISK_FAT16
#define DISK_FS_UNKNOWN			0		/* δ֪ļϵͳ */
#define DISK_FAT12				1		/* FAT12ļϵͳ */
#define DISK_FAT16				2		/* FAT16ļϵͳ */
#define DISK_FAT32				3		/* FAT32ļϵͳ */
#endif

/* FATļĿ¼Ϣ */
typedef struct _FAT_DIR_INFO {
	UINT8	DIR_Name[11];				/* 00H,ļ,11ֽ,㴦ո */
	UINT8	DIR_Attr;					/* 0BH,ļ,οǰ˵ */
	UINT8	DIR_NTRes;					/* 0CH */
	UINT8	DIR_CrtTimeTenth;			/* 0DH,ļʱ,0.1뵥λ */
	UINT16	DIR_CrtTime;				/* 0EH,ļʱ */
	UINT16	DIR_CrtDate;				/* 10H,ļ */
	UINT16	DIR_LstAccDate;				/* 12H,һδȡ */
	UINT16	DIR_FstClusHI;				/* 14H */
	UINT16	DIR_WrtTime;				/* 16H,ļ޸ʱ,οǰĺMAKE_FILE_TIME */
	UINT16	DIR_WrtDate;				/* 18H,ļ޸,οǰĺMAKE_FILE_DATA */
	UINT16	DIR_FstClusLO;				/* 1AH */
	UINT32	DIR_FileSize;				/* 1CH,ļ */
} FAT_DIR_INFO, *P_FAT_DIR_INFO;		/* 20H */

/* ļ */
#define ATTR_READ_ONLY			0x01	/* ļΪֻ */
#define ATTR_HIDDEN				0x02	/* ļΪ */
#define ATTR_SYSTEM				0x04	/* ļΪϵͳ */
#define ATTR_VOLUME_ID			0x08	/*  */
#define ATTR_DIRECTORY			0x10	/* Ŀ¼ */
#define ATTR_ARCHIVE			0x20	/* ļΪ浵 */
#define ATTR_LONG_NAME			( ATTR_READ_ONLY | ATTR_HIDDEN | ATTR_SYSTEM | ATTR_VOLUME_ID )
/* ļ UINT8 */
/* bit0 bit1 bit2 bit3 bit4 bit5 bit6 bit7 */
/*  ֻ      ϵ      Ŀ      δ   */
/*        ͳ      ¼               */
/* ļʱ UINT16 */
/* Time = (Hour<<11) + (Minute<<5) + (Second>>1) */
#define MAKE_FILE_TIME( h, m, s )	( (h<<11) + (m<<5) + (s>>1) )	/* ָʱļʱ */
/* ļ UINT16 */
/* Date = ((Year-1980)<<9) + (Month<<5) + Day */
#define MAKE_FILE_DATE( y, m, d )	( ((y-1980)<<9) + (m<<5) + d )	/* ָյļ */

/* ļ */
#define PATH_WILDCARD_CHAR		0x2A	/* ·ͨ '*' */
#define PATH_SEPAR_CHAR1		0x5C	/* ·ķָ '\' */
#define PATH_SEPAR_CHAR2		0x2F	/* ·ķָ '/' */
#ifndef MAX_PATH_LEN
#define MAX_PATH_LEN			128		/* ·,бָܷСԼ·00H */
#endif

/* ⲿ */
typedef union _CMD_PARAM {
	struct {
		UINT8	mBuffer[ MAX_PATH_LEN ];
	} Other;
	struct {
		UINT32	mTotalSector;			/* : ǰ߼̵ */
		UINT32	mFreeSector;			/* : ǰ߼̵ʣ */
	} Query;							/* CMD_DiskQuery, ѯϢ */
	struct {
		UINT8	mPathName[ MAX_PATH_LEN ];	/* : ·: [̷,ð,б,Ŀ¼ļչ...,00H], ̷ðſʡ, "C:\DIR1.EXT\DIR2\FILENAME.EXT",00H */
	} Open;								/* CMD_FileOpen, ļ */
//	struct {
//		UINT8	mPathName[ MAX_PATH_LEN ];	/* : ·: [̷,ð,б,Ŀ¼ļչ(ͨ*)...,00H], ̷ðſʡ, "C:\DIR1.EXT\DIR2\FILE*",00H */
//	} Open;								/* CMD_FileOpen, öļ, CH56xvFileSizeλΪ1xFileNameEnumer,Ϊ0򷵻ָŵļ */
	struct {
		UINT8	mUpdateLen;				/* : Ƿ³: 0ֹ,1 */
	} Close;							/* CMD_FileClose, رյǰļ */
	struct {
		UINT8	mPathName[ MAX_PATH_LEN ];	/* : ·: [̷,ð,б,Ŀ¼ļչ...,00H], ̷ðſʡ, "C:\DIR1.EXT\DIR2\FILENAME.EXT",00H */
	} Create;							/* CMD_FileCreate, ½ļ,ļѾɾ½ */
	struct {
		UINT8	mPathName[ MAX_PATH_LEN ];	/* : ·: [̷,ð,б,Ŀ¼ļչ...,00H], ̷ðſʡ, "C:\DIR1.EXT\DIR2\FILENAME.EXT",00H */
	} Erase;							/* CMD_FileErase, ɾļر */
	struct {
		UINT32	mFileSize;				/* : µļ,Ϊ0FFFFFFFFH޸, : ԭ */
		UINT16	mFileDate;				/* : µļ,Ϊ0FFFFH޸, : ԭ */
		UINT16	mFileTime;				/* : µļʱ,Ϊ0FFFFH޸, : ԭʱ */
		UINT8	mFileAttr;				/* : µļ,Ϊ0FFH޸, : ԭ */
	} Modify;							/* CMD_FileQuery, ѯǰļϢ; CMD_FileModify, ѯ޸ĵǰļϢ */
	struct {
		UINT32	mSectorOffset;			/* : ƫ,0ƶļͷ,0FFFFFFFFHƶļβ, : ǰļָӦľ, 0FFFFFFFFHѵļβ */
		UINT32	mLastOffset;
	} Locate;							/* CMD_FileLocate, ƶǰļָ */
	struct {
		UINT8	mSectorCount;			/* : ȡ, : ʵʶȡ */
		UINT8	mReserved1;
		UINT8	mLbaCount;
		UINT8	mReserved2;
		PUINT8	mDataBuffer;			/* : ʼַ, : ǰַ */
		UINT32	mLbaStart;
	} Read;								/* CMD_FileRead, ӵǰļȡ */
	struct {
		UINT8	mSectorCount;			/* : д, : ʵд */
		UINT8	mReserved1;
		UINT8	mLbaCount;
		UINT8	mReserved2;
		PUINT8	mDataBuffer;			/* : ʼַ, : ǰַ */
		UINT32	mLbaStart;
	} Write;							/* CMD_FileWrite, ǰļд */
	struct {
		UINT32	mDiskSizeSec;			/* : ̵, ״εʱ */
	} DiskReady;						/* CMD_DiskReady, ѯ̾ */
	struct {
		UINT32	mByteOffset;			/* : ֽΪλƫ, ֽΪλļָ, : ǰļָӦľ, 0FFFFFFFFHѵļβ */
		UINT32	mLastOffset;
	} ByteLocate;						/* CMD_ByteLocate, ֽΪλƶǰļָ */
	struct {
		UINT32	mByteCount;				/* : ׼ȡֽ, : ʵʶֽ */
		PUINT8	mByteBuffer;			/* : ָŶݿĻ */
	} ByteRead;							/* CMD_ByteRead, ֽΪλӵǰļȡݿ */
	struct {
		UINT32	mByteCount;				/* : ׼дֽ, : ʵдֽ */
		PUINT8	mByteBuffer;			/* : ָŶݿĻ */
	} ByteWrite;						/* CMD_ByteWrite, ֽΪλǰļдݿ */
	struct {
		UINT8	mSaveVariable;			/* : Ϊ0ָU̵ı,Ϊ0x80ָU̵ı,ֵ򱸷/ */
		UINT8	mReserved[3];
		PUINT8	mBuffer;				/* : ָӳııݻ,ȲС80ֽ */
	} SaveVariable;						/* CMD_SaveVariable, //ָӳı */
} CMD_PARAM, *P_CMD_PARAM;

/* SCSI */
#ifndef SPC_CMD_INQUIRY
#define SPC_CMD_INQUIRY			0x12
#define SPC_CMD_READ_CAPACITY	0x25
#define SPC_CMD_READ10			0x28
#define SPC_CMD_WRITE10			0x2A
#define SPC_CMD_TEST_READY		0x00
#define SPC_CMD_REQUEST_SENSE	0x03
#define SPC_CMD_MODESENSE6		0x1A
#define SPC_CMD_MODESENSE10		0x5A
#define SPC_CMD_START_STOP		0x1B
#endif

/* BOC */
#if 0
typedef union _BULK_ONLY_CMD {
	struct {
		UINT32	mCBW_Sig;
		UINT32	mCBW_Tag;
		UINT32	mCBW_DataLen;			/* : ݴ䳤 */
		UINT8	mCBW_Flag;				/* : ䷽ȱ־ */
		UINT8	mCBW_LUN;
		UINT8	mCBW_CB_Len;			/* : ĳ,Чֵ116 */
		UINT8	mCBW_CB_Buf[16];		/* : ,ûΪ16ֽ */
	} mCBW;								/* BulkOnlyЭ, CBWṹ */
	struct {
		UINT32	mCSW_Sig;
		UINT32	mCSW_Tag;
		UINT32	mCSW_Residue;			/* : ʣݳ */
		UINT8	mCSW_Status;			/* : ִн״̬ */
		UINT8	mReserved;
	} mCSW;								/* BulkOnlyЭ״̬, CSWṹ */
} BULK_ONLY_CMD;						/* CMD_BulkOnlyCmd, ִлBulkOnlyЭ, ݴôpDISK_BASE_BUF */
#endif

/* FILE: CH56xUF.C */

#define EN_DISK_WRITE			1
#define EN_HUB_DISK				1

#ifndef DISK_BASE_BUF_LEN
#define DISK_BASE_BUF_LEN		512		/* ĬϵĴݻСΪ512ֽ,ѡΪ20484096֧ĳЩU,Ϊ0ֹ.Hļж建ӦópDISK_BASE_BUFָ */
#endif

/* ӳṩı */
extern UINT8V	CH56xIntStatus;			/* CH56xж״̬ */
extern UINT8V	CH56xDiskStatus;		/* ̼ļ״̬ */
extern UINT8	CH56xvDiskFat;			/* ߼̵FAT־:1=FAT12,2=FAT16,3=FAT32 */
extern UINT8	CH56xvSecPerClus;		/* ߼̵ÿ */
extern UINT8	CH56xvSectorSizeB;		/* log2(CH56xvSectorSize) */
extern UINT32	CH56xvStartLba;			/* ߼̵ʼLBA */
extern UINT32	CH56xvDiskRoot;			/* FAT16ΪĿ¼ռ,FAT32ΪĿ¼ʼغ */
extern UINT32	CH56xvDataStart;		/* ߼̵ʼLBA */
extern UINT32	CH56xvStartCluster;		/* ǰļĿ¼ʼغ */
extern UINT32	CH56xvFileSize;			/* ǰļĳ */
extern UINT32	CH56xvCurrentOffset;	/* ǰļָ,ǰдλõֽƫ */
extern UINT32	CH56xvFdtLba;			/* ǰFDTڵLBAַ */
extern UINT16	CH56xvFdtOffset;		/* ǰFDTڵƫƵַ */
extern UINT16	CH56xvSectorSize;		/* ̵С */
extern PUINT8	pDISK_BASE_BUF;			/* ָⲿRAMĴݻ,ȲСCH56xvSectorSize,Ӧóʼ */
extern PUINT8	pDISK_FAT_BUF;			/* ָⲿRAMĴFATݻ,ȲСCH56xvSectorSize,Ӧóʼ */
#ifdef EN_HUB_DISK
extern UINT8	CH56xvHubPortCount;		/* HUBϵĶ˿,Ϊ0ûHUB */
extern UINT8	CH56xvHubPortIndex;		/* HUBϵĵǰ˿ں,λ7Ϊ0Զѯ,Ϊ1ָ˿ں */
#endif

/* ӳṩӳ */
/* ӳ, ļӳCH56xFile*ʹ̲ѯӳCH56xDiskQueryܻõݻpDISK_BASE_BUF,
   пpDISK_BASE_BUFб˴Ϣ, Ա뱣֤pDISK_BASE_BUF;,
   RAM, ҪpDISK_BASE_BUFʱ;, ôʱCH56xDirtyBuffer̻ */
extern UINT8	CH56xGetVer( void );		/* ȡǰӳİ汾 */
extern void		CH56xDirtyBuffer( void );	/* ̻ */
extern UINT8	CH56xDiskConnect( void );	/* ǷӲ´״̬ */
extern UINT8	CH56xBulkOnlyCmd( void );	/* ִлBulkOnlyЭ */
extern UINT8	CH56xDiskReady( void );		/* ѯǷ׼ */
extern UINT8	CH56xAnalyzeError( UINT8 iMode );	/* USBʧܷCH56xIntStatusش״̬ */
extern UINT8	CH56xFileOpen( void );		/* ļöļ */
extern UINT8	CH56xFileClose( void );		/* رյǰļ */
#ifdef EN_DISK_WRITE
extern UINT8	CH56xFileErase( void );		/* ɾļر */
extern UINT8	CH56xFileCreate( void );	/* ½ļ,ļѾɾ½ */
extern UINT8	CH56xFileAlloc( void );		/* ļȵΪļĴ̿ռ */
#endif
extern UINT8	CH56xFileModify( void );	/* ѯ޸ĵǰļϢ */
extern UINT8	CH56xFileQuery( void );		/* ѯǰļϢ */
extern UINT8	CH56xFileLocate( void );	/* ƶǰļָ */
extern UINT8	CH56xFileRead( void );		/* ӵǰļȡݵָ */
#ifdef EN_DISK_WRITE
extern UINT8	CH56xFileWrite( void );		/* ǰļдָ */
#endif
extern UINT8	CH56xByteLocate( void );	/* ֽΪλƶǰļָ */
extern UINT8	CH56xByteRead( void );		/* ֽΪλӵǰλöȡݿ */
#ifdef EN_DISK_WRITE
extern UINT8	CH56xByteWrite( void );		/* ֽΪλǰλдݿ */
#endif
extern UINT8	CH56xDiskQuery( void );		/* ѯϢ */
extern void		CH56xSaveVariable( void );	/* //ָӳı,ӳڶоƬU֮л */

extern CMD_PARAM mCmdParam;					/*  */
#if DISK_BASE_BUF_LEN > 0
extern UINT8  DISK_BASE_BUF[ DISK_BASE_BUF_LEN ];	/* ⲿRAMĴݻ,Ϊһĳ */
#endif
extern UINT8	CH56xReadSector( UINT32 StartLba, UINT32 SectCount, PUINT8 DataBuf );	/* Ӵ̶ȡݵ */
#ifdef EN_DISK_WRITE
extern UINT8	CH56xWriteSector( UINT32 StartLba, UINT32 SectCount, PUINT8 DataBuf );	/* еĶݿд */
#endif
extern UINT8	CH56xLibInit( void );		/* ʼCH56xCH56xоƬ,ɹ0 */

#ifdef __cplusplus
}
#endif

#endif
