/********************************** (C) COPYRIGHT *********************************
* File Name          : FTPINC.H
* Author             : WCH
* Version            : V1.0
* Date               : 2013/11/15
* Description        : Define for CH563FTP.Cs
**********************************************************************************/
#ifndef __CH563FTPINC_H__
#define __CH563FTPINC_H__

#define DEBUG                        1            // ------------115200

typedef struct _FTP
{
    UINT8 TcpStatus;                // TCP״̬
    UINT8 CmdStatus;                // ӿִ״̬
    UINT8 InterCmdS;                // ӿִб־λ
    UINT8 CmdFirtS;                 // һִб־λ
    UINT8 FindList;                 // ҵָļ
    UINT8 FindFile;                 // ҵָļ
    UINT8 CmdDataS;                 // ״̬
    UINT8 SocketCtl;                // ftpsocket
    UINT8 DatMonitor;               // ftpsocket
    UINT8 DatTransfer;              // ftpӴsocket
    UINT8 FileCmd;                  // ӿ    
    UINT16 SouPort;                 // ˿ں
    UINT16 RecDatLen;               // յݳ
}FTP;
extern  FTP   ftp;
extern     char  ListName[24];      // ڱĿ¼
extern     char  ListMkd[24];       // ڱ´Ŀ¼
extern     char  FileName[24];      // ڱļ 
extern     char  CharIP[17];        // ڱתַIPַ
extern    const UINT8 *pUserName;   // ½
extern    const UINT8 *pPassword;   // e-mail Ϊ½
/* CH563ض */                                                                   
extern UINT8 MACAddr[6];                          // CH563MACַ 
extern const UINT8 IPAddr[4];                     // CH563IPַ 
extern const UINT8 GWIPAddr[4];                   // CH563 
extern const UINT8 IPMask[4];                     // CH563 
extern const UINT8 DestIP[4];
/* TCP״̬ */
#define FTP_MACH_DISCONT            0x00          // TCPϿ
#define FTP_MACH_CONNECT            0x01          // TCP
/* ״̬ */
#define FTP_MACH_QUIT               0x01          // ½ǰ
#define FTP_MACH_CLOSE              0x02          // ½
/* ݴ״̬ */
#define FTP_MACH_SENDDATA           0x01          // Ҫ
#define FTP_MACH_RECEDATA           0x02          // Ҫ
#define FTP_MACH_DATAOVER           0x04          // ݴ
/* ӿִ״̬ */
#define FTP_MACH_LOGINSUC           0x01          // ¼ɹ
#define FTP_MACH_SEARCHSUC          0x02          // Ѱļ
#define FTP_MACH_GETSUC             0x04          // ļɹ
#define FTP_MACH_PUTSUC             0x08          // ϴļɹ
/*  ִй̱־λ */
#define FTP_MACH_FINDLIST           0x01          // ѰĿ¼־λ
#define FTP_MACH_FINDFILE           0x02          // Ѱļ־λ
#define FTP_MACH_GETFILE            0x04          // ļ־λ
#define FTP_MACH_MKDLIST            0x08          // Ŀ¼־λ
#define FTP_MACH_PUTFILE            0x10          // ϴļ־λ
/* ״̬Ϣ */ 
#define FTP_CHECK_NULL              0x00          // ûźŷ򲻽зϢ˶ 
#define FTP_CHECK_SUCCESS           0x00          // Ϣȷ  
#define FTP_COMMAND_SUCCESS         0x00          // ӿִгɹ
#define FTP_COMMAND_CONTINUE        0x01          // ӿִй
/* ӿ */
#define FTP_CMD_LOGIN               0x01          // ¼
#define FTP_CMD_SEARCH              0x02          // Ѱļ
#define FTP_CMD_GETFILE             0x03          // ļ
#define FTP_CMD_PUTFILE             0x04          // ϴļ
/* ********************************************************************************
* źź˶Դ
**********************************************************************************/
#define FTP_ERR_LOGIN               0x20         // ¼
#define FTP_ERR_SEARCH              0x21         // Ѱļ
#define FTP_ERR_GETFILE             0x22         // ļ
#define FTP_ERR_PUTFILE             0x23         // ϴļ
#define FTP_ERR_UNLIST              0x2a         // δҵĿ¼ 
#define FTP_ERR_UNFILE              0x2b         // δҵļ
#define FTP_ERR_UNKW                0x2f         // δ֪

/**********************************************************************************/
void CH563NET_FTPClientCmd( void );                                                                 /* ѯ״ִ̬ */

void CH563NET_FTPInterCmd( void );                                                                  /* ִжӦеִ˳ */
 
void CH563NET_FTPSendData( char *PSend, UINT32 Len,UINT8 index );                                   /*  */

void CH563NET_FTPProcessReceDat( char *recv_buff,UINT8 check_type,UINT8 socketid );                 /* յ */

void CH563NET_FTPInit( void );                                                                      /* 563ʼ */

void CH563NET_FTPInitVari( void );                                                                  /* ʼ */
                                  
UINT8 CH563NET_FTPCheckRespond( char *recv_buff,UINT8 check_type );                                 /* ӦϢ */

void  CH563NET_FTPCtlClient(void);                                                                  /* FTP */

void  CH563NET_FTPDatClient( UINT16 *port );                                                        /* FTP */

void  CH563NET_FTPDatServer( UINT16 *port );

void  CH563NET_FTPCommand( UINT8 choiceorder);                                                      /* ִжӦ */

UINT8 CH563NET_FTPLogin( void );                                                                    /* ½ */    

UINT8 CH563NET_FTPSearch(char *pListNAme,char *pFileName );                                         /* ļ */

UINT8 CH563NET_FTPGetFile( char *pFileName );                                                       /* ļ */

UINT8 CH563NET_FTPPutFile(char *pListNAme, char *pFileName);                                        /* ϴļ */

UINT8 CH563NET_FTPFindFile( char *pReceiveData );                                                   /* ˶ļ */

UINT8 CH563NET_FTPFindList( char *pReceiveData );                                                   /* ˶ļ */

UINT8 CH563NET_FTPGetSockeID( void );                                                               /* ȡsocket */

UINT8 CH563NET_FTPMkdirCheck( char *rece_buf);                                                      /* Ŀ¼ִ״̬ */

UINT8 CH563NET_FTPGetFileData( char *recv_buff );                                                   /* ȡص */

void  CH563NET_FTPQuit( void );                                                                     /* ˳ */

void mStopIfError( UINT8 iError );

void CH563NET_HandleGloableInt( void );

#endif    // __CH563FTPINC_H__
