/********************************** (C) COPYRIGHT ******************************
* File Name          : FTP_CLIENT.C
* Author             : WCH
* Version            : V1.0
* Date               : 2013/11/15
* Description        : CH563оƬFTPӿ
*                    : MDK3.36@ARM966E-S,Thumb,С
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "CH563BAS.H"
#include "CH563NET.H"
#include "FTPINC.H"
#include "FTPCMD.C"
#include "FTPFILE.C"

/*******************************************************************************
* Function Name  : CH563NET_FTPProcessReceDat
* Description    : ȡ   
* Input          : recv_buff  -563յ
*                  check_type -ǰ
*                  socketid   -socket
* Output         : None               
* Return         : None
*******************************************************************************/
void CH563NET_FTPProcessReceDat( char *recv_buff,UINT8 check_type,UINT8 socketid )
{
    UINT8 S;
    if( socketid == ftp.DatTransfer ){
        if(ftp.CmdDataS == FTP_MACH_RECEDATA){                                  /* ļ */
            if( ftp.InterCmdS == FTP_MACH_GETFILE ){ 
                S = CH563NET_FTPFileWrite(recv_buff,strlen(recv_buff));
            }
            else if(ftp.InterCmdS == FTP_MACH_FINDLIST ){
                S = CH563NET_FTPFindList( recv_buff );                          /* ֤ݣڲָĿ¼ */
                if( S == FTP_CHECK_SUCCESS ) ftp.FindList = 1;                  /* 鵽ָĿ¼ */
            }
            else if(ftp.InterCmdS == FTP_MACH_FINDFILE ){
                S = CH563NET_FTPFindFile( recv_buff );                          /* ļ */    
                if( S == FTP_CHECK_SUCCESS ) ftp.FindFile = 1;                  /* ҵļ */
            }
        }
    }
    else if( socketid == ftp.SocketCtl ){                                       /* ΪӦ */            
        S = CH563NET_FTPCheckRespond(recv_buff,check_type);
    }
}

/*******************************************************************************
* Function Name  : CH395_FTPSendFile
* Description    : 
* Input          : NONE
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET_FTPSendFile( void )
{
    UINT8 S;    
    
    S = CH563NET_FTPFileOpen( FileName );
    if(S == FTP_CHECK_SUCCESS)    CH563NET_FTPFileRead( );
    CH563NET_FTPSendData( send_buff, strlen(send_buff),ftp.DatTransfer );
    if(ftp.CmdDataS == FTP_MACH_DATAOVER){
        CH563NET_SocketClose( ftp.DatTransfer,TCP_CLOSE_NORMAL );
    }    
}

/*******************************************************************************
* Function Name  : CH563NET_FTPCheckRespond
* Description    : ѯ״ִ̬Ӧ
* Input          : recv_buff  -Ϣ
                   check_type -
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET_FTPClientCmd( void )
{
    if(ftp.CmdDataS == FTP_MACH_SENDDATA){
        if(ftp.TcpStatus == FTP_MACH_CONNECT) CH563NET_FTPSendFile( );          /*  */
        return ;     
    }
    if(ftp.CmdDataS == FTP_MACH_DATAOVER){
        if(ftp.FindList == 1){                                                  /* ҵĿ¼ */
            ftp.FindList = 0;
            CH563NET_FTPCwd( 0 );
        }
    }
    if(ftp.FileCmd){
        CH563NET_FTPInterCmd( );                                                /* ִжӦĽӿ */
    }
}

/*******************************************************************************
* Function Name  : CH563NET_FTPInterCmd
* Description    : ִжӦеִ˳
* Input          : NONE
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET_FTPInterCmd( void )
{
    switch(ftp.FileCmd){
        case FTP_CMD_LOGIN:                                                     /* ½ */
            if( CH563NET_FTPLogin( ) == FTP_COMMAND_SUCCESS ){                  /* ½ɹ,ɽ */
                CH563NET_FTPSearch("USER","FILELIST.txt" );                     /* ʼѯָĿ¼ */            
            }
            break;
        case FTP_CMD_SEARCH:                                                    /* ѲļĿ¼ļ*/
            if( CH563NET_FTPSearch("USER","FILELIST.txt" ) == FTP_COMMAND_SUCCESS ){        
                if( ftp.FindFile )CH563NET_FTPGetFile("FILELIST.txt" );         /* Ѳ鵽ָĿ¼µļʼļ */
                else CH563NET_FTPQuit( );                                       /* ûѲ鵽ָĿ¼µļ˳Ҳɽϴ*/
            }
            break;
        case FTP_CMD_GETFILE:                                                   /* ļļ*/ 
            if(CH563NET_FTPGetFile("FILELIST.txt" ) == FTP_COMMAND_SUCCESS ){   /* ļɹɽ */
                CH563NET_FTPPutFile("TEXT","abc.txt");                          /* ϴļ */
            }
            break;
        case FTP_CMD_PUTFILE:                                                   /* ϴļĿ¼ļ*/
            if( CH563NET_FTPPutFile("TEXT","abc.txt")== FTP_COMMAND_SUCCESS ){  /* ϴļɹɽ */
                CH563NET_FTPQuit( );                                            /* ˳ */
            }
            break;
        default:
            break;
    }
}

/*********************************** endfile **********************************/
