/********************************** (C) COPYRIGHT ******************************
* File Name          : Main.C
* Author             : WCH
* Version            : V1.0
* Date               : 2013/11/15
* Description        : CH563 FTP Server DEMO
*                      (1)CH563 Examples by KEIL;
*                      (2)0Ϣ,115200bps;
*                      (3)CH563NETʾļʾFTPܣARM966,Thumb,С
*******************************************************************************/



/******************************************************************************/
/* ͷļ*/
#include <stdio.h>
#include <string.h>
#include "CH563SFR.H"
#include "CH563SFR.H"
#include "SYSFREQ.H"
#include "FTPINC.H"
#include "CH563NET.H"
#include "ISPXT56X.H"

#define CH563NET_DBG                          1

/* ĻȫֱҪ壬е */
__align(16)UINT8    CH563MACRxDesBuf[(RX_QUEUE_ENTRIES )*16];                   /* MAC16ֽڶ */
__align(4) UINT8    CH563MACRxBuf[RX_QUEUE_ENTRIES*RX_BUF_SIZE];                /* MACջ4ֽڶ */
__align(4) SOCK_INF SocketInf[CH563NET_MAX_SOCKET_NUM];                         /* SocketϢ4ֽڶ */
const UINT16 MemNum[8] = {CH563NET_NUM_IPRAW,
                         CH563NET_NUM_UDP,
                         CH563NET_NUM_TCP,
                         CH563NET_NUM_TCP_LISTEN,
                         CH563NET_NUM_TCP_SEG,
                         CH563NET_NUM_IP_REASSDATA,
                         CH563NET_NUM_PBUF,
                         CH563NET_NUM_POOL_BUF
                         };
const UINT16 MemSize[8] = {CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_IPRAW_PCB),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_UDP_PCB),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_TCP_PCB),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_TCP_PCB_LISTEN),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_TCP_SEG),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_IP_REASSDATA),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_PBUF) + CH563NET_MEM_ALIGN_SIZE(0),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_PBUF) + CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_POOL_BUF)
                         };
__align(4)UINT8 Memp_Memory[CH563NET_MEMP_SIZE];
__align(4)UINT8 Mem_Heap_Memory[CH563NET_RAM_HEAP_SIZE];
__align(4)UINT8 Mem_ArpTable[CH563NET_RAM_ARP_TABLE_SIZE];


#define CH563NET_TIMEPERIOD                    50                               /* ʱʱڣλmS*/

/******************************************************************************/
/* ʾغ */
#define RECE_BUF_LEN                          536                               /* ջĴС */
/* CH563NET_TCPMSSΪ536ֽڣһTCPݲΪ536ֽ */
/* TCPЭջûڽأֵΪsocketĽջȡ趨 */
/* RX_QUEUE_ENTRIESʱҪMSSʹ֮Ĺϵ細ֵΪ4*MSSԶһλᷢ */
/* 4TCPRX_QUEUE_ENTRIESС4ȻᵼݰʧӶͨѶЧʽ */
/* RX_QUEUE_ENTRIESҪ( /MSS ),socketͬʱдݣ */
/* RX_QUEUE_ENTRIESҪ(( /MSS )*socket) ڶsocketͬʱдշʱ */
/* Ϊ˽ԼRAM뽫ջĳΪMSS */
UINT8 SocketRecvBuf[CH563NET_MAX_SOCKET_NUM][RECE_BUF_LEN];                     /* socketջ */
/******************************************************************************/
/* CH563ض */
UINT8 MACAddr[6] = {0x02,0x03,0x04,0x05,0x06,0x07};                             /* CH563MACַ */ 
const UINT8 IPAddr[4] =  {192,168,1,10};                                        /* CH563IPַ */ 
const UINT8 GWIPAddr[4] ={192,168,1,1};                                         /* CH563 */
const UINT8 IPMask[4] =  {255,255,255,0};                                       /* CH563 */ 

/* ض */
extern FTP ftp;        
char  UserName[16];                                                             /* ڱû */
char  SourIP[17];                                                               /* ڱתַIPַ */
#if Access_Authflag
char  *pUserName = "anonymous";                                                 /* Էʷûû޷ʷ */
#endif
char  *pPassWord = "IEUser@";                                                   /* Ȩ޵루ֶֻ֧ */
UINT8 SocketId;    
UINT8 SerPort;                                                                  /* socketԲö */
/*******************************************************************************
* Function Name  : IRQ_Handler
* Description    : IRQжϷ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
__irq void IRQ_Handler( void )
{
    if(R32_INT_FLAG & 0x8000)                                                   /* ̫ж */
    {                                                                           /* ̫жжϷ */
        CH563NET_ETHIsr();
    }
    if(R32_INT_FLAG & RB_IF_TMR0)                                               /* ʱж */
    {
         CH563NET_TimeIsr(CH563NET_TIMEPERIOD);                                 /* CH563NET_ ʱжϷ */
         R8_TMR0_INT_FLAG |= 0xff;                                              /* ʱжϱ־ */
         ftp.TimeCount++;
         if(ftp.TimeCount>250) ftp.TimeCount = 0; 
    }
}
__irq void FIQ_Handler( void )
{
    while(1);
}
/*******************************************************************************
* Function Name  : SysTimeInit
* Description    : ϵͳʱʼCH563@100MHZ TIME0 10msCH563NET_TIMEPERIOD
*                ʼʱ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void SysTimeInit(void)
{
    R8_TMR0_CTRL_MOD = RB_TMR_ALL_CLEAR;
    R32_TMR0_COUNT = 0x00000000; 
    R32_TMR0_CNT_END = 0x186a0 * CH563NET_TIMEPERIOD;                           /* Ϊ10MSʱ */
    R8_TMR0_INTER_EN |= RB_TMR_IE_CYC_END;
    R8_TMR0_CTRL_MOD = RB_TMR_COUNT_EN;
}

/*******************************************************************************
* Function Name  : InitSysHal
* Description    : ӲʼTIM0ETHж
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void InitSysHal(void)
{
    R8_INT_EN_IRQ_0 |= RB_IE_IRQ_TMR0;                                          /* TIM0ж */
    R8_INT_EN_IRQ_1 |= RB_IE_IRQ_ETH;                                           /* ETHж */
    R8_INT_EN_IRQ_GLOB |= RB_IE_IRQ_GLOB;                                       /* IRQȫж */
}

/*******************************************************************************
* Function Name  : mStopIfError
* Description    : ʹãʾ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void mStopIfError(UINT8 iError)
{
    if (iError == CH563NET_ERR_SUCCESS) return;                                 /* ɹ */
    PRINT("Error: %02X\n", (UINT16)iError);                                     /* ʾ */
}

/*******************************************************************************
* Function Name  : CH563NET_LibInit
* Description    : ʼ
* Input          : ip      ipַָ
*                gwip    ipַָ
*                 : mask    ָ
*                 : macaddr MACַָ 
* Output         : None
* Return         : ִ״̬
*******************************************************************************/
UINT8 CH563NET_LibInit(const UINT8 *ip,const UINT8 *gwip,const UINT8 *mask,const UINT8 *macaddr)
{
    UINT8 i;
    struct _CH563_CFG cfg;
    if(CH563NET_GetVer() != CH563NET_LIB_VER)return 0xfc;                       /* ȡİ汾ţǷͷļһ */
    CH563NETConfig = LIB_CFG_VALUE;                                             /* Ϣݸñ */
    cfg.RxBufSize = RX_BUF_SIZE; 
    cfg.TCPMss   = CH563NET_TCP_MSS;
    cfg.HeapSize = CH563_MEM_HEAP_SIZE;
    cfg.ARPTableNum = CH563NET_NUM_ARP_TABLE;
    cfg.MiscConfig0 = CH563NET_MISC_CONFIG0;
    CH563NET_ConfigLIB(&cfg);
    i = CH563NET_Init(ip,gwip,mask,macaddr);
    return (i);                      /* ʼ */
}

/*******************************************************************************
* Function Name  : CH563NET_HandleSokcetInt
* Description    : socketжϴ
* Input          : sockeid  socket
*                initstat ж״̬
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET_HandleSokcetInt(UINT8 sockeid,UINT8 initstat)
{
    UINT32 len;

    PRINT("sockeid = %02x\n",sockeid);                           
    if(initstat & SINT_STAT_RECV)                                               /* ж */
    {
        len = CH563NET_SocketRecvLen(sockeid,NULL);                             /* Ὣǰָ봫ݸprecv*/
        CH563NET_SocketRecv(sockeid,SocketRecvBuf[sockeid],&len);               /* ջݶMyBuf*/
        PRINT("Receive Len = %02x\n",len);                           
        PRINT("MyBuf:\n%s\n\n",SocketRecvBuf[sockeid]);                           
        ftp.TimeCount = 0;
        CH563NET_FTPHandleDatRece((char *)SocketRecvBuf[sockeid],sockeid);
           memset((void *)SocketRecvBuf[sockeid],'\0',sizeof(SocketRecvBuf[sockeid]));              
    }
    if(initstat & SINT_STAT_CONNECT)                                            /* TCPж */
    {
        /* CH563NET_ModifyRecvBuf                                         */
        /* TCP SERVERģʽ£⵽TCPӣCH563NET_ԶΪ       */
        /* ӷһsocketϢsocketûзջ       */
        /* TCP Serverģʽ£һյжϺӦòӦ     */
        /* CH563NET_ModifyRecvBufΪsocketһ                 */
        /* CH563NET_ModifyRecvBufþΪsocket仺ģʽ   */
        /* ͬʹãҪ˫ʱʱ޸Ľջĵַͳ   */
        /* TCP Serverģʽ£CH563NET_ͻ˵Ӷsocket*/
        /* пеϢбӺϷͻӣReset      */
        PRINT("TCP Connect Success\n");                           
        CH563NET_ModifyRecvBuf(sockeid,(UINT32)SocketRecvBuf[sockeid],RECE_BUF_LEN); 
        memset((void *)SocketRecvBuf[SocketId],'\0',sizeof(SocketRecvBuf[SocketId]));              
        CH563NET_FTPGetSockeID( sockeid );
    }
    if(initstat & SINT_STAT_DISCONNECT)                                         /* TCPϿж */
    {
        PRINT("TCP Disconnect\n");                                              /* Ӧ´ */
        if( sockeid == ftp.SocketCtlConnect ){
            ftp.AuthFlag = 0;
            ftp.TcpCtlSta = FTP_MACH_DISCONT; 
            ftp.SocketCtlConnect = 255;
        }
        else if( sockeid == ftp.SocketCtlMonitor ){
            ftp.AuthFlag = 0;
            CH563NET_FTPCtlServer(  );
        } 
        else if( sockeid == ftp.SocketDatConnect ){
            ftp.TcpDatSta = FTP_MACH_DISCONT;
            ftp.SocketDatConnect = 255;
        } 
        else if( sockeid == ftp.SocketDatMonitor ){
            ftp.SocketDatConnect = 255;
        } 
    }
    if(initstat & SINT_STAT_TIM_OUT)                                            /* TCPʱж */
    {
                                                                                /* жϣCH563NET_ڲὫsocketΪر*/
        PRINT("TCP Timout\n");                                                  /* Ӧò´ */
        if( sockeid == ftp.SocketCtlConnect ){
            ftp.TcpCtlSta = FTP_MACH_DISCONT; 
            ftp.AuthFlag = 0;
            ftp.SocketCtlConnect = 255;
        }
        else if( sockeid == ftp.SocketCtlMonitor ){
            ftp.AuthFlag = 0;
            CH563NET_FTPCtlServer(  );
        } 
        else if( sockeid == ftp.SocketDatConnect ){
            ftp.TcpDatSta = FTP_MACH_DISCONT;
            ftp.SocketDatConnect = 255;
        } 
        else if( sockeid == ftp.SocketDatMonitor ){
            ftp.SocketDatConnect = 255;
        } 
    }
}
/*******************************************************************************
* Function Name  : CH563NET_HandleGlobalInt
* Description    : ȫжϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET_HandleGlobalInt(void)
{
    UINT8 initstat;
    UINT8 i;
    UINT8 socketinit;

    initstat = CH563NET_GetGlobalInt();                                         /* ȫж״̬ */
    if(initstat & GINT_STAT_UNREACH)                                            /* ɴж */
    {
        PRINT("UnreachCode %d\n",CH563Inf.UnreachCode);                       /* 鿴ɴ */
        PRINT("UnreachProto %d\n",CH563Inf.UnreachProto);                     /* 鿴ɴЭ */
        PRINT("UnreachPort %d\n",CH563Inf.UnreachPort);                       /* ѯɴ˿ */
    }
   if(initstat & GINT_STAT_IP_CONFLI)                                           /* IPͻж */
   {
   
   }
   if(initstat & GINT_STAT_PHY_CHANGE)                                          /* PHYıж */
   {
       i = CH563NET_GetPHYStatus();                                             /* ȡPHY״̬ */
       PRINT("GINT_STAT_PHY_CHANGE %02x\n",i);
   }
   if(initstat & GINT_STAT_SOCKET)                                              /* Socketж */
   {
       for(i = 0; i < CH563NET_MAX_SOCKET_NUM; i ++)                     
       {
           socketinit = CH563NET_GetSocketInt(i);                               /* socketжϲ */
           if(socketinit)CH563NET_HandleSokcetInt(i,socketinit);                /* ж */
       }    
   }
}

/*******************************************************************************
* Function Name  : CH563NET_FTPCtlServer
* Description    : TCP Server socket
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET_FTPCtlServer(void)
{
   UINT8 i;                                                             
   SOCK_INF TmpSocketInf;                                                       /* ʱsocket */

   memset((void *)&TmpSocketInf,0,sizeof(SOCK_INF));                            /* ڲὫ˱ƣýʱȫ */
   TmpSocketInf.SourPort = 21;                                                  /* Դ˿ */
   TmpSocketInf.ProtoType = PROTO_TYPE_TCP;                                     /* socekt */
   i = CH563NET_SocketCreat(&SocketId,&TmpSocketInf);                           /* socketصsocketSocketId */
   mStopIfError(i);                                                             /*  */
   ftp.SocketCtlMonitor = SocketId; 
   i = CH563NET_SocketListen(SocketId);                                         /* TCP */
   PRINT("SocketId ctl:%d\n",(UINT16)SocketId);
   mStopIfError(i);                                                             /*  */
}

/*******************************************************************************
* Function Name  : CH563NET_FTPServerDat
* Description    : TCP Server socket
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET_FTPServerDat( UINT16 *port )
{
   UINT8 i;
   SOCK_INF TmpSocketInf;                                                       /* ʱsocket */
 
   if(SerPort < 100||SerPort > 200) SerPort = 100;
   SerPort++;
   memset((void *)&TmpSocketInf,0,sizeof(SOCK_INF));                            /* ڲὫ˱ƣýʱȫ */
   TmpSocketInf.SourPort = 256*5 + SerPort;                                     /* Դ˿ */
   *port = TmpSocketInf.SourPort; 
   TmpSocketInf.ProtoType = PROTO_TYPE_TCP;                                     /* socekt */
   i = CH563NET_SocketCreat(&SocketId,&TmpSocketInf);                           /* socketصsocketSocketId */
   mStopIfError(i);                                                             /*  */
   ftp.SocketDatMonitor = SocketId; 
   i = CH563NET_SocketListen(SocketId);                                         /* TCP */
   PRINT("SocketId dat server:%d\n",(UINT16)SocketId);
   mStopIfError(i);                                                             /*  */
}

/*******************************************************************************
* Function Name  : CH563NET_FTPClientDat
* Description    : TCP Server socket
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET_FTPClientDat( UINT16 port,UINT8 *pAddr )
{
   UINT8 i;                                                             
   SOCK_INF TmpSocketInf;                                                       /* ʱsocket */

   memset((void *)&TmpSocketInf,0,sizeof(SOCK_INF));                            /* ڲὫ˱ƣýʱȫ */
   memcpy((void *)TmpSocketInf.IPAddr,pAddr,4);
   TmpSocketInf.SourPort = 20;                                                  /* Դ˿ */
   TmpSocketInf.DesPort = port;
   TmpSocketInf.ProtoType = PROTO_TYPE_TCP;                                     /* socekt */
   i = CH563NET_SocketCreat(&SocketId,&TmpSocketInf);                           /* socketصsocketSocketId */
   TmpSocketInf.RecvStartPoint = (UINT32)SocketRecvBuf[SocketId];               /* ýջĽջ */
   TmpSocketInf.RecvBufLen = RECE_BUF_LEN ;                                     /* ýջĽճ */
   ftp.SocketDatConnect = SocketId;
   PRINT("SocketId dat client:%d\n",(UINT16)SocketId);
  mStopIfError(i);                                                              /*  */
   i = CH563NET_SocketConnect(SocketId);                                        /* TCP */
   mStopIfError(i);                                                             /*  */
   memset((void *)SocketRecvBuf[SocketId],'\0',sizeof(SocketRecvBuf[SocketId]));              
}

/*******************************************************************************
* Function Name  : SendData
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET_FTPSendData( char *PSend, UINT32 Len,UINT8 index )
{
    UINT32 length;
    UINT8 i,*p,count;

    p = (UINT8 *)PSend;
    PRINT("send buf:\n%s\n",PSend);
    length = Len;
    count = 0;
    while(1){
        Len = length;
        i = CH563NET_SocketSend(index,p,&Len);                                  /* MyBufеݷ */
        mStopIfError(i);                                                        /*  */
        if(Len == 0){
            count++;
            if(count>2){
                PRINT("Send Data  fail\n");
                return;
            } 
        }
        length -= Len;                                                          /* ܳȼȥԼϵĳ */
        p += Len;                                                               /* ָƫ */
        if(length)continue;                                                     /* δϣ */
        break;                                                                  /* ϣ˳ */
    }
    PRINT("Send Data  Success\n");
    ftp.TimeCount = 0;
}

/*******************************************************************************
* Function Name  : CH563NET_FTPGetSockeID
* Description    : ȡsocketid
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET_FTPGetSockeID( UINT8 socketid )
{
    UINT8 i;

    if(SocketInf[socketid].SourPort == 21){
        if(ftp.TcpCtlSta <= FTP_MACH_DISCONT){
            ftp.SocketCtlConnect = socketid;
            ftp.TcpCtlSta = FTP_MACH_CONNECT;
        }
        else{
            CH563NET_SocketClose( socketid,TCP_CLOSE_NORMAL );
        }
    }
    if(SocketInf[socketid].SourPort == 20||SocketInf[socketid].SourPort == (256*5 + SerPort)){
        if(ftp.TcpDatSta <= FTP_MACH_DISCONT){
            ftp.TcpDatSta = FTP_MACH_CONNECT;
            ftp.SocketDatConnect = socketid;
        }
        else{
            i = CH563NET_SocketClose( socketid,TCP_CLOSE_NORMAL );              /* ֻһͻӽշ */
            mStopIfError( i ); 
            PRINT("ERROR: only support a socket connected\n");
        }
    }
}
/*******************************************************************************
* Function Name  : CH563NET_FTPInitVari
* Description    : ʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET_FTPInitVari( )
{
    FTP   *pFTP;
    UINT8 i,j;

    pFTP = &ftp;
    memset((void *)pFTP,'\0',sizeof(ftp));
    ftp.SocketDatMonitor = 255;
    ftp.SocketDatConnect = 255;
    ftp.SocketCtlMonitor = 255;
    ftp.SocketCtlConnect = 255; 
    memset((void *)SourIP,'\0',sizeof(SourIP));                   
    j = 0;
    for(i=0;i<4;i++){                                                           /* ʮƵIPַתҪַʽ */
        if( IPAddr[i]/100 ){
            SourIP[j++] = IPAddr[i]/100 + '0';
            SourIP[j++] = (IPAddr[i]%100)/10 + '0' ;
            SourIP[j++] = IPAddr[i]%10 + '0';
        } 
        else if( IPAddr[i]/10 ){
            SourIP[j++] = IPAddr[i]/10 + '0';
            SourIP[j++] = IPAddr[i]%10 + '0';
        } 
        else SourIP[j++] = IPAddr[i]%10 + '0';
         SourIP[j++] = '.';
    }
    mInitFtpList( );
}

/*******************************************************************************
* Function Name  : mInitSTDIO
* Description    : Ϊprintfgetkeyʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void mInitSTDIO( void )
{
    UINT32    x, x2;

    x = 10 * FREQ_SYS * 2 / 16 / 115200;                                        /* 115200bps */
    x2 = x % 10;
    x /= 10;
    if ( x2 >= 5 ) x ++;                                                        /*  */
    R8_UART0_LCR = 0x80;                                                        /* DLABλ1 */
    R8_UART0_DIV = 1;                                                           /* ԤƵ */
    R8_UART0_DLM = x>>8;
    R8_UART0_DLL = x&0xff;

    R8_UART0_LCR = RB_LCR_WORD_SZ ;                                             /* ֽڳΪ8 */
    R8_UART0_FCR = RB_FCR_FIFO_TRIG|RB_FCR_TX_FIFO_CLR|RB_FCR_RX_FIFO_CLR |    
                   RB_FCR_FIFO_EN ;                                             /* FIFOΪ14巢ͺͽFIFOFIFOʹ */
    R8_UART0_IER = RB_IER_TXD_EN;                                               /* TXD enable */
    R32_PB_SMT |= RXD0|TXD0;                                                    /* RXD1 schmitt input, TXD1 slow rate */
    R32_PB_PD &= ~ RXD0;                                                        /* disable pulldown for RXD0, keep pullup */
    R32_PB_DIR |= TXD0;                                                         /* TXD1 output enable */
}

/*******************************************************************************
* Function Name  : fputc
* Description    : ͨϢ
* Input          : c-- writes the character specified by c 
*                  *f--the output stream pointed to by *f
* Output         : None
* Return         : None
*******************************************************************************/

int fputc( int c, FILE *f )
{
    R8_UART0_THR = c;                                                           /*  */
    while( ( R8_UART0_LSR & RB_LSR_TX_FIFO_EMP ) == 0 );                        /* ȴݷ */
    return( c );
}

/*******************************************************************************
* Function Name  : CH563NET_FTPConnect
* Description    : ch563ʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET_FTPConnect( void ) 
{
    UINT8 i = 0;

    i = CH56X_GetMac(MACAddr);
    CH563NET_FTPInitVari( );
    i = CH563NET_LibInit(IPAddr,GWIPAddr,IPMask,MACAddr);                       /* ʼ */
    mStopIfError(i);                                                            /*  */
    PRINT("CH563NET_LibInit Success\n");
    SysTimeInit( );                                                             /* ϵͳʱʼ */
    InitSysHal( );                                                              /* ʼж */
    CH563NET_FTPCtlServer( );
}

/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
int main( void )
{
    mInitSTDIO( );                                                              /* Ϊüͨڼʾ */
    CH563NET_FTPConnect( );                                                     /* TCP FTP */
    while(1){
        CH563NET_MainTask( );                                                   /* CH563NETҪѭвϵ */ 
        if( CH563NET_QueryGlobalInt() )CH563NET_HandleGlobalInt( );             /* ѯжϣжϣȫжϴ */ 
        CH563NET_FTPServerCmd( );                                               /* ѯ״ִ̬Ӧ */
    }
}

/*********************************** endfile **********************************/
