/********************************** (C) COPYRIGHT *********************************
* File Name          : POP3.H
* Author             : WCH
* Version            : V1.0
* Date               : 2013/11/15
* Description        : Define for ch563pop3.c
**********************************************************************************/
#ifndef __POP3_H__
#define __POP3_H__
//================================================================================
extern  UINT8 OrderType;                       // 
extern  UINT8 CheckType;      
extern  UINT8 ReceDatFlag;                     // յݱ־λ
extern  UINT16 ReceLen;    
//=================================================================================
#define attach_max_len              512        // ͸󳤶ȣĬΪ512   
#define POP3_SERVER_PORT            110        // ʼĿĶ˵
#define SMTP_SERVER_PORT            25         // ʼĿĶ˵
#define DEBUG                        1         //     -- 115200
typedef struct
{
    UINT8 Socket;               
    UINT8 EncodeType;                          // ʼʹõı뷽ʽ
    UINT8 AnalyMailDat;                        // ʼ־λ
    UINT8 identitycheck;                       // ֤ݱ־λ
    UINT8 RefreshTime;                         // ûѲ鵽ʼ־λ
    UINT8 DiscnntFlag;
    UINT8 ReceFlag;
    char  sBufTime[40];                        // ʼʱ
    char  Ccname[48];                          // ͵
    char  DecodeRName[32];                     // յʼķ
    char  pPop3Server[32];                     // POP
    char  pPop3UserName[32];                   // POP½û
    char  pPop3PassWd[32];                     // POP½
}POP;
/* popʼ */
extern const char *p_Server;                   // POP
extern const char *p_UserName;                 // POP½û
extern const char *p_PassWord;                 // POP½
/* CH563ض */                                                                   
extern UINT8 MACAddr[6];                       // CH563MACַ 
extern const UINT8 IPAddr[4];                  // CH563IPַ 
extern const UINT8 GWIPAddr[4];                // CH563 
extern const UINT8 IPMask[4];                  // CH563 
/* socketpop3 ض, POPʼ*/                                              
extern const UINT8  Socketpop3IP[4];           // Socket pop3ĿIPַ
extern const UINT16  Pop3SourPrt;              // Socket pop3Դ˿ں

/************************************************************************************************************************
* POPѡ
************************************************************************************************************************/
#define POP_RTER        1                      // 1 serverʼȫı
#define POP_DELE        1                      // 2 ɾ
//    #define POP_RSET    1                    // 3 еDELE
//    #define POP_TOP        1                 // 4 nʼǰm
//    #define POP_UIDL    1                    // 5 serverڸָʼΨһʶûָеġ
#define POP_REFRESH        1                   // ʼûյʼѯ־ 
/************************************************************************************************************************
*  
* 0x01-0x0f Ϊʼ
****************** 0x01-0x07 Ϊ
****************** 0x09-0x0e ΪPѡ
****************** 0x01-0x02-0x03-0x06 Ϊȷ״̬
****************** 0x04-0x05 0x09-0x0e Ϊ״̬
* 0x10-0x1f Ϊʼ
****************** 0x10-0x17 谴˳ִ
****************** Ϊѡ
* 0x00         κβ
************************************************************************************************************************/
#define NOOP                    0x00
//POP RECEIVE CODE
#define POP_RECEIVE_USER        0x01    // ֤û
#define POP_RECEIVE_PASS        0x02    // ֤
#define POP_RECEIVE_STAT        0x03    // ͳ
#define POP_RECEIVE_LIST        0x04    // ָʼĴС
#define POP_RECEIVE_RTER        0x05    // ȡʼȫı
#define POP_RECEIVE_QUIT        0x06    // ˳½
#define POP_CLOSE_SOCKET        0x07    // رpopsocket
#define POP_RECEIVE_START       0x08    // ʼ
#define POP_RECEIVE_DELE        0x09    // ɾ
#define POP_RECEIVE_RSET        0x0a    // еDELE
#define POP_RECEIVE_TOP         0x0b    // nʼǰmݣmȻ
#define POP_RECEIVE_UIDL        0x0e    // ڸָʼΨһʶ
#define POP_ERR_CHECK           0x0F    // POPֳ˳½رsocket
/* *********************************************************************************************************************
* źź˶Դ
************************************************************************************************************************/
//POP ERR CHECK CODE
#define POP_ERR_CNNT            0x20     // popӴ--------------Ƕ˿ںţIPô
#define POP_ERR_USER            0x21     // ֤û-------ûʽԣUSER鿴͵˶Ƿȷͬ
#define POP_ERR_PASS            0x22     // ½ʧ-----------------û󣬻PASS
#define POP_ERR_STAT            0x23     // ȡʼϢ---------STATʧµ½绹ʧܼ
#define POP_ERR_LIST            0x24     // ȡʼϢб---------LIST
#define POP_ERR_RETR            0x25     // ȡָʼϢ---ȡʼڣRETR󣬻Ĳȷ
#define POP_ERR_DELE            0x26     // ɾĳʼʧ---------ɾʼڣRETR󣬻Ĳȷ
#define POP_ERR_QUIT            0x59     // ˳½ʧ-------------QUIT
#define POP_ERR_RSET            0x28     // ָɾʼ-----------RSET˳֮ǰִвЧ
#define POP_ERR_TOP             0x2B     // ȡĳʼǰmʧ----ȡʼڣRETR󣬻Ĳȷ
#define POP_ERR_UIDL            0x2C     // ȡĳʼIDʧ-------ʼڣUIDL󣬻Ĳȷ
#define POP_ERR_UNKW            0x2F     // popδ֪--------------δ֪
//
#define send_data_timeout       0x10     // ݳʱ
#define send_data_success       0x14     // ݳʱ

/***********************************************************************************************************************
*  
***********************************************************************************************************************/
//POP3  CODE
#define OPEN_SOCKET_RECEIVE     0xA0     // 򿪽socket
#define LOGIN_MAILBOX_RECEIVE   0xA1     // ½
#define READ_MAIL_STAT          0xA2     // ȡʼб
#define READ_MAIL_LIST          0xA3     // ȡʼб
#define READ_MAIL_MAILBODYDATA  0xA4     // ȡʼ
#define READ_MAIL_ATTACHMENT    0xA5     // ȡʼ
#define READ_MAIL_ADDRESS       0xA6     // ȡ˵ַ
#define READ_MAIL_TIME          0xA7     // ȡʱ
#define READ_MAIL_SUBJECT       0xA8     // ȡʼ
#define QUIT_RECEIVE_MAIL       0xA9     // ˳½رsocket
//SMTP  CODE
#define OPEN_SOCKET_SEND        0xB0     // 򿪷socket
#define LOGIN_MAILBOX_SEND      0xB1     // ½
#define SEND_MAIL_UNATTACH      0xB2     // ʼ
#define SEND_MAIL_CONTATTACH    0xB3     // ʼ
#define QUIT_SEND_MAIL          0xB4     // ˳½رsocket
/***********************************************************************************************************************
* ˶ϢĴ 
* ɹCHECK_SUCCESSΪһ
* 󷵻ضӦĴ 
* źţҪ˶
***********************************************************************************************************************/
#define CHECK_SUCCESS              0
#define uncheck                    0
#define CHECK_ERROR                1
//POP CHECK CODE
// ӦϢȷء+0k 󷵻ء-ERR
#define POP_CHECK_CNNT            0x50    
#define POP_CHECK_USER            0x51    
#define POP_CHECK_PASS            0x52    
#define POP_CHECK_STAT            0x53
#define POP_CHECK_LIST            0x54    
#define POP_CHECK_RETR            0x55
#define POP_CHECK_DELE            0x56
#define POP_CHECK_SEAR            0x57
#define POP_CHECK_QUIT            0x58
#define POP_CHECK_RSET            0x59
#define POP_CHECK_APOP            0x5A
#define POP_CHECK_TOP             0x5B
#define POP_CHECK_UIDL            0x5C
//==============================================================================
void CH563NET_SendData( char *PSend, UINT32 Len,UINT8 type,UINT8 index  );      // 

void CH563NET_MAILInit(void);                                                   // 563ʼ

void CH563NET_POP3Init( void );                                                 // ʼʼ

void CH563NET_MailCmd( UINT8 choiceorder);                                      // ִжӦԶշ

void CH563NET_POP3Retr( UINT8 num );                                            // ȡĳʼ

void CH563NET_POP3Dele( UINT8 num );                                            // ɾĳʼ

void CH563NET_POP3Rset( void );                                                 // еɾ

void CH563NET_POP3Top( UINT8 num ,UINT8 m  );                                   // ȡĳʼǰm

void CH563NET_POP3Uidl( UINT8 num );                                            // ȡĳʼID

UINT8 CH563NET_CheckResponse( char *recv_buff,UINT8 check_type );               // ӦϢ

void CH563NET_Quit(UINT8 index );                                               // ˳½

void CH563NET_CreatTcpPop3( void );                                             // pop3

void CH563NET_ReplyMailBody( void );                                            // ظʼ

void CH563NET_MailQuery( void );

void CH563NET_AnalyseMailData( char *recv_buff );

void mStopIfError(UINT8 iError);

void CH563NET_HandleGloableInt( void );

//================================================================================
#endif
