/********************************** (C) COPYRIGHT *********************************
* File Name          : CH563FTPINC.H
* Author             : WCH
* Version            : V1.0
* Date               : 2013/11/15
* Description        : Define for CH563PING.C
**********************************************************************************/
#ifndef __CH563FTPINC_H__
#define __CH563FTPINC_H__
//=================================================================================
#define DEBUG                        1            // ------------115200


#define ICMP_SOKE_CON                0
#define ICMP_SEND_ERR                1
#define ICMP_SEND_SUC                2
#define ICMP_RECV_ERR                3
#define ICMP_RECV_SUC                4
#define ICMP_UNRECH                  5
#define ICMP_REPLY                   6
#define ICMP_REPLY_SUC               7
#define ICMP_KEEP_NO                10


#define ICMP_HEAD_TYPE               8
#define ICMP_HEAD_REPLY              0
#define ICMP_HEAD_CODE               0
#define ICMP_HEAD_ID                 512
#define ICMP_HEAD_SEQ                100
#define ICMP_DATA_BYTES              32

/*ICMPͷֶݽṹ*/
typedef struct _icmphdr 
{
    UINT8   i_type;                 /* ICMP */
    UINT8   i_code;                 /* еĴ */
    UINT16  i_cksum;                /* У */ 
    UINT16  i_id;                   /* Ωһıʶ */
    UINT16  i_seq;                  /* к */
    UINT8   i_data[32];
}IcmpHeader,*IcmpHead;

extern UINT8  IcmpSuc;
extern UINT32 TimeCount;

/* CH563ض */                                                                   
extern UINT8 MACAddr[6];                                                            /* CH563MACַ */ 
extern const UINT8 IPAddr[4];                                                       /* CH563IPַ */ 
extern const UINT8 GWIPAddr[4];                                                     /* CH563 */
extern const UINT8 IPMask[4];                                                       /* CH563 */ 
extern const UINT8 DestIP[4];
extern const UINT8 IPRawProto;                                                      /* IPЭ */


void CH563NET_PINGCmd( void );                                                      /* ѯ״ִ̬ */

void CH563NET_FTPSendData( char *PSend, UINT32 Len,UINT8 index );                   /*  */

void CH563NET_ProcessReceDat( char *recv_buff,UINT8 check_type,UINT8 socketid );    /* յ */

void CH563NET_PINGInit( void );                                                     /* 563ʼ */

void InitPing( void );

void InitParameter( void );

void Respond_Ping( UINT8 *pDat );

void mStopIfError( UINT8 iError );

void CH563NET_HandleGloableInt( void );

void CH563NET_PINGSendData( UINT8 *PSend, UINT32 Len,UINT8 index );

void CH563NET_IcmpRecvData( UINT32 len, UINT8 *pDat );
#endif    // __CH563FTPINC_H__
