/********************************** (C) COPYRIGHT ******************************
* File Name          : CH563.C
* Author             : WCH
* Version            : V1.0
* Date               : 2013/11/15
* Description        : CH563 WEB Server DEMO
*                      (1)CH563 Examples by KEIL3_V3.53;
*                      (2)1Ϣ,115200bps;
*                      (3)ʾWEB563ܣ563web 
                          ͨҳʵ563ãԼ
*******************************************************************************/
  

/******************************************************************************/
/* ͷļ*/
#include <stdio.h>
#include <string.h>
#include "CH563SFR.H"
#include "SYSFREQ.H"
#include   "HTTPS.H"
#include  "ISPXT56X.H"
#define CH563NET_DBG                          1

#define CH563NET_MAX_SOCKET_NUM              6                                 /* SocketĸûãĬΪ4Socket,Ϊ32 */
#define RX_QUEUE_ENTRIES                     4                                /* CH563 MACУֵС2,ĬΪ7Ϊ32 */
#define CH563NET_TCP_MSS                     1024                             /* tcp MSSĴС*/

#include "CH563NET.H"
/* ĻȫֱҪ壬е */
__align(16)UINT8    CH563MACRxDesBuf[(RX_QUEUE_ENTRIES )*16];                             /* MAC16ֽڶ */
__align(4) UINT8    CH563MACRxBuf[RX_QUEUE_ENTRIES*RX_BUF_SIZE];                          /* MACջ4ֽڶ */
__align(4) SOCK_INF SocketInf[CH563NET_MAX_SOCKET_NUM];                                   /* SocketϢ4ֽڶ */
const UINT16 MemNum[8] = {CH563NET_NUM_IPRAW,
                       CH563NET_NUM_UDP,
                       CH563NET_NUM_TCP,
                       CH563NET_NUM_TCP_LISTEN,
                       CH563NET_NUM_TCP_SEG,
                       CH563NET_NUM_IP_REASSDATA,
                       CH563NET_NUM_PBUF,
                       CH563NET_NUM_POOL_BUF
                       };
const UINT16 MemSize[8] = {CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_IPRAW_PCB),
                        CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_UDP_PCB),
                        CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_TCP_PCB),
                        CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_TCP_PCB_LISTEN),
                        CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_TCP_SEG),
                        CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_IP_REASSDATA),
                        CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_PBUF) + CH563NET_MEM_ALIGN_SIZE(0),
                        CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_PBUF) + CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_POOL_BUF)
                       };
__align(4)UINT8 Memp_Memory[CH563NET_MEMP_SIZE];
__align(4)UINT8 Mem_Heap_Memory[CH563NET_RAM_HEAP_SIZE];
__align(4)UINT8 Mem_ArpTable[CH563NET_RAM_ARP_TABLE_SIZE];
 
#define CH563NETTIMEPERIOD                   10                                           /* ʱʱڣλmS*/

/******************************************************************************/
/* ʾغ */
#define RECE_BUF_LEN                          1460                                        /* ջĴС */
#define CH563NET_DBG                           0                                          /* printfʹ */
/* CH563NETTCPMSSΪ536ֽڣһTCPݲΪ536ֽ */
/* TCPЭջûڽأֵΪsocketĽջȡ趨 */
/* RX_QUEUE_ENTRIESʱҪMSSʹ֮Ĺϵ細ֵΪ4*MSSԶһλᷢ */
/* 4TCPRX_QUEUE_ENTRIESС4ȻᵼݰʧӶͨѶЧʽ */
/* RX_QUEUE_ENTRIESҪ( /MSS ),socketͬʱдݣ */
/* RX_QUEUE_ENTRIESҪ(( /MSS )*socket) ڶsocketͬʱдշʱ */
/* Ϊ˽ԼRAM뽫ջĳΪMSS */

                       
UINT8 MACAddr[6];                                                                         /* CH563MACַ */
UINT8 IPAddr[4];                                                                         /* CH563IPַ */
UINT8 GWIPAddr[4];                                                                       /* CH563 */
UINT8 IPMask[4];                                                                         /* CH563 */
                                                                                             
/* ñ */
UINT8  SocketId,RecvBuffer[RECE_BUF_LEN];                                           
UINT8  SocketRecvBuf[CH563NET_MAX_SOCKET_NUM][RECE_BUF_LEN];                              /* socketջ */
UINT8 flag=0;                                                                             /*ձ־*/
/*******************************************************************************
* Function Name  : IRQ_Handler
* Description    : IRQжϷ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
__irq void IRQ_Handler( void )
{
    if(R32_INT_FLAG & 0x8000)                                                             /* ̫ж */
    {                                                                                     /* ̫жжϷ */
        CH563NET_ETHIsr();
    }
    if(R32_INT_FLAG & RB_IF_TMR0)                                                         /* ʱж */
    {
         CH563NET_TimeIsr(CH563NETTIMEPERIOD);                                            /* ʱжϷ */
         R8_TMR0_INT_FLAG |= 0xff;                                                        /* ʱжϱ־ */
   }
}
__irq void FIQ_Handler( void )
{
    while(1);
}

/*******************************************************************************
* Function Name  : SysTimeInit
* Description    : ϵͳʱʼCH563@100MHZ TIME0 10msCH563NETTIMEPERIOD
*                ʼʱ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void SysTimeInit(void)
{
    R8_TMR0_CTRL_MOD = RB_TMR_ALL_CLEAR;
    R32_TMR0_COUNT = 0x00000000; 
    R32_TMR0_CNT_END = 0x186a0 * CH563NETTIMEPERIOD;                                      /* Ϊ10MSʱ */
    R8_TMR0_INTER_EN |= RB_TMR_IE_CYC_END;
    R8_TMR0_CTRL_MOD = RB_TMR_COUNT_EN;
}

/*******************************************************************************
* Function Name  : InitSysHal
* Description    : ӲʼTIM0ETHж
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void InitSysHal(void)
{
    R8_INT_EN_IRQ_0 |= RB_IE_IRQ_TMR0;                                                    /* TIM0ж */
    R8_INT_EN_IRQ_1 |= RB_IE_IRQ_ETH;                                                     /* ETHж */
    R8_INT_EN_IRQ_GLOB |= RB_IE_IRQ_GLOB;                                                 /* IRQȫж */
}

/*******************************************************************************
* Function Name  : mStopIfError
* Description    : ʹãʾ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void mStopIfError(UINT8 iError)
{
    if (iError == CH563NET_ERR_SUCCESS) return;                                           /* ɹ */
#if CH563NET_DBG
    printf("Error: %02X\n", (UINT16)iError);                                              /* ʾ */
#endif    
}

/*******************************************************************************
* Function Name  : CH563NET_LibInit
* Description    : ʼ
* Input          : ip      ipַָ
*                gwip    ipַָ
*                 : mask    ָ
*                 : macaddr MACַָ 
* Output         : None
* Return         : ִ״̬
*******************************************************************************/
UINT8 CH563NET_LibInit(const UINT8 *ip,const UINT8 *gwip,const UINT8 *mask,const UINT8 *macaddr)
{
    UINT8 i;
    struct _CH563_CFG cfg;
    if(CH563NET_GetVer() != CH563NET_LIB_VER)return 0xfc;                                 /* ȡİ汾ţǷͷļһ */
    CH563NETConfig = LIB_CFG_VALUE;                                                       /* Ϣݸñ */
    cfg.RxBufSize = RX_BUF_SIZE; 
    cfg.TCPMss   = CH563NET_TCP_MSS;
    cfg.HeapSize = CH563_MEM_HEAP_SIZE;
    cfg.ARPTableNum = CH563NET_NUM_ARP_TABLE;
    cfg.MiscConfig0 = CH563NET_MISC_CONFIG0;
  CH563NET_ConfigLIB(&cfg);
    i = CH563NET_Init(ip,gwip,mask,macaddr);
    return (i);              
}

/*******************************************************************************
* Function Name  : CH563NET_HandleSockInt
* Description    : socketжϴ
* Input          : sockeid  socket
*                initstat ж״̬
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET_HandleSockInt(UINT8 sockeid,UINT8 initstat)
{
    UINT32 len;
     
    if(initstat & SINT_STAT_RECV)                                                         /* ж */
    {
        len = CH563NET_SocketRecvLen(sockeid,NULL);                                       /* ѯ */
    
      
#if CH563NET_DBG
        printf("Receive Len = %02x\n",len);                           
#endif
        if(len)
        {
            CH563NET_SocketRecv(sockeid,RecvBuffer,&len);                                /* յ󱣴RecvBuffer[]*/
            flag  =  1;
            socket=sockeid;
            //printf("sockint:%d",socket);
        }
        
      
    }
    if(initstat & SINT_STAT_CONNECT)                                                      /* TCPж */
    {
#if CH563NET_DBG                                                                          /* жϱʾTCPѾӣԽշ */
        printf("TCP Connect Success  %d\n",sockeid);                           
#endif
        /* CH563NET_ModifyRecvBuf                                       */
        /* TCP SERVERģʽ£⵽TCPӣCH563NETԶΪ      */
        /* ӷһsocketϢsocketûзջ     */
        /* TCP Serverģʽ£һյжϺӦòӦ   */
        /* CH563NET_ModifyRecvBufΪsocketһ               */
        /* CH563NET_ModifyRecvBufþΪsocket仺ģʽ */
        /* ͬʹãҪ˫ʱʱ޸Ľջĵַͳ */
        /* TCP Serverģʽ£ͻ˵Ӷsocket     */
        /* пеϢбӺϷͻӣReset    */
    
        CH563NET_ModifyRecvBuf(sockeid,(UINT32)SocketRecvBuf[sockeid],RECE_BUF_LEN);  
    }
    if(initstat & SINT_STAT_DISCONNECT)                                                   /* TCPϿж */
    {
#if CH563NET_DBG                                                                          /* жϣCH563NETڲὫsocketΪر*/
        printf("TCP Disconnect %d\n",sockeid);                                            /* Ӧ´ */
#endif

    }
    if(initstat & SINT_STAT_TIM_OUT)                                                      /* TCPʱж */
    {
#if CH563NET_DBG                                                                          /* жϣCH563NETڲὫsocketΪر*/
        printf("TCP Timout  %d\n",sockeid);                                               /* Ӧ´ */
#endif

    }

}

/*******************************************************************************
* Function Name  : CH563NET_HandleGlobalInt
* Description    : ȫжϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET_HandleGlobalInt(void)
{
    UINT8 initstat;
    UINT8 i;
    UINT8 socketinit;
    
    initstat = CH563NET_GetGlobalInt();                                                   /* ȫж״̬ */           
    if(initstat & GINT_STAT_UNREACH)                                                      /* ɴж */                     
    {                                                                                                                          
    }                                                                                                                          
   if(initstat & GINT_STAT_IP_CONFLI)                                                     /* IPͻж */                     
   {                                                                                                                           
                                                                                                                               
   }                                                                                                                           
   if(initstat & GINT_STAT_PHY_CHANGE)                                                    /* PHYıж */                    
   {                                                                                                                           
       i = CH563NET_GetPHYStatus();                                                       /* ȡPHY״̬ */                    
       #if CH563NET_DBG                                                                                                        
         printf("GINT_STAT_PHY_CHANGE %02x\n",i);                                                                              
       #endif                                                                                                                  
   }                                                                                                                           
   if(initstat & GINT_STAT_SOCKET)                                                        /* Socketж */                     
   {                                                                                                                           
       for(i = 0; i < CH563NET_MAX_SOCKET_NUM; i ++)                                                                           
       {                                                                                                                       
           socketinit = CH563NET_GetSocketInt(i);                                         /* socketжϲ */             
           if(socketinit)CH563NET_HandleSockInt(i,socketinit);                            /* ж */               
       }    
   }
}


void CH563NET_UdpServerRecv(struct _SCOK_INF *socinf,UINT32 ipaddr,UINT16 port,UINT8 *buf,UINT32 len)
{

    UINT8 ip_addr[4],i;               
    for(i=0;i<4;i++){
        ip_addr[i] = ipaddr&0xff;
        printf("%-4d",ip_addr[i]);
        ipaddr = ipaddr>>8;    
    }

    CH563NET_SocketUdpSendTo( socinf->SockIndex,buf,&len,ip_addr,port);
}

/*******************************************************************************
* Function Name  : CH563NET_CreatTcpSocket
* Description    : TCP Server scoket
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET_Creat_Web_TcpSocket(void)
{
   UINT8 i;                                                             
   SOCK_INF TmpSocketInf;                                                                 /* ʱsocket */                                       
   memset((void *)&TmpSocketInf,0,sizeof(SOCK_INF));                                      /* ڲὫ˱ƣýʱȫ */       
   TmpSocketInf.SourPort = 80;                                                            /* Դ˿ */                                               
   TmpSocketInf.ProtoType = PROTO_TYPE_TCP;                                               /* socekt */                                           
   i = CH563NET_SocketCreat(&SocketId,&TmpSocketInf);                                     /* socketصsocketSocketId */           
   mStopIfError(i);                                                                       /*  */                                                 
   i = CH563NET_SocketListen(SocketId);                                                   /* TCP */                                                  
   mStopIfError(i);                                                                       /*  */                                                 
}

void CH563NET_Creat_Cfg_Socket(UINT8 mode,UINT8 *Desip,UINT16 Desport,UINT16 Srcport)     /*ҳϢ563Ӧsocket*/
{
  UINT8 i;

  SOCK_INF TmpSocketInf;
   memset((void *)&TmpSocketInf,0,sizeof(SOCK_INF));    
  printf("desport: %d, srcport: %d\n",Desport,Srcport);
  printf("desip:%d.%d.%d.%d\n",Desip[0],Desip[1],Desip[2],Desip[3]);
  printf("mode %d\n",mode);
  switch(mode)
  {
    
;
    case MODE_TcpServer:
         TmpSocketInf.ProtoType = PROTO_TYPE_TCP; 
         TmpSocketInf.SourPort =Srcport;    
         i = CH563NET_SocketCreat(&SocketId,&TmpSocketInf);                           
         mStopIfError(i);                                                             
         i = CH563NET_SocketListen(SocketId);                                         
         mStopIfError(i); 
          break;
    case MODE_TcpClient:        
         TmpSocketInf.ProtoType = PROTO_TYPE_TCP;
         memcpy((void *)&TmpSocketInf.IPAddr,Desip,4);
         TmpSocketInf.SourPort =Srcport;
         TmpSocketInf.DesPort =Desport;
         TmpSocketInf.RecvStartPoint=(UINT32)SocketRecvBuf[3];
         TmpSocketInf.RecvBufLen= RECE_BUF_LEN;
         i=CH563NET_SocketCreat(&SocketId,&TmpSocketInf);
         mStopIfError(i);
         i=CH563NET_SocketConnect(SocketId);
         mStopIfError(i);
         break;
    default :
            break;      
  }
}  
          
/*******************************************************************************
* Function Name  : mInitSTDIO
* Description    : Ϊprintfgetkeyʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void mInitSTDIO( void )
{
    UINT32    x, x2;

    x = 10 * FREQ_SYS * 2 / 16 / 115200;                                        /* 115200bps */
    x2 = x % 10;
    x /= 10;
    if ( x2 >= 5 ) x ++;                                                        /*  */
    R8_UART0_LCR = 0x80;                                                        /* DLABλ1 */
    R8_UART0_DIV = 1;                                                           /* ԤƵ */
    R8_UART0_DLM = x>>8;
    R8_UART0_DLL = x&0xff;

    R8_UART0_LCR = RB_LCR_WORD_SZ ;                                             /* ֽڳΪ8 */
    R8_UART0_FCR = RB_FCR_FIFO_TRIG|RB_FCR_TX_FIFO_CLR|RB_FCR_RX_FIFO_CLR |    
                   RB_FCR_FIFO_EN ;                                             /* FIFOΪ14巢ͺͽFIFOFIFOʹ */
    R8_UART0_IER = RB_IER_TXD_EN;                                               /* TXD enable */
    R32_PB_SMT |= RXD0|TXD0;                                                    /* RXD0 schmitt input, TXD0 slow rate */
    R32_PB_PD &= ~ RXD0;                                                        /* disable pulldown for RXD0, keep pullup */
    R32_PB_DIR |= TXD0;                                                         /* TXD1 output enable */
}

/*******************************************************************************
* Function Name  : fputc
* Description    : ͨϢ
* Input          : c-- writes the character specified by c 
*                  *f--the output stream pointed to by *f
* Output         : None
* Return         : None
*******************************************************************************/

int fputc( int c, FILE *f )
{
    R8_UART0_THR = c;                                                           /*  */
    while( ( R8_UART0_LSR & RB_LSR_TX_FIFO_EMP ) == 0 );                        /* ȴݷ */
    return( c );
}

void CH563_RESET()                                                              /*563λ*/
{
   printf("reset\n");
   R8_SAFE_ACCESS_SIG=0X57;
   R8_SAFE_ACCESS_SIG=0XAB;
   R8_GLOB_RST_CFG=0X40 | RB_GLOB_FORCE_RST;
   R8_SAFE_ACCESS_SIG=0;  
} 



void CH563_Default()                                                            /*563ָȫ*/
{
   EEPROM_ERASE(Basic_Cfg_Address,4096);
   EEPROM_WRITE(Basic_Cfg_Address,Basic_Default,Basic_Cfg_Len);
   EEPROM_ERASE(Port_Cfg_Address,4096);
   EEPROM_WRITE(Port_Cfg_Address,Port_Default,Port_Cfg_Len);
   EEPROM_ERASE(Login_Cfg_Address,4096);
   EEPROM_WRITE(Login_Cfg_Address,Login_Default,Login_Cfg_Len);
   printf("563_default\n");

   CH563_RESET();
}
  


  
/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
int main(void) 
{

  UINT8 i = 0;


    UINT16 DESPORT,SRCPORT;
  
    mInitSTDIO( ); 
    R32_PB_PU  |=1<<6;
    R32_PB_DIR &=~(1<<6);

    if((R32_PB_PIN &(1<<6))==0){                                                         /*PB6Ϊֶָ*/                                                                                         
      Delay_ms(500);                                                                                                                                                                                           
      if((R32_PB_PIN&(1<<6))==0){                                                                                                                                                                              
        while((R32_PB_PIN&(1<<6))==0);                                                                                                                                                                         
        CH563_Default();                                                                                                                                                                                       
      }                                                                                                                                                                                                        
    }                                                                                                                                                                                                          
                                                                                                                                                                                                               
    EEPROM_READ(Basic_Cfg_Address,Basic_CfgBuf,Basic_Cfg_Len);                           /*EEPROMȡϢ*/                                                                                            
    EEPROM_READ(Port_Cfg_Address,Port_CfgBuf,Port_Cfg_Len);                                                                                                                                                    
    EEPROM_READ(Login_Cfg_Address,Login_CfgBuf,Login_Cfg_Len);                                                                                                                                                 
                                                                                                                                                                                                               
    if(Basic_CfgBuf->flag[0]!=0x57 || Basic_CfgBuf->flag[1]!=0xAB)                       /*жϢ־λжΪ˵EEPROMﱣϢ󣬻ָ*/                            
      CH563_Default();                                                                                                                                                                                         
    else{                                                                                                                                                                                                      
          if(Basic_CfgBuf->flag[0]!=0x57 || Basic_CfgBuf->flag[1]!=0xAB)                 /*жϢͬ*/                                                                                            
             CH563_Default();                                                                                                                                                                                  
          else{                                                                                                                                                                                                
              if(Basic_CfgBuf->flag[0]!=0x57 || Basic_CfgBuf->flag[1]!=0xAB)             /*жϢͬ*/                                                                                            
               CH563_Default();                                                                                                                                                                                
           }                                                                                                                                                                                                   
        }                                                                                                                                                                                                      
                                                                                                                                                                                                               
    memcpy(MACAddr,Basic_CfgBuf->mac,6);                                                                                                                                                                       
    memcpy(IPAddr,Basic_CfgBuf->ip,4);                                                                                                                                                                         
    memcpy(IPMask,Basic_CfgBuf->mask,4);                                                                                                                                                                       
    memcpy(GWIPAddr,Basic_CfgBuf->gateway,4);                                                                                                                                                                  
    printf("ch563ip:\n");                                                                                                                                                                                      
    for(i=0;i<4;i++)                                                                                                                                                                                           
     printf("%d.",IPAddr[i]);                                                                                                                                                                                  
    i = CH563NET_LibInit(IPAddr,GWIPAddr,IPMask,MACAddr);                                                                                                                                                      
    mStopIfError(i);                                                                     /*563 */                                                                                                  
#if CH563NET_DBG
    printf("CH563NETLibInit Success\n");
#endif 
    http_request = (st_http_request*)RecvBuffer;       
    SysTimeInit();                                                                       /* ϵͳʱʼ */
    InitSysHal();                                                                        /* ʼж */
    CH563NET_Creat_Web_TcpSocket();                                                      /* web server */ 
    
    DESPORT=Port_CfgBuf->des_port[0]*256+Port_CfgBuf->des_port[1];
    SRCPORT=Port_CfgBuf->src_port[0]*256+Port_CfgBuf->src_port[1];
    CH563NET_Creat_Cfg_Socket(Port_CfgBuf->mode,Port_CfgBuf->des_ip,DESPORT  ,SRCPORT);       
    Init_Para_Tab();                                                                     /*ʼ*/                                                    
    while(1)
    {
        CH563NET_MainTask();                                                             /* CH563NETҪѭвϵ */
        if(CH563NET_QueryGlobalInt())CH563NET_HandleGlobalInt();                         /* ѯжϣжϣȫжϴ */
        Web_Server( );                                                                   /*Web */        
    }
}

/*********************************** endfile **********************************/
