/********************************** (C) COPYRIGHT *******************************
* File Name          : Main.C
* Author             : WCH
* Version            : V1.20
* Date               : 2013/11/15
* Description        : CH563 USB Host Examples
*                      (1)CH563 USB Examples by KEIL3    
*                      (2)0Ϣ,115200bps
*                      (3)USB HOSTԲѯʽ
*                      (4): 
*                           FATļϵͳʽU̡
*                           ʾгָĿ¼µļԼ/öļ
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include <stdio.h>
#include <string.h>
#include "absacc.h"
#include "SYSFREQ.H"                                                            /* ϵͳͷļ */
#include "CH563SFR.H"
#include "EHCI_HCD.H"                                                           /* Ͳͷļ */
#include "CH563USBSFR.H"                                                        /* оƬUSBĴͷļ */
#include "Udisk.H"                                                              /* Udiskͷļ */
#include "PRINTF.H"                                                             /* ڴӡͷļ */

/******************************************************************************/
/*  */
UINT8 EHCI_Allocate_Buf[ EHCI_ALLOCATE_BUF_LEN ];                               /* ڴ仺(QHQTDȽṹҪ32ֽڶ, QHQTDڴʹ) */
__align( 4096 ) UINT8 EHCI_Data_Buf[ EHCI_DATA_BUF_LEN ];                       /* ڴݻ(Ҫ4K) */                                
__align( 4096 ) UINT8 EHCI_PERIODIC_LIST_Buf[ EHCI_PER_LISE_BUF_LEN ];          /* ֡б(Ҫ4K) */                                

/* Uؽṹ */
BULK_ONLY_CMD    mBOC;                                                          /* BulkOnlyṹ */
DISK_INFO        UDisk;                                                         /* Uؽṹ嶨 */                                                        

/******************************************************************************/                
/* ¶ϸ˵뿴CH56XUFI.Hļ */
#define DISK_BASE_BUF_LEN        20 * 1024                                      /* ĬϵĴݻСΪ512ֽ,ѡΪ20484096֧ĳЩU,Ϊ0ֹ.Hļж建ӦópDISK_BASE_BUFָ */
/* ҪôݻԽԼRAM,ôɽDISK_BASE_BUF_LENΪ0Խֹ.Hļж建,ӦóڵCH56xLibInit֮ǰõĻʼַpDISK_BASE_BUF */

//#define NO_DEFAULT_ACCESS_SECTOR    1                                         /* ֹĬϵĴдӳ,бдĳ */
#define NO_DEFAULT_FILE_ENUMER        1                                         /* ֹĬϵļöٻص,бдĳ */
#define UNSUPPORT_USB_HUB            1                                          /* Ĭϲ֧HUB */

#include "CH56XUFI.H"
#include "CH56XUFI.C"

/* һLEDڼʾĽ,͵ƽLED */
#define LED_OUT_INIT( )        { R32_PA_OUT |= ELINK; R32_PA_DIR |= ELINK; }    /* ELINK ߵƽΪ */
#define LED_OUT_ACT( )        { R32_PA_CLR |= ELINK; }                          /* ELINK ͵ƽLEDʾ */
#define LED_OUT_INACT( )    { R32_PA_OUT |= ELINK; }                            /* ELINK ߵƽرLEDʾ */

/*******************************************************************************
* Function Name  : IRQ_Handler
* Description    : IRQжϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
__irq void IRQ_Handler( void )
{
    while( 1 );
}

/*******************************************************************************
* Function Name  : FIQ_Handler
* Description    : FIQжϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
__irq void FIQ_Handler( void )
{
    while( 1 );
}

/*******************************************************************************
* Function Name  : mInitSTDIO
* Description    : Ϊprintfgetkeyʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void mInitSTDIO( void )
{
    UINT32    x, x2;

    x = 10 * FREQ_SYS * 2 / 16 / 115200;                                        /* 115200bps */
    x2 = x % 10;
    x /= 10;
    if ( x2 >= 5 ) x ++;                                                        /*  */
    R8_UART0_LCR = 0x80;                                                        /* DLABλ1 */
    R8_UART0_DIV = 1;                                                           /* ԤƵ */
    R8_UART0_DLM = x>>8;
    R8_UART0_DLL = x&0xff;

    R8_UART0_LCR = RB_LCR_WORD_SZ ;                                             /* ֽڳΪ8 */
    R8_UART0_FCR = RB_FCR_FIFO_TRIG|RB_FCR_TX_FIFO_CLR|RB_FCR_RX_FIFO_CLR |    
                   RB_FCR_FIFO_EN ;                                             /* FIFOΪ14巢ͺͽFIFOFIFOʹ */
    R8_UART0_IER = RB_IER_TXD_EN;                                               /* TXD enable */
    R32_PB_SMT |= RXD0|TXD0;                                                    /* RXD0 schmitt input, TXD0 slow rate */
    R32_PB_PD &= ~ RXD0;                                                        /* disable pulldown for RXD0, keep pullup */
    R32_PB_DIR |= TXD0;                                                         /* TXD0 output enable */
}

/*******************************************************************************
* Function Name  : fputc
* Description    : ͨϢ
* Input          : c-- writes the character specified by c 
*                  *f--the output stream pointed to by *f
* Output         : None
* Return         : None
*******************************************************************************/

int fputc( int c, FILE *f )
{
    R8_UART0_THR = c;                                                           /*  */
    while( ( R8_UART0_LSR & RB_LSR_TX_FIFO_EMP ) == 0 );                        /* ȴݷ */
    return( c );
}

/*******************************************************************************
* Function Name  : mStopIfError
* Description    : ״̬
*                  ʾ벢ͣ,Ӧ滻ΪʵʵĴʩ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void mStopIfError( UINT8 iError )
{
    if( iError == ERR_SUCCESS ) 
    {    
        return;                                                                 /* ɹ */
    }
    printf( "Error: %02X\n", (UINT16)iError );                                  /* ʾ */
    
    /* ,Ӧ÷ԼCH56xDiskStatus״̬,CH56xDiskConnectѯǰUǷ,UѶϿôµȴU̲ٲ,
       Ĵ:
       1һCH56xDiskReady,ɹ,Open,Read/Write,CH56xDiskReadyлԶCH56xDiskConnect
       2CH56xDiskReadyɹ,ôǿнCH56xDiskStatusΪDISK_CONNECT״̬,Ȼͷʼ(ȴUCH56xDiskConnectCH56xDiskReady) */
    while( 1 ) 
    {
        LED_OUT_ACT( );                                                         /* LED˸ */
        Delay_ms( 200 );
        LED_OUT_INACT( );
        Delay_ms( 200 );
    }
}

/*******************************************************************************
³ΪEXAM13öUļ
*******************************************************************************/
typedef struct _FILE_NAME 
{
    UINT32    DirStartClust;                                                    /* ļĿ¼ʼغ */
//    UINT32    Size;                                                           /* ļ */
    UINT8    Name[8+3+1+1];                                                     /* ļ,8+3ֽ,ָ,,ΪδĿ¼· */
    UINT8    Attr;                                                              /* ļ */
    UINT8    Reserved[2];                                                       /* for 4 bytes align */
}FILE_NAME;

#define    MAX_FILE_COUNT               200
FILE_NAME    FileNameBuffer[ MAX_FILE_COUNT ];                                  /* ļṹ */
UINT16    FileCount;
UINT32    CurrentDirStartClust;                                                 /* 浱ǰĿ¼ʼغ,ڼӿļöٺʹٶ */

/*******************************************************************************
* Function Name  : ListFile
* Description    : оָĿ¼µļ
*                  mCmdParam.Open.mPathName[]ΪĿ¼ַ,ʽļ
*                  ͬ,бĿ¼
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 ListFile( void )
{
    UINT8  i;

    printf( "List Directory: %s\n", mCmdParam.Open.mPathName );                 /* ʾĿ¼ */
    i = strlen( (PCCHAR)mCmdParam.Open.mPathName );                             /* ·ĳ,Ŀ¼Ľ */
    if( i && mCmdParam.Open.mPathName[ i - 1 ] == '/' )                         /* ǸĿ¼,Ѿ·ָ */
    { 
    }  
    else 
    {
        mCmdParam.Open.mPathName[ i++ ] = '/';                                  /* ڵǰĿ¼½ö,Ŀ¼ⶼ·,ǸĿ¼·ָ */
    }
    mCmdParam.Open.mPathName[ i++ ] = '*';                                      /* öͨ,·"\*""\C51\*""\C51\CH563*" */
    mCmdParam.Open.mPathName[ i ] = 0;                                          /*  */
    CH56xvFileSize = 0xFFFFFFFF;                                                /* ö,ÿҵһļһxFileNameEnumerصӳ,ֵС0x80000000ÿֻöһļ̫ */
    i = CH56xFileOpen( );                                                       /* ö,ɻصxFileNameEnumer¼浽ṹ */
    if( i == ERR_SUCCESS || i == ERR_FOUND_NAME || i == ERR_MISS_FILE ) 
    {  
        /* ɹ,ͨ᷵ERR_SUCCESS,xFileNameEnumerǰ˳ʱŻ᷵ERR_FOUND_NAME */
        printf( "Success, new FileCount = %d\n", FileCount );
        return( ERR_SUCCESS );
    }
    else 
    {
        printf( "Failed, new FileCount = %d\n", FileCount );
        return( i );
    }
}

/*******************************************************************************
* Function Name  : ListAll
* Description    : Թȵ㷨öUеļĿ¼
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 ListAll( void )
{
    UINT8  i;
    UINT16 OldFileCount;

    OldFileCount = FileCount = 0;                                               /* ļṹ */
    FileNameBuffer[ 0 ].Name[ 0 ] = '/';                                        /* Ŀ¼,·,Ŀ¼Ǿ·֮ⶼ· */
    FileNameBuffer[ 0 ].Name[ 1 ] = 0;
    FileNameBuffer[ 0 ].DirStartClust = 0;                                      /* Ŀ¼ */
    FileNameBuffer[ 0 ].Attr = ATTR_DIRECTORY;                                  /* Ŀ¼ҲĿ¼,Ϊһ¼ */

    for( FileCount = 1; OldFileCount < FileCount; OldFileCount ++ ) 
    {  
        /* öٵļṹδз */
        if( FileNameBuffer[ OldFileCount ].Attr & ATTR_DIRECTORY ) 
        {  
            /* Ŀ¼ */
            strcpy( (PCHAR)mCmdParam.Open.mPathName, (PCCHAR)FileNameBuffer[ OldFileCount ].Name );  /* Ŀ¼,Ŀ¼ⶼ· */
            CH56xvStartCluster = FileNameBuffer[ OldFileCount ].DirStartClust;  /* ǰĿ¼ϼĿ¼ʼغ,·,·ٶȿ */
            i = CH56xFileOpen( );                                               /* Ŀ¼,Ϊ˻ȡĿ¼ʼغٶ */
            if( i == ERR_SUCCESS ) 
            {
                return( ERR_MISS_DIR );                                         /* ӦǴĿ¼,ǷؽǴļ */
            }
            if( i != ERR_OPEN_DIR ) 
            {
                return( i );
            }
            if( OldFileCount ) 
            {
                CurrentDirStartClust = CH56xvStartCluster;                      /* ǸĿ¼,ȡĿ¼ʼغ */
            }
            else
            {  
                /* ǸĿ¼,ȡĿ¼ʼغ */
                if( CH56xvDiskFat == DISK_FAT32 ) 
                {
                    CurrentDirStartClust = CH56xvDiskRoot;                      /* FAT32Ŀ¼ */
                }
                else 
                {
                    CurrentDirStartClust = 0;                                   /* FAT12/FAT16Ŀ¼ */
                }
            }
            CH56xFileClose( );                                                  /* ڸĿ¼һҪر */
//            strcpy( mCmdParam.Open.mPathName, FileNameBuffer[ OldFileCount ].Name );  /* Ŀ¼,mPathNameδ޸ٸ */
            CH56xvStartCluster = FileNameBuffer[ OldFileCount ].DirStartClust;  /* ǰĿ¼ϼĿ¼ʼغ,·,·ٶȿ */
            i = ListFile( );                                                    /* öĿ¼,ɻصxFileNameEnumer¼浽ṹ */
            if( i != ERR_SUCCESS ) 
            {
                return( i );
            }
        }
    }

    /* UеļĿ¼ȫö,濪ʼݽṹ¼δļ */
    printf( "Total file&dir = %d, Open every file:\n", FileCount );
    for( OldFileCount = 0; OldFileCount < FileCount; OldFileCount ++ ) 
    {
        if( ( FileNameBuffer[ OldFileCount ].Attr & ATTR_DIRECTORY ) == 0 ) 
        {  
            /* ļ,Ŀ¼ */
            printf( "Open file: %s\n", FileNameBuffer[ OldFileCount ].Name );
            strcpy( (PCHAR)mCmdParam.Open.mPathName, (PCCHAR)FileNameBuffer[ OldFileCount ].Name );  /* · */
            CH56xvStartCluster = FileNameBuffer[ OldFileCount ].DirStartClust;  /* ǰļϼĿ¼ʼغ,·,·ٶȿ */
            i = CH56xFileOpen( );                                               /* ļ */
            if( i == ERR_SUCCESS ) 
            {  
                /* ɹļ */
                mCmdParam.Read.mDataBuffer = (PUINT8)( & EHCI_Data_Buf[ 0 ] );  /* ָļݻʼַ */
                mCmdParam.Read.mSectorCount = 1;                                /* ȡ */
                CH56xFileRead( );
//                CH56xFileClose( );                                            /* дر */
            }
        }
    }
    return( ERR_SUCCESS );
}

/*******************************************************************************
* Function Name  : xFileNameEnumer
* Description    : ļöٻصӳ,οCH56XUFI.Hļе
*                  ÿһļFileOpenñص,xFileNameEnumer
                   غ,FileOpenݼCH56xvFileSizeöֱļ
                   Ŀ¼.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void xFileNameEnumer( void )        
{  
    UINT8  i, c;
    P_FAT_DIR_INFO    pFileDir;
    PUINT8            pNameBuf;

    pFileDir = (P_FAT_DIR_INFO)( pDISK_BASE_BUF + CH56xvFdtOffset );            /* ǰFDTʼַ */
    if( pFileDir -> DIR_Name[ 0 ] == '.' ) 
    {
        return;                                                                 /* ǱϼĿ¼,붪 */
    }    
    if( ( pFileDir -> DIR_Attr & ATTR_DIRECTORY ) == 0 ) 
    {  
        /* жļ */
        if( pFileDir -> DIR_Name[ 8 ] == 'H' && pFileDir -> DIR_Name[ 9 ] == ' ' /* ļչ,".H"ļ,,Ǽǲ */
         || pFileDir -> DIR_Name[ 8 ] == 'E' && pFileDir -> DIR_Name[ 9 ] == 'X' && pFileDir -> DIR_Name[10] == 'E' ) 
        {
            return;                                                             /* չ".EXE"ļ, */
        }
    }
    pNameBuf = & FileNameBuffer[ FileCount ].Name[ 0 ];                         /* ļṹеļ */
    for( i = 0; i < 11; i ++ ) 
    {  
        /* ļ,Ϊ11ַ */
        c = pFileDir -> DIR_Name[ i ];
        if ( i == 0 && c == 0x05 ) 
        {
            c = 0xE5;                                                           /* ַ */
        }
        if( c != 0x20 ) 
        {  
            /* Чַ */
            if( i == 8 ) 
            {  
                /* չ */
                *pNameBuf = '.';                                                /* ָ */
                pNameBuf ++;
            }
            *pNameBuf = c;                                                      /* ļһַ */
            pNameBuf ++;
        }
    }
    *pNameBuf = 0;                                                              /* ǰļ·Ľ */
    FileNameBuffer[ FileCount ].DirStartClust = CurrentDirStartClust;           /* ¼ǰĿ¼ʼغ,ڼӿļٶ */
    FileNameBuffer[ FileCount ].Attr = pFileDir -> DIR_Attr;                    /* ļ */
    if( pFileDir -> DIR_Attr & ATTR_DIRECTORY ) 
    {  
        /* жĿ¼ */
        printf( "Dir %4d#: %s\n", FileCount, FileNameBuffer[ FileCount ].Name );
    }
    else 
    {  
        /* жļ */
        printf( "File%4d#: %s\n", FileCount, FileNameBuffer[ FileCount ].Name );
    }
    FileCount ++;                                                               /* ļ */
    if( FileCount >= MAX_FILE_COUNT ) 
    {  
        /* ļṹ̫С,ṹ */
        CH56xvFileSize = 1;                                                     /* ǿǰö,FileOpenٻصxFileNameEnumerǰ,ֹ */
        printf( "FileName Structure Full\n" );
    }
}

/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
int    main( void ) 
{
    UINT8  status;
    UINT8  i;

//    SysFreq( );                                                               /* ҪPLLӦʱƵ */
    LED_OUT_INIT( );
    LED_OUT_ACT( );                                                             /* LEDһʾ */
    Delay_ms( 100 );
    LED_OUT_INACT( );
    mInitSTDIO( );                                                              /* Ϊüͨڼʾ */

    printf( "CH563_FAT_EXAM13_V1.20_2013.08.12...................................\xd\xa" );

#if DISK_BASE_BUF_LEN == 0
    pDISK_BASE_BUF = &my_buffer[0];                                             /* .HļжCH563רû,ûָָӦóĻںԽԼRAM */
#endif

    /* USBسʼ */
    USBHOST_ModeSet( );                                                         /* USBģʽ */
    USBHOST_EHCI_Init( );                                                       /* USBEHCIλʼ */
    USBHOST_Structure_DeInit( );                                                /* USBݽṹʼ */
    USBHOST_DevicePara_Init( &UDisk.Device );                                   /* USBزʼ */

    i = CH56xLibInit( );                                                        /* ʼCH563CH563оƬ,ɹ0 */
    mStopIfError( i );
    /* ·ʼ */

    while ( 1 ) 
    {
        /***********************************************************************/
        /* ѯȴ豸 */
        printf("Wait USB Device In:\n" );

#ifdef UNSUPPORT_USB_HUB

        /* Ҫ֧USB-HUB,ôȴU̲ĳCH563,ͨCH56xDiskConnectѯ,ͨCH56xDiskReadyȴ,Ȼд */
        while ( CH56xDiskStatus < DISK_CONNECT ) 
        {  
            /* ѯCH563жϲж״̬,ȴU̲ */
            CH56xDiskConnect( );
            Delay_ms( 50 );                                                     /* ûҪƵѯ */
        }
        LED_OUT_ACT( );                                                         /* LED */
        Delay_ms( 200 );                                                        /* ʱ,ѡ,еUSB洢Ҫʮʱ */
    
        /* ʼ˵0 */            
        status = USBHOST_EHCI_EP0_Init( &UDisk.Device );                        /* USBƶ˵0ʼ */
        if( status != USB_OPERATE_SUCCESS )
        {            
            printf("USBHOST_EP0_Init Error\n");        
            while( 1 );
        }

        /* ڼ⵽USB豸,ȴ100*50mS,ҪЩMP3̫,ڼ⵽USB豸DISK_MOUNTED,ȴ5*50mS,ҪDiskReady */
        for( i = 0; i < 100; i ++ ) 
        {  
            /* ȴʱ,100*50mS */
            Delay_ms( 50 );
            printf( "Ready ?\n" );
            if( CH56xDiskReady( ) == ERR_SUCCESS ) 
            {
                break;                                                          /* ѯǷ׼ */
            }
            if( CH56xDiskStatus < DISK_CONNECT ) 
            {
                break;                                                          /* ⵽Ͽ,¼Ⲣʱ */
            }
            if( CH56xDiskStatus >= DISK_MOUNTED && i > 5 ) 
            {
                break;                                                          /* еUǷδ׼,Ժ,ֻҪ佨MOUNTEDҳ5*50mS */
            }
        }
        if( CH56xDiskStatus < DISK_CONNECT ) 
        {  
            /* ⵽Ͽ,¼Ⲣʱ */
            printf( "Device gone\n" );
            continue;                                                           /* µȴ */
        }
        if( CH56xDiskStatus < DISK_MOUNTED ) 
        {  
            /* δ֪USB豸,USB̡ӡ */
            printf( "Unknown device\n" );
            goto UnknownUsbDevice;
        }
        
#else

        /* Ҫ֧USB-HUB,ôοĵȴ */
        while ( 1 ) 
        {  
            /* ֧USB-HUB */
            Delay_ms( 50 );                                                     /* ûҪƵѯ */
            
            if( CH56xDiskConnect( ) == ERR_SUCCESS ) 
            {  
                /* ѯʽ: ǷӲ´״̬,سɹ˵ */
                Delay_ms( 200 );                                                /* ʱ,ѡ,еUSB洢Ҫʮʱ */

                /***********************************************************************/
                /* ʼ˵0 */    
                status = USBHOST_EP0_Init( );                                   /* USBƶ˵0ʼ */
                if( status != USB_OPERATE_SUCCESS )
                {
#ifdef  MY_DEBUG_PRINTF            
                    printf("USBHOST_EP0_Init Error\n");
#endif            
                    mStopIfError( status );
                }
        
                /* ڼ⵽USB豸,ȴ100*50mS,ҪЩMP3̫,ڼ⵽USB豸DISK_MOUNTED,ȴ5*50mS,ҪDiskReady */
                for( i = 0; i < 100; i ++ ) 
                {  
                    /* ȴʱ,100*50mS */
                    Delay_ms( 50 );
                    printf( "Ready ?\n" );
                    if( CH56xDiskReady( ) == ERR_SUCCESS ) 
                    {
                        break;                                                  /* ѯǷ׼ */
                    }
                    if( CH56xDiskStatus < DISK_CONNECT ) 
                    {  
                        /* ⵽Ͽ,¼Ⲣʱ */
                        printf( "Device gone\n" );
                        break;                                                  /* µȴ */
                    }
                    if( CH56xDiskStatus >= DISK_MOUNTED && i > 5 ) 
                    {
                        break;                                                  /* еUǷδ׼,Ժ,ֻҪ佨MOUNTEDҳ5*50mS */
                    }
                    if( CH56xDiskStatus == DISK_CONNECT ) 
                    {  
                        /* 豸 */
                        if( CH56xvHubPortCount ) 
                        {  
                            /* һUSB-HUB,ûU */
                            printf( "No Udisk in USB_HUB\n" );
                            break;
                        }
                        else
                        {  
                            /* δ֪USB豸,пU̷Ӧ̫,Ҫ */
                        }
                    }
                }
                if( CH56xDiskStatus >= DISK_MOUNTED ) 
                {  
                    /* U */
                    break;                                                      /* ʼU */
                }
                if( CH56xDiskStatus == DISK_CONNECT ) 
                {  
                    /* γԻǲ,ƲU */
                    if ( CH56xvHubPortCount ) 
                    {  
                        /* һUSB-HUB,ûU */
                        /* whileеȴHUB˿U */
                    }
                    else 
                    {  
                        /* δ֪USB豸,USB̡ӡ,Ѿ˺ܶλ */
                        printf( "Unknown device\n" );
                        goto UnknownUsbDevice;
                    }
                }
            }
        }
        LED_OUT_ACT( );                                                         /* LED */
#endif
        
        /* ʾUϢ */
        printf( "TotalSize = %lu MB \n", mCmdParam.DiskReady.mDiskSizeSec >> ( 20 - CH56xvSectorSizeB ) );  /* ʾΪMBΪλ */
        printf( "Current disk sector size = %d Bytes \n", CH56xvSectorSize );   /* CH56xvSectorSizeU̵ʵС */
#if DISK_BASE_BUF_LEN
        if( DISK_BASE_BUF_LEN < CH56xvSectorSize ) 
        {  
            /* ݻǷ㹻,CH56xvSectorSizeU̵ʵС */
            printf( "Too large sector size\n" );
            goto UnknownUsbDevice;
        }
#endif

        Delay_ms( 20 );
        printf( "List all file \n" );
        i = ListAll( );                                                         /* öUеļĿ¼ */
        mStopIfError( i );

UnknownUsbDevice:
        printf( "Take out\n" );
        while( 1 ) 
        {  
            /* ֧USB-HUB */
            Delay_ms( 10 );                                                     /* ûҪƵѯ */
            if( CH56xDiskConnect( ) != ERR_SUCCESS ) 
            {    
                break;                                                          /* ѯʽ: ǷӲ´״̬,سɹ˵ */
            }
        }
        LED_OUT_INACT( );                                                       /* LED */
        
        /* ³ʼUزԴ */
        USBHOST_DevicePara_Init( &UDisk.Device );                               /* USBزʼ */
        USBHOST_Structure_DeInit( );                                            /* USBݽṹʼ */        
        Delay_ms( 200 );
    }
}


