/* 2014.09.09
*****************************************
**   Copyright  (C)  W.ch  1999-2014   **
**   Web:      http://wch.cn           **
*****************************************
**  USB-flash File Interface for CH56x **
**  ADS 1.2, Keil 3.11/4.12 @ARM946E-S,v5TE **
*****************************************
*/
/* CH56x Uļϵͳӿ, ֧: FAT12/FAT16/FAT32 */

//#define DISK_BASE_BUF_LEN		512	/* ĬϵĴݻСΪ512ֽ,ѡΪ20484096֧ĳЩU,Ϊ0ֹڱļж建ӦópDISK_BASE_BUFָ */
/* ҪôݻԽԼRAM,ôɽDISK_BASE_BUF_LENΪ0Խֹڱļж建,ӦóڵCH56xLibInit֮ǰõĻʼַpDISK_BASE_BUF */

//#define NO_DEFAULT_ACCESS_SECTOR	1		/* ֹĬϵĴдӳ,бдĳ */
//#define NO_DEFAULT_FILE_ENUMER		1		/* ֹĬϵļöٻص,бдĳ */

//#include "CH56XBAS.H"
#include "CH56XUFI.H"

CMD_PARAM mCmdParam;						/*  */
#if DISK_BASE_BUF_LEN > 0
__align(8)	UINT8  DISK_BASE_BUF[ DISK_BASE_BUF_LEN ];	/* ⲿRAMĴݻ,Ϊһĳ */
#endif

/* ³ԸҪ޸ */

#ifndef NO_DEFAULT_ACCESS_SECTOR		/* ӦóжNO_DEFAULT_ACCESS_SECTORԽֹĬϵĴдӳ,Ȼбдĳ */

//if ( use_external_interface ) {  // 滻Uײдӳ
//    CH374vSectorSize=512;  // ʵʵС,ֵ512ı
//    CH56xvSectorSizeB=9;   // ʵʵСλ,512Ӧ9,1024Ӧ10,2048Ӧ11
//    CH374DiskStatus=DISK_MOUNTED;  // ǿƿ豸ӳɹ(ֻļϵͳ)
//}

#ifdef __UDISK_H__

extern BULK_ONLY_CMD	mBOC;

#else

typedef union _BULK_ONLY_CMD0 {
	struct {
		UINT32	mCBW_Sig;
		UINT32	mCBW_Tag;
		UINT32	mCBW_DataLen;			/* : ݴ䳤 */
		UINT8	mCBW_Flag;				/* : ䷽ȱ־ */
		UINT8	mCBW_LUN;
		UINT8	mCBW_CB_Len;			/* : ĳ,Чֵ116 */
		UINT8	mCBW_CB_Buf[16];		/* : ,ûΪ16ֽ */
	} mCBW;								/* BulkOnlyЭ, CBWṹ */
	struct {
		UINT32	mCSW_Sig;
		UINT32	mCSW_Tag;
		UINT32	mCSW_Residue;			/* : ʣݳ */
		UINT8	mCSW_Status;			/* : ִн״̬ */
		UINT8	mReserved;
	} mCSW;								/* BulkOnlyЭ״̬, CSWṹ */
} BULK_ONLY_CMD0;						/* CMD_BulkOnlyCmd, ִлBulkOnlyЭ, ݴôpDISK_BASE_BUF */

extern BULK_ONLY_CMD0	mBOC;

#endif

extern UINT8 MS_ScsiCmd_Process( UINT8 *DataBuf );

UINT8	CH56xReadSector( UINT32 StartLba, UINT32 SectCount, PUINT8 DataBuf )  /* Ӵ̶ȡݵ */
{
	UINT8	retry;
//	if ( use_external_interface ) return( extReadSector( StartLba, SectCount, DataBuf ) );  /* ⲿӿ */
	for( retry = 0; retry < 3; retry ++ ) {  /*  */
		mBOC.mCBW.mCBW_DataLen = SectCount << CH56xvSectorSizeB;
		mBOC.mCBW.mCBW_Flag = 0x80;
		mBOC.mCBW.mCBW_CB_Len = 10;
		mBOC.mCBW.mCBW_CB_Buf[ 0 ] = SPC_CMD_READ10;
		mBOC.mCBW.mCBW_CB_Buf[ 1 ] = 0x00;
		mBOC.mCBW.mCBW_CB_Buf[ 2 ] = (UINT8)( StartLba >> 24 );
		mBOC.mCBW.mCBW_CB_Buf[ 3 ] = (UINT8)( StartLba >> 16 );
		mBOC.mCBW.mCBW_CB_Buf[ 4 ] = (UINT8)( StartLba >> 8 );
		mBOC.mCBW.mCBW_CB_Buf[ 5 ] = (UINT8)( StartLba );
		mBOC.mCBW.mCBW_CB_Buf[ 6 ] = 0x00;
		mBOC.mCBW.mCBW_CB_Buf[ 7 ] = 0x00;
		mBOC.mCBW.mCBW_CB_Buf[ 8 ] = SectCount;
		mBOC.mCBW.mCBW_CB_Buf[ 9 ] = 0x00;
		CH56xIntStatus = MS_ScsiCmd_Process( DataBuf );  /* ִлBulkOnlyЭ */
		if ( CH56xIntStatus == ERR_SUCCESS ) {
			return( CH56xIntStatus );
		}
		CH56xIntStatus = CH56xAnalyzeError( retry );
		if ( CH56xIntStatus != ERR_SUCCESS ) {
			return( CH56xIntStatus );
		}
	}
	return( CH56xIntStatus = ERR_USB_DISK_ERR );  /* ̲ */
}

#ifdef EN_DISK_WRITE

extern void Delay_us( int n );

UINT8	CH56xWriteSector( UINT32 StartLba, UINT32 SectCount, PUINT8 DataBuf )  /* еĶݿд */
{
	UINT8	retry;
//	if ( use_external_interface ) return( extWriteSector( StartLba, SectCount, DataBuf ) );  /* ⲿӿ */
	for( retry = 0; retry < 3; retry ++ ) {  /*  */
		mBOC.mCBW.mCBW_DataLen = SectCount << CH56xvSectorSizeB;
		mBOC.mCBW.mCBW_Flag = 0x00;
		mBOC.mCBW.mCBW_CB_Len = 10;
		mBOC.mCBW.mCBW_CB_Buf[ 0 ] = SPC_CMD_WRITE10;
		mBOC.mCBW.mCBW_CB_Buf[ 1 ] = 0x00;
		mBOC.mCBW.mCBW_CB_Buf[ 2 ] = (UINT8)( StartLba >> 24 );
		mBOC.mCBW.mCBW_CB_Buf[ 3 ] = (UINT8)( StartLba >> 16 );
		mBOC.mCBW.mCBW_CB_Buf[ 4 ] = (UINT8)( StartLba >> 8 );
		mBOC.mCBW.mCBW_CB_Buf[ 5 ] = (UINT8)( StartLba );
		mBOC.mCBW.mCBW_CB_Buf[ 6 ] = 0x00;
		mBOC.mCBW.mCBW_CB_Buf[ 7 ] = 0x00;
		mBOC.mCBW.mCBW_CB_Buf[ 8 ] = SectCount;
		mBOC.mCBW.mCBW_CB_Buf[ 9 ] = 0x00;
		CH56xIntStatus = MS_ScsiCmd_Process( DataBuf );  /* ִлBulkOnlyЭ */
		if ( CH56xIntStatus == ERR_SUCCESS ) {
			Delay_us( 200 );  /* дʱ */
			return( CH56xIntStatus );
		}
		CH56xIntStatus = CH56xAnalyzeError( retry );
		if ( CH56xIntStatus != ERR_SUCCESS ) {
			return( CH56xIntStatus );
		}
	}
	return( CH56xIntStatus = ERR_USB_DISK_ERR );  /* ̲ */
}

#endif
#endif  // NO_DEFAULT_ACCESS_SECTOR

#ifndef NO_DEFAULT_FILE_ENUMER			/* ӦóжNO_DEFAULT_FILE_ENUMERԽֹĬϵļöٻص,Ȼбдĳ */
void xFileNameEnumer( void )			/* ļöٻصӳ */
{
/* ָöCH56xvFileSizeΪ0xFFFFFFFFFileOpenôÿһļFileOpenñص
   صxFileNameEnumerغFileOpenݼCH56xvFileSizeöֱļĿ¼ǣ
   ڵFileOpen֮ǰһȫֱΪ0FileOpenص󣬱CH56xvFdtOffsetõṹFAT_DIR_INFO
   ṹеDIR_AttrԼDIR_NameжǷΪļĿ¼¼Ϣȫֱ
   FileOpenغжϷֵERR_MISS_FILEERR_FOUND_NAMEΪɹȫֱΪЧļ
   ڱصxFileNameEnumerнCH56xvFileSizeΪ1ô֪ͨFileOpenǰǻص */
#if 0
	UINT8			i;
	UINT16			FileCount;
	P_FAT_DIR_INFO	pFileDir;
	PUINT8			NameBuf;
	pFileDir = (P_FAT_DIR_INFO)( pDISK_BASE_BUF + CH56xvFdtOffset );  /* ǰFDTʼַ */
	FileCount = (UINT16)( 0xFFFFFFFF - CH56xvFileSize );  /* ǰļö,CH56xvFileSizeֵ0xFFFFFFFF,ҵļݼ */
	if ( FileCount < sizeof( FILE_DATA_BUF ) / 12 ) {  /* 黺Ƿ㹻,ٶÿļռ12ֽڴ */
		NameBuf = & FILE_DATA_BUF[ FileCount * 12 ];  /* 㱣浱ǰļĻַ */
		for ( i = 0; i < 11; i ++ ) NameBuf[ i ] = pFileDir -> DIR_Name[ i ];  /* ļ,Ϊ11ַ,δո */
		if ( pFileDir -> DIR_Attr & ATTR_DIRECTORY ) NameBuf[ i ] = 1;  /* жĿ¼ */
		NameBuf[ i ] = 0;  /* ļ */
	}
#endif
}
#endif  // NO_DEFAULT_FILE_ENUMER

UINT8	CH56xLibInit( void )  /* ʼCH56xCH56xоƬ,ɹ0 */
{
	if ( CH56xGetVer( ) < CH56x_LIB_VER ) return( 0xFF );  /* ȡǰӳİ汾,汾̫򷵻ش */
#if DISK_BASE_BUF_LEN > 0
	pDISK_BASE_BUF = & DISK_BASE_BUF[0];  /* ָⲿRAMĴݻ */
	pDISK_FAT_BUF = & DISK_BASE_BUF[0];  /* ָⲿRAMĴFATݻ,pDISK_BASE_BUFԽԼRAM */
/* ϣļȡٶ,ôеCH56xLibInit֮,pDISK_FAT_BUFָһpDISK_BASE_BUFͬСĻ */
#endif
	CH56xDiskStatus = DISK_UNKNOWN;  /* δ֪״̬ */
	return( ERR_SUCCESS );
}
